'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: c_103_.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:07:06 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : peter.junge@sun.com
'*
'* short description : Detail test of Calc features in menu View
'*
'************************************************************************
'*
' #1 C_103_ ' Initial routine
' #1 tViewColRowHeader
' #1 tViewPageBreakView
'*
'\***********************************************************************


sub C_103_

Printlog Chr(13) + "--------- C_103_ ---------"

   Call tViewColRowHeader
   call tViewPageBreakView

End sub

'
'-----------------------------------------------------------
'
testcase tViewColRowHeader
'/// This test checks if the settings which are made in one calcdocument ///
'/// in the Options are validity for the other called calcdocuments. ///
'/// Further it is checked if the document specific settings are only ///
'/// validity for this appropriate document. ///


   dim file$
   file$ = Convertpath(gOfficePath & "user/work/tAnsichtSpaltenZeilenKoepfe" & Ext)
   'disable the columns- and row header
'/// Call the Tools|Optionsdialog and uncheck Column and row headers
   Call  hNewDocument
   sleep(2)
   ToolsOptions
   hToolsOptions ( "SPREADSHEET", "VIEW" )
   if ZeilenUndSpaltenkoepfe.IsChecked then
      ZeilenUndSpaltenkoepfe.uncheck
      Kontext "ExtrasOptionenDLG"
       ExtrasOptionenDLG.Ok
   else
      Kontext "ExtrasOptionenDLG"
       ExtrasOptionenDLG.cancel
   end if
   'check if the modyfied settings are imported
'/// open a new calc document and check, if the row- and column header are disabled

   ToolsOptions
   hToolsOptions ( "SPREADSHEET", "VIEW" )
   if ZeilenUndSpaltenkoepfe.IsChecked then
      Warnlog "General settings doesn't detected"
   else
        Printlog "General settings are OK"
   end if
   Kontext "ExtrasOptionenDLG"
   ExtrasOptionenDLG.cancel

   sleep 3
'/// Save, close and reopen the document.
   Call hSpeichernUnterMitFilterKill file$, FileFormat
   sleep(2)
   Call hCloseDocument
   sleep(2)
'/// switch on column and row header in the option dialog and check this settings in a documnet
   Call  hNewDocument
   ToolsOptions
   hToolsOptions ( "SPREADSHEET", "VIEW" )
   ZeilenUndSpaltenkoepfe.Check
   Kontext "ExtrasOptionenDLG"
   ExtrasOptionenDLG.Ok
   call hCloseDocument
   sleep 2
   Call hDateiOeffnen file$
   sleep 2
   ToolsOptions
   hToolsOptions ( "SPREADSHEET", "VIEW" )
   if ZeilenUndSpaltenkoepfe.IsChecked then
      Warnlog "The document-specific adjustment is ignored"
    else
        Printlog "The document-specific adjustment is OK"
   end if
   Kontext "ExtrasOptionenDLG"
   ExtrasOptionenDLG.cancel
   sleep 50
   call hCloseDocument
'/// Close the document, switch off column- and row header and check it again
   sleep 5
   Call  hNewDocument
   ToolsOptions
   hToolsOptions ( "SPREADSHEET", "VIEW" )
   ZeilenUndSpaltenkoepfe.UnCheck
   Kontext "ExtrasOptionenDLG"
   ExtrasOptionenDLG.Ok
   call hCloseDocument
   sleep 3
   Call hDateiOeffnen file$
   sleep 2
   ViewColumnAndRowHeaders

   ToolsOptions
   hToolsOptions ( "SPREADSHEET", "VIEW" )
   if ZeilenUndSpaltenkoepfe.IsChecked then
      Printlog "The document-specific adjustment is OK"
    else
       Warnlog "The document-specific adjustment is ignored"
   end if
   Kontext "ExtrasOptionenDLG"
   ExtrasOptionenDLG.cancel
   'sleep 3
   Call hCloseDocument
   sleep 3
   Call  hNewDocument
   'sleep 3
'/// At least, switch on again the column- and row headers
   ToolsOptions
   hToolsOptions ( "SPREADSHEET", "VIEW" )
   if ZeilenUndSpaltenkoepfe.IsChecked then
      Warnlog "General settings are ignored"
    else
        Printlog "General settings are OK"
   end if
   ZeilenUndSpaltenkoepfe.Check
   Kontext "ExtrasOptionenDLG"
   ExtrasOptionenDLG.Ok

   Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tViewPageBreakView
'/// This test checks if the PageBreakView works with and without ///
'/// the option MaxNoOfPages ///

   dim max_check as boolean
   dim iPreviousScaleIndex as Integer
   max_check = false

   call hNewDocument
'/// Open a new calc document and call the menuitem 'FormatPageCalc'.
'/// Then select the tabpage 'Sheets' and check 'fit number of pages'
   FormatPageCalc
   Kontext
   sleep (2)
   active.setpage TabTabelleCalc
   Kontext
     Printlog "Check for '...Margin ... out of print range' message."
     if Active.Exists(2) then
      if Active.GetRT = 304 then
        Printlog Active.GetText
        Active.Yes
        sleep(2)
      end if
     end if
   sleep (2)
   Kontext "TabTabelleCalc"
   iPreviousScaleIndex = ScalingMode.GetSelIndex
   if iPreviousScaleIndex <> 1 then
      warnlog "Scaling mode has unexpected initial value"
   endif
   ScalingMode.Select (3)
   TabTabelleCalc.Ok
'/// Then call the menuitem 'ViewPageBreakPreview', open the 'FormatPageCalc' dialog,
'/// go to tabpage 'sheet' and check, if the checkbox 'fit number of pages' is checked
   ViewPageBreakPreview
   FormatPageCalc
   Kontext
   sleep (2)
   active.setpage TabTabelleCalc
   Kontext
     Printlog "Check for '...Margin ... out of print range' message."
     if Active.Exists(2) then
      if Active.GetRT = 304 then
        Printlog Active.GetText
        Active.Yes
        sleep(2)
      end if
     end if
   sleep (2)
   Kontext "TabTabelleCalc"
   if ScalingMode.GetSelIndex = 3 then
      max_check = true
   else
      Warnlog "The settings on the tabpage table are not imported"
   end if
   TabTabelleCalc.Ok
'/// Switch off the scale number off pages and check the setting
   Skalierungaufheben
   FormatPageCalc
   Kontext
   sleep (2)
   active.setpage TabTabelleCalc
   Kontext
     Printlog "Check for '...Margin ... out of print range' message."
     if Active.Exists(2) then
      if Active.GetRT = 304 then
        Printlog Active.GetText
        Active.Yes
        sleep(2)
      end if
     end if
   sleep (2)
   Kontext "TabTabelleCalc"
   if ScalingMode.GetSelIndex <> iPreviousScaleIndex then
      Warnlog "Switch off the scaling doesn't work"
   else
      Printlog "OK, Page break preview was switched on"
   end if
   TabTabelleCalc.Cancel
   ViewPageBreakPreview

   call hCloseDocument

endcase

