'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: un_redo8.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:07:26 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : peter.junge@Sun.COM
'*
'* short description	:	Complete Test for the undo/redo function which test
'*
'************************************************************************
'*
' #1 un_redo8     ' Initial routine
' #1 tSubtotals   ' Apply subtotals - Undo/Redo - Check correct results
'*
'\***********************************************************************

sub un_redo8

Printlog Chr(13) + "--------- Subtotals ---------"

        call tSubtotals

end sub

'**************************************************************************************************

testcase tSubtotals


	dim group_current, group_int, i as integer
	group_int = 3
	dim file as string
	file = convertpath(gtesttoolpath & "calc/special/input/umsatztabelle.sxc")

	for i = 1 to 3

		printlog "* TabGroup" & i
'/// Open the document (gtesttoolpath & "calc/special/input/umsatztabelle.sxc"), goto cell 'A1'
'/// and
		call hDateiOeffnen file
      Kontext "DocumentCalc"
      DocumentCalc.TypeKeys "<Mod1 Home>"
'/// Call menuitem 'DataSubtotals' goto the first tabpage and select nr 2 from listbox 'Group by'
'/// for the next two turnarounds do the same in the second and the third tabpage
      call Subtotal(i, true)
      group_current = GruppierenNach.GetSelIndex
      printlog "group_current: " & group_current
      GruppierenNach.Select group_int
      Kontext
      if i = 1 then
      	TabGruppe1.OK
      elseif i = 2 then
      	TabGruppe2.OK
      else
      	TabGruppe3.OK
      end if

'/// check if the modify has been taken over
      Kontext "DocumentCalc"
      DocumentCalc.TypeKeys "<Mod1 Home>"
      call Subtotal(i)
      if GruppierenNach.GetSelIndex = group_int then
      	printlog "OK, the modify of the grouping list has been taken over"
      else
      	warnlog "The modify of the grouping list hasn_t been taken over"
      end if
      Kontext
      if i = 1 then
      	TabGruppe1.Cancel
      elseif i = 2 then
      	TabGruppe2.Cancel
      else
      	TabGruppe3.Cancel
      end if

'/// check if the undo-function works
      EditUndo
      Kontext "DocumentCalc"
      DocumentCalc.TypeKeys "<Mod1 Home>"
      call Subtotal(i)
      if GruppierenNach.GetSelIndex = group_current then
      	printlog "OK, the modify of the grouping list has been reset to current"
      else
      	warnlog "The modify of the grouping list hasn't been reset to current"
      end if
      Kontext
      if i = 1 then
      	TabGruppe1.Cancel
      elseif i = 2 then
      	TabGruppe2.Cancel
      else
      	TabGruppe3.Cancel
      end if

'/// check if the redo-function works
      EditRedo
      Kontext "DocumentCalc"
      DocumentCalc.TypeKeys "<Mod1 Home>"
      call Subtotal(i)
      if GruppierenNach.GetSelIndex = group_int then
      	printlog "OK, redo works"
      else
      	warnlog "The redo-function doesn't work"
      end if
      Kontext
      if i = 1 then
      	TabGruppe1.Cancel
      elseif i = 2 then
      	TabGruppe2.Cancel
      else
      	TabGruppe3.Cancel
      end if
      EditUndo

      call hCloseDocument

      '_________________________________________________________________________________________________
		'check now the checkboxes in the area "Teilergebnisse"

      call hDateiOeffnen file
      Kontext "DocumentCalc"
      DocumentCalc.TypeKeys "<Mod1 Home>"
      call Subtotal(i, true)
      GruppierenNach.Select 2
      'if i <> 3 then Teilergebnisse.TypeKeys "<Down><Return>"
      Teilergebnisse.TypeKeys "<Down><Return>"
      Kontext
      if i = 1 then
      	TabGruppe1.OK
      elseif i = 2 then
      	TabGruppe2.OK
      else
      	TabGruppe3.OK
      end if

      ' check if the modify has been taken over
      Kontext "DocumentCalc"
      call cgotocell("B5")
      call FormatCell
      try
         if StyleWest.GetSelIndex = 4 and Underlined() = 2 then
            printlog "OK, the Subtotal for date has been inserted"
         else
            warnlog "The Subtotal for date hasn't been inserted"
         end if
      catch
         if Style.GetSelIndex = 4 and Underlined() = 2 then
      	    printlog "OK, the Subtotal for date has been inserted"
         else
            warnlog "The Subtotal for date hasn't been inserted"
         end if
      endcatch
      Kontext
      TabFont.Cancel

      ' check if the undo-function works
      EditUndo
      'if i >= 2 then EditUndo
      call cgotocell ("B5")
      call FormatCell
      try
         if StyleWest.GetSelIndex = 1 and Underlined() = 1 then
            printlog "OK, the Subtotal for date has been reset to current"
         else
            warnlog "The subtotal1 for date hasn't been reset to current"
         end if
      catch
         if Style.GetSelIndex = 1 and Underlined() = 1 then
            printlog "OK, the Subtotal for date has been reset to current"
         else
            warnlog "The subtotal1 for date hasn't been reset to current"
         end if
      endcatch
      Kontext
      TabFont.Cancel

      ' check if the redo-function works
      EditRedo
      call cgotocell ("B5")
      call FormatCell
      try
	 if StyleWest.GetSelIndex = 4 and Underlined() = 2 then
            printlog "OK, redo works"
         else
            warnlog "The redo-function doesn't work"
         end if
      catch
         if Style.GetSelIndex = 4 and Underlined() = 2 then
            printlog "OK, redo works"
	 else
            warnlog "The redo-function doesn't work"
         end if
      endcatch
      Kontext
      TabFont.Cancel
      EditUndo
      call hCloseDocument
        '_________________________________________________________________________________________________

		call hDateiOeffnen file
      Kontext "DocumentCalc"
      DocumentCalc.TypeKeys "<Mod1 Home>"
      call Subtotal(i, true)
      GruppierenNach.Select 4
      Teilergebnisse.TypeKeys "<Down><Down><Return>"
      Berechnungsvorschrift.Select 3
      Kontext
      if i = 1 then
      	TabGruppe1.OK
      elseif i = 2 then
      	TabGruppe2.OK
      else
      	TabGruppe3.OK
      end if

      ' check if the modify has been taken over
      Kontext "DocumentCalc"
      call cgotocell("C3")
      call FormatCell
      try
      	 if StyleWest.GetSelIndex = 4 and Underlined() = 2 then
      	    printlog "OK, the Subtotal for south has been inserted"
      	 else
      	    warnlog "The subtotal1 for south hasn't been inserted"
      	 end if
      catch
         if Style.GetSelIndex = 4 and Underlined() = 2 then
            printlog "OK, the Subtotal for south has been inserted"
      	 else
      	    warnlog "The subtotal1 for south hasn't been inserted"
      	 end if
      endcatch
      Kontext
      TabFont.Cancel

      ' check if the undo-function works
      EditUndo
      call cgotocell ("C3")
      call FormatCell
      try
         if StyleWest.GetSelIndex = 1 and Underlined() = 1 then
            printlog "OK, the Subtotal for south has been reset to current"
         else
            warnlog "The Subtotal for south hasn't been reset to current"
         end if
      catch
         if Style.GetSelIndex = 1 and Underlined() = 1 then
            printlog "OK, the Subtotal for south has been reset to current"
         else
            warnlog "The Subtotal for south hasn't been reset to current"
         end if
      endcatch
      Kontext
      TabFont.Cancel

      ' check if the redo-function works
      EditRedo
      call cgotocell ("C3")
      call FormatCell
      try
         if StyleWest.GetSelIndex = 4 and Underlined() = 2 then
            printlog "OK, redo works"
         else
            warnlog "The redo-function doesn't work"
         end if
      catch
         if Style.GetSelIndex = 4 and Underlined() = 2 then
            printlog "OK, redo works"
         else
            warnlog "The redo-function doesn't work"
         end if
      endcatch
      Kontext
      TabFont.Cancel
      EditUndo

      call hCloseDocument

	next i
        '_________________________________________________________________________________________________
'/// Check now the TabPage Options in the DataSubtotals dialog

	call hDateiOeffnen file
	printlog "* TabPage Options"
	dim fl_default, fl_set as boolean
	Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
'/// Toggle 'Page break betwenn groups'
   if NeueSeiteBeiGruppenwechsel.IsChecked then
   	NeueSeiteBeiGruppenwechsel.UnCheck
   	fl_set = false
   else
   	NeueSeiteBeiGruppenwechsel.Check
   	fl_set = true
   end if
   fl_default = fl_set
   Kontext
   TabTeilergebnisseOptionen.OK

'/// check if the modify has been taken over
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if NeueSeiteBeiGruppenwechsel.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, the checkbox PageBreakBetweenGroups has been toggelt"
   else
   	warnlog "The checkbox PageBreakBetweenGroups hasn't been toggelt"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the undo-function works
   EditUndo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if NeueSeiteBeiGruppenwechsel.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set <> fl_default then
   	printlog "OK, the checkbox PageBreakBetweenGroups has been reset to current"
   else
   	warnlog "The checkbox PageBreakBetweenGroups hasn't been reset to current"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the redo-function works
   EditRedo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if NeueSeiteBeiGruppenwechsel.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, redo works"
   else
   	warnlog "The redo-function doesn't work"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel
   EditUndo
   '_________________________________________________________________________________________________

	Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
'/// Call menuitem 'DataSubtotals', goto tabpage 'Options' and toggle 'Case sensitive'
   call Subtotal_Options
   if GrossKleinschreibungBeachten.IsChecked then
   	GrossKleinschreibungBeachten.UnCheck
   	fl_set = false
   else
   	GrossKleinschreibungBeachten.Check
   	fl_set = true
   end if
   fl_default = fl_set
   Kontext
   TabTeilergebnisseOptionen.OK

'/// check if the modify has been taken over
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if GrossKleinschreibungBeachten.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, the checkbox CaseSensitive has been toggelt"
   else
   	warnlog "The checkbox CaseSensitive hasn't been toggelt"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the undo-function works
   EditUndo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if GrossKleinschreibungBeachten.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set <> fl_default then
   	printlog "OK, the checkbox CaseSensitive has been reset to current"
   else
   	warnlog "The checkbox CaseSensitive hasn't been reset to current"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the redo-function works
   EditRedo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if GrossKleinschreibungBeachten.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, redo works"
   else
   	warnlog "The redo-function doesn't work"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel
   EditUndo
   '_________________________________________________________________________________________________

'/// Call menuitem 'DataSubtotals', goto tabpage 'Options' and toggle 'Pre sort area'
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BereichVorherNachGruppenSortieren.IsChecked then
   	BereichVorherNachGruppenSortieren.UnCheck
   	fl_set = false
   else
   	BereichVorherNachGruppenSortieren.Check
   	fl_set = true
   end if
   fl_default = fl_set
   Kontext
   TabTeilergebnisseOptionen.OK

'/// check if the modify has been taken over
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BereichVorherNachGruppenSortieren.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, the checkbox SortGroups has been toggelt"
   else
   	warnlog "The checkbox SortGroups hasn't been toggelt"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the undo-function works
   EditUndo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BereichVorherNachGruppenSortieren.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set <> fl_default then
   	printlog "OK, the checkbox SortGroups has been reset to current"
   else
   	warnlog "The checkbox SortGroups hasn't been reset to current"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the redo-function works
   EditRedo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BereichVorherNachGruppenSortieren.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, redo works"
   else
   	warnlog "The redo-function doesn't work"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel
   EditUndo
   '_________________________________________________________________________________________________

'/// Call menuitem 'DataSubtotals', goto tabpage 'Options' and toggle 'Include formats'
	Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if FormateEinschliessen.IsChecked then
   	FormateEinschliessen.UnCheck
   	fl_set = false
   else
   	FormateEinschliessen.Check
   	fl_set = true
   end if
   fl_default = fl_set
   Kontext
   TabTeilergebnisseOptionen.OK

'/// check if the modify has been taken over
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if FormateEinschliessen.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, the checkbox Format has been toggelt"
   else
   	warnlog "The checkbox Format hasn't been toggelt"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the undo-function works
   EditUndo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if FormateEinschliessen.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set <> fl_default then
   	printlog "OK, the checkbox Format has been reset to current"
   else
   	warnlog "The checkbox Format hasn't been reset to current"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the redo-function works
   EditRedo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if FormateEinschliessen.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, redo works"
   else
   	warnlog "The redo-function doesn't work"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel
   EditUndo
   '_________________________________________________________________________________________________

'/// Call menuitem 'DataSubtotals', goto tabpage 'Options' and toggle 'Custom sort order'
	Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BenutzerdefinierteSortierreihenfolge.IsChecked then
   	BenutzerdefinierteSortierreihenfolge.UnCheck
   	fl_set = false
   else
   	BenutzerdefinierteSortierreihenfolge.Check
   	fl_set = true
   end if
   fl_default = fl_set
   Kontext
   TabTeilergebnisseOptionen.OK

'/// check if the modify has been taken over
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BenutzerdefinierteSortierreihenfolge.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, the checkbox UserDefinedSort has been toggelt"
   else
   	warnlog "The checkbox UserDefinedSort hasn't been toggelt"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the undo-function works
   EditUndo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BenutzerdefinierteSortierreihenfolge.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set <> fl_default then
   	printlog "OK, the checkbox UserDefinedSort has been reset to current"
   else
   	warnlog "The checkbox UserDefinedSort hasn't been reset to current"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the redo-function works
   EditRedo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BenutzerdefinierteSortierreihenfolge.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, redo works"
   else
   	warnlog "The redo-function doesn't work"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel
   EditUndo
   '_________________________________________________________________________________________________
   ' check the same with another selected entry in the listbox for UserDefinedSort

   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BenutzerdefinierteSortierreihenfolge.IsChecked then
   	BenutzerdefinierteSortierreihenfolge.UnCheck
   	fl_set = false
   else
   	BenutzerdefinierteSortierreihenfolge.Check
   	fl_set = true
   end if
   fl_default = fl_set
   Kontext
   TabTeilergebnisseOptionen.OK

   ' select another entry in the listbox
    Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   SortierreihenfolgeAnzeige.Select 3
   Kontext
   TabTeilergebnisseOptionen.OK

   ' check if the modify has been taken over
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BenutzerdefinierteSortierreihenfolge.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default and SortierreihenfolgeAnzeige.GetSelIndex = 3 then
   	printlog "OK, the listbox has the third entry"
   else
   	warnlog "The listbox hasn't the third entry"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

   ' check if the undo-function works
   EditUndo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BenutzerdefinierteSortierreihenfolge.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default and SortierreihenfolgeAnzeige.GetSelIndex = 1 then
   	printlog "OK, the listbox has been reset to current"
   else
   	warnlog "The listbox hasn't been reset to current"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

   ' check if the redo-function works
   EditRedo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if BenutzerdefinierteSortierreihenfolge.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default and SortierreihenfolgeAnzeige.GetSelIndex = 3 then
   	printlog "OK, redo works"
   else
   	warnlog "The redo-function doesn't work"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel
   EditUndo
   '_________________________________________________________________________________________________

'/// Call menuitem 'DataSubtotoals', goto tabpage 'Options' and toggle 'Ascending'
	Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if Aufsteigend.IsChecked then
   	Absteigend.Check
   	fl_set = false
   else
   	Aufsteigend.Check
   	fl_set = true
   end if
   fl_default = fl_set
   Kontext
   TabTeilergebnisseOptionen.OK

'/// check if the modify has been taken over
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if Aufsteigend.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, the radiobutton IncrementSort has been set"
   else
   	warnlog "The radiobutton IncrementSort hasn't been set"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the undo-function works
   EditUndo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if Aufsteigend.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set <> fl_default then
   	printlog "OK, the radiobutton IncrementSort has been reset to current"
   else
   	warnlog "The radiobutton IncrementSort hasn't been reset to current"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the redo-function works
   EditRedo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if Aufsteigend.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, redo works"
   else
   	warnlog "The redo-function doesn't work"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel
   EditUndo
   '_________________________________________________________________________________________________

'/// Call menuitem 'DataSubtotals', goto tabpage 'Options' and toggle 'Descending'
	Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if Absteigend.IsChecked then
   	Aufsteigend.Check
   	fl_set = false
   else
   	Absteigend.Check
   	fl_set = true
   end if
   fl_default = fl_set
   Kontext
   TabTeilergebnisseOptionen.OK

'/// check if the modify has been taken over
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if Absteigend.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, the radiobutton DecrementSort has been set"
   else
   	warnlog "The radiobutton DecrementSort hasn't been set"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the undo-function works
   EditUndo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if Absteigend.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set <> fl_default then
   	printlog "OK, the radiobutton DecrementSort has been reset to current"
   else
   	warnlog "The radiobutton DecrementSort hasn't been reset to current"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel

'/// check if the redo-function works
   EditRedo
   Kontext "DocumentCalc"
	DocumentCalc.TypeKeys "<Mod1 Home>"
   call Subtotal_Options
   if Absteigend.IsChecked then
   	fl_set = true
   else
   	fl_set = false
   end if
   if fl_set = fl_default then
   	printlog "OK, redo works"
   else
   	warnlog "The redo-function doesn't work"
   end if
   Kontext
   TabTeilergebnisseOptionen.Cancel
   EditUndo
   '_________________________________________________________________________________________________

   call hCloseDocument


endcase

'**************************************************************************************************
sub Subtotal(i as integer, optional stp as boolean)

	DataSubtotals
   Kontext
	if stp = true then
		active.setpage TabGruppe1
      Kontext "TabGruppe1"
      GruppierenNach.Select 2
      if i >= 2 then
      	Kontext
       	active.setpage TabGruppe2
        	kontext "TabGruppe2"
        	GruppierenNach.Select 2
        	Kontext
       	active.setpage TabGruppe3
        	Kontext "TabGruppe3"
        	GruppierenNach.Select 2
		end if
     	Kontext
	end if
   select case i
   case 1 : active.setpage TabGruppe1
       	Kontext "Tabgruppe1"
       	if stp = true then
       		TabGruppe1.OK
       		DataSubtotals
       		Kontext
       		active.setpage TabGruppe1
       		Kontext "Tabgruppe1"
       	end if
   case 2 : active.setpage TabGruppe2
       	Kontext "TabGruppe2"
       	if stp = true then
       		TabGruppe2.OK
       		DataSubtotals
       		Kontext
       		active.setpage TabGruppe2
       		Kontext "Tabgruppe2"
       	end if
   case 3 : active.setpage TabGruppe3
       	Kontext "TabGruppe3"
       	if stp = true then
       		TabGruppe3.OK
       		DataSubtotals
       		Kontext
       		active.setpage TabGruppe3
       		Kontext "Tabgruppe3"
       	end if
   end select

end sub

sub Subtotal_Options()

	DataSubtotals
   Kontext
   active.setpage TabTeilergebnisseOptionen
   Kontext "TabTeilergebnisseOptionen"

end sub

sub FormatCell()

	FormatCells
    Kontext
    active.setpage TabFont
    Kontext "TabFont"

end sub

function Underlined() as integer

	Kontext
	active.setpage TabFontEffects
	Kontext "TabFontEffects"
	Underlined = Underline.GetSelIndex
	Kontext
	active.setPage TabFont
	Kontext "TabFont"

end function



