'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: c_004b.inc,v $
'*
'*  $Revision: 1.23 $
'*
'*  last change: $Author: pj $ $Date: 2005/11/08 14:13:03 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : peter.junge@sun.com
'*
'* short description : Check the toolbar resources for menuitem Insert - Part 2
'*
'*************************************************************************************************
'*
' #1 C_004b ' Initial routine
' #1 tInsertObject            
' #1 tInsertGraphicSpecialCharacters
' #1 tInsertCellsRowsColumns
' #1 tToolbox
' #1 tThemenauswahl
'*
'\************************************************************************************************


global sflag as boolean

sub C_004b

printLog Chr(13) + "---------  c_004b  ( Toolbordtest for objects )   ----------"

   call tInsertObject            
   call tInsertGraphicSpecialCharacters
   call tInsertCellsRowsColumns
   call tToolbox
   call tThemenauswahl

end sub
'
'-----------------------------------------------------------
'
testcase tInsertObject


   call hNewDocument
   printlog "* Insert diagram *"
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Mod1 Home>"
   DocumentCalc.TypeKeys "A<tab>B<return>6<left>5<return>10<tab>12<return>"

   Kontext "StandardBar"
   CreateChart.Click
   call gMouseMove (20,20,60,60)
   try
      Kontext "AutoFormatDiagrammBeginn"
       Weiter.Click
       sleep (2)
      Kontext "AutoFormatDiagramm2"
       Fertigstellen.Click
   catch
      warnlog "Something similar to #i35390# seems to disturb proceeding the chart autoformat dialog -> Check this out!"
      goto endsub
   endcatch

   sleep (2)
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<ESCAPE>"
   DocumentCalc.MouseDown 50,50
   DocumentCalc.MouseUp 50,50
   try
      FormatTextCalc
      sleep (2)
      Kontext
      Active.SetPage TabText
      sleep (2)
      Kontext "TabText"
      TabText.OK
      sleep (2)
      printlog "OK, Chart was insert!"
   catch
      if gtPlatform = "lin" then
         warnlog "#i38648# A zero size chart was created if OOo is using the GTK plugin!"
         qaErrorLog "To work around set environment variable, e.g. 'export SAL_USE_VCLPLUGIN=gen'"
      else
         warnlog "Chart wasn't insert!"
      endif
   endcatch
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<ESCAPE>"
'   Kontext "InsertObjectbar"
'   InsertObjectbar.Close
   call hCloseDocument
'-------------------------------
   printlog "* Insert Formel *"

   call hNewDocument

   dim xrange as integer
   xrange = 2
    sflag = false
    DocumentCalc.TypeKeys "<Mod1 Home>"
    WL_TB_SC_OBJEKT_Formel

    Kontext "CommandsMath"
    try
      Commands.TypeKeys "e=mc^2"
      Kontext "DocumentCalc"
      call gMouseClick (5,5)
      while xrange < 7 and sflag = false
         call fselect (xrange)
         xrange = xrange + 1
      wend
      Kontext "DocumentCalc"
      call gMouseClick (20,20)
    catch
      warnlog "Input of math formula seems to cause a problem!"
    endcatch
    Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<ESCAPE>"
    call hCloseDocument
'-------------------------------
   call hNewDocument
   Dim nid as integer
   dim frameContent as STRING
       frameContent = convertPath ( gTesttoolPath & "calc/update/input/c_004b/tInsertObjectFrame.odt" )
   DocumentCalc.TypeKeys "<Mod1 Home>"
   printlog "* Insert Frame *"
   WL_TB_SC_OBJEKT_Frame

   Kontext "TabEigenschaften"
   FrameName.SetText "ThisFrame"
   Inhalt.SetText frameContent
   TabEigenschaften.OK

   Kontext "DocumentCalc"
   call gMouseClick (50,50)

   EditPlugIn
   call gMouseClick (5,5)
   try 
       FormatPositionAndSize
   catch
       warnlog "#i43800# - Editing floating frames fails"
       goto skipTheRest
   endcatch
   Kontext
   Active.SetPage TabPositionAndSize
   Kontext "TabPositionAndSize"
   Kontext
   TabPositionAndSize.Cancel
skipTheRest:
   call gMouseClick (60,60)
   call hCloseDocument
'-------------------------------
   call hNewDocument
   Dim lng As integer
   Dim obj_nr as integer

   If gPlatgroup = "unx" then
      lng = 5
   else
      lng = 6
   end if
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Mod1 Home>"
   printlog "* Insert OLE-Object *"

   WL_TB_SC_OBJEKT_Objekt

   Kontext "OLEObjektEinfuegen"
   obj_nr = Objekttyp.GetItemCount
   if obj_nr <> lng then
      warnlog "Number of objects isn't correct!"
   else
      printlog "OK, Number of objects is right!"
   end if
   OLEObjektEinfuegen.Cancel
'-------------------------------
   printlog "* Insert plugin *"

   WL_TB_SC_OBJEKT_Plugin

   Kontext "PlugInEinfuegen"
   call Dialogtest (PlugInEinfuegen)
   PlugInEinfuegen.Cancel
'-------------------------------
   printlog "* Insert applet *"

   WL_TB_SC_OBJEKT_Applet

   Kontext "AppletEinfuegen"
   call Dialogtest (AppletEinfuegen)
   AppletEinfuegen.Cancel
   call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tInsertGraphicSpecialCharacters

   Dim nid as integer
   Dim file$
   file$ = convertpath(gTesttoolpath & "global\input\graf_inp\baer.tif")
   call hNewDocument
   printlog "* Insert graphic *"
    Kontext "Insertbar"
    if Not Insertbar.Exists then
       Call hToolbarSelect("Insert", true)
    endif
   Insertbar.Move 20,20
   sleep(2)
   Grafik.Click
   Kontext "GrafikEinfuegenDlg"
   UebergeordneterOrdner.Click
   Standard.Click
   Preview.Uncheck
   Preview.Check
   Dateiname.Settext file$
   Oeffnen.Click
   Kontext "DocumentCalc"
   call gMouseClick (5,5)
   DocumentCalc.OpenContextMenu
      nid = MenuGetItemID (4)
      MenuSelect nid
      Kontext
                Active.SetPage TabPositionAndSize
                Kontext "TabPositionAndSize"
      Kontext
                TabPositionAndSize.OK
        Kontext "Insertbar"
        Insertbar.Close
   Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<delete>"
'-------------------------------
   printlog "* Insert special characters *"
   printlog "*** If the test crashes by calling 'InsertSpecialCharacterCalc', it is bug:98975"
    WL_TB_SC_Einfuegen_Sonderzeichen

    Kontext "Sonderzeichen"
    Schriftliste.TypeKeys "<right>"
    Sonderzeichen.OK
    Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<return>"

    call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tInsertCellsRowsColumns

    call hNeuesDokument(True)
    printlog "* Insert cell downwards *"
    DocumentCalc.TypeKeys "<right><down>1<return><up>"

    WL_TB_SC_Zellen_ZellenNachUnten

    if cZellwert("B3") = "1" then
      printlog "OK, one cell was insert!"
    else
      warnlog "There wasn't any cell insert!"
    end if
    printlog "cZellwert " & cZellwert("B3")
    call cGotocell("B2")
    '-------------------------------
    printlog "* Insert cell to the right *"
    WL_TB_SC_Zellen_ZellenNachRechts
    if cZellwert("B3") ="1" then
      printlog "OK, cellcontent of 'B3' is still the same!"
   else
      warnlog "Possibly there was a column insert!"
   end if
'-------------------------------
   printlog "* Go one line downwards and insert cell to the right *"
   WL_TB_SC_Zellen_ZellenNachRechts
   if cZellwert("B3") = "" and cZellwert("C3") = "1" then
      printlog "OK, insert cell to the right work!"
   else
      warnlog "Insert cell to the rigth doesn't work!"
   end if
'-------------------------------
   printlog "* Insert line *"
   WL_TB_SC_Zellen_GanzeZeile
   if cZellwert("C3") = "" and cZellwert("C4") = "1" then
      printlog "OK, insert line work!"
   else
      warnlog "Insert line doesn't work!"
   end if
'-------------------------------
   printlog "* Insert column *"
   WL_TB_SC_Zellen_GanzeSpalte
   if cZellwert("C4") = "" and cZellwert("D4") = "1" then
      printlog "OK, insert column work!"
   else
      warnlog "Insert column doesn't work!"
   end if

   call hCloseDocument

endcase

'
'-----------------------------------------------------------
'
testcase tToolbox
   if gOOo then
       qaErrorLog "Feature not supported in OpenOffice.org"
       goto endsub
   endif
  
   printlog "* Autoformat *"
   call hNewDocument
   call atinserttable
   DocumentCalc.TypeKeys "<Mod1 Shift right right down>"
   WL_CALC_Autoformat
   Kontext "AutoFormatCalc"
   call Dialogtest (AutoFormatCalc)
    AutoFormatCalc.Cancel

    call hCloseDocument

    printlog "* Orthography *"

    if left(iSprache,1) <> 8 then
        call hNewDocument

        DocumentCalc.TypeKeys "Feehler<return>"
        WL_CALC_Rechtschreibung
        Kontext
        if Active.Exists then
            Active.Yes
        end if
        Kontext "Rechtschreibung"
        call Dialogtest (Rechtschreibung)
        Rechtschreibung.Cancel
   else
      printlog "This option isn't possible for asian languages at this time"
   end if
'-------------------------------

   if iSprache < 80 then
       printlog "* Automatic orthography *"
        call hNewDocument
        Kontext "Toolbar"
        printlog "AutoSpellcheck.getState: " & AutoSpellcheck.GetState ( 2 )
         if  AutoSpellcheck.GetState ( 2 ) = 0 then
            AutoSpellcheck.click
         else
            qaErrorLog "Finding AutoSpellcheck already pressed is unexpected but not necessarily a Bug!"
         end if
        Kontext "DocumentCalc"
        DocumentCalc.TypeKeys "Teeest<RETURN><UP>"
        DocumentCalc.TypeKeys "<F2>"
        DocumentCalc.TypeKeys "<MOD1 SHIFT LEFT>"
        DocumentCalc.MouseMove (2, 2)
        DocumentCalc.MouseUp (2, 2)
        DocumentCalc.OpenContextMenu
         dim nID as integer
         nID = MenuGetItemID (1)
         printlog "ContextMenuItemText: " & MenuGetItemText(nID)
         if left(MenuGetItemText(nID), 2) = "te" then
            printlog "It seems that the autocorrection works"
         else
            if left(MenuGetItemText(nID), 2) = "Te" then
               printlog "It seems that the autocorrection works"
            else
               warnlog "It seems that the autocorrection doesn't work"
            end if
         end if
       call hMenuClose
       Kontext "Toolbar"
       AutoSpellcheck.click
       Kontext "DocumentCalc"

        call hCloseDocument

    end if
'-------------------------------
   printlog "* Search and replace *"
   call hNewDocument
   WL_CALC_SuchenUndErsetzen
   Kontext "FindAndReplace"
   call Dialogtest ( FindAndReplace )
   FindAndReplace.Cancel
'-------------------------------
   printlog "* Automatic filter *"
   'if gtSYSName <> "Linux" then
      WL_CALC_AutoFilter
      Kontext
      if Active.Exists then
         printlog "OK, autofilter is available!"
         Active.OK
      else
         warnlog "autofilter doesn't work!"
      end if
   'else
   '  warnlog "Because of bug: 93455 no actives are detected on LINUX, so this feature couldn't be tested"
   'end if
'-------------------------------
   printlog "* Sort ascending *"
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Mod1 Home>5<return>9<return>7<return>"
   WL_CALC_SortierenAuf
   if cZellwert ("A1") = "5" and cZellwert ("A3") = "9" then
      printlog "OK, sort ascending work!"
   else
      warnlog "Sort ascending doesn't work!"
   end if
'-------------------------------
   printlog "* Sort sloping *"
   WL_CALC_SortierenAb
   if cZellwert ("A1") = "9" and cZellwert ("A3") = "5" then
      printlog "OK, sort sloping work!"
   else
      warnlog "Sort sloping doesn't work!"
   end if
'-------------------------------
   printlog "* Insert and remove grouping *"
   WL_CALC_Gruppierung
   Kontext "GruppierungAktivieren"
   call Dialogtest ( GruppierungAktivieren )
   GruppierungAktivieren.OK
   try
      WL_CALC_GruppierungAufheben
      printlog "OK,remove grouping is visible!"
   catch
      warnlog "remove grouping isn't visible!"
   endcatch
   printlog "Push button 'remove grouping' again!"
   try
      WL_CALC_GruppierungAufheben
      warnlog "remove grouping is still visible!"
   catch
      printlog "OK, remove grouping isn't visible!"
   endcatch
   call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tThemenauswahl
'warnlog "#i40880# - Testcase disabled"
'goto endsub

   call hNewDocument
   printlog "* Check topic selection *"
   Kontext "Toolbar"
   if Not Toolbar.Exists then
      Call hToolbarSelect("Tools", true)
      sleep(2)
   endif   
   try
      Themen.Click
      sleep(10)
      Kontext "TB_SC_Themenauswahl"
      if TB_SC_Themenauswahl.IsVisible then
         printlog "OK, Themenauswahl is visible!"
      else
         warnlog "Themenauswahl isn't visible!"
      end if
      Kontext "TB_SC_Themenauswahl"
      Schliessen.click
      sleep(2)
   catch
      Kontext "Active"
      if Active.exists then
         printlog Active.getText
         Active.OK
      end if
      Kontext "TB_SC_Themenauswahl"
      Schliessen.click
   endcatch
   Kontext "TB_SC_Themenauswahl"
      if TB_SC_Themenauswahl.exists then
         warnlog "Themenauswahl is visible!"
      else
         printlog "OK, Themenauswahl isn't visible!"
      end if
   call hCloseDocument

endcase

