'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: c_005_.inc,v $
'*
'*  $Revision: 1.8 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:07:38 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : peter.junge@Sun.COM
'*
'* short description : Check the resources for menu item Format
'*
'*************************************************************************
'*
' #1 C_005_ ' Initial routine
' #1 tFormatStandard
' #1 tFormatCharacter
' #1 tFormatCell
' #1 tFormatRowModifyRowHeight
' #1 tFormatRowOptimalRowHeight
' #1 tFormatRowHideShow
' #1 tFormatColumnModifyColumnWidth
' #1 tFormatColumnOptimalColumnWidth
' #1 tFormatColumnHideShow
' #1 tFormatSheetRenameSheet
' #1 tFormatTableHideShow
' #1 tFormatPageFormat
' #1 tFormatPrinterRange
' #1 tFormatPrintRangeEditPrintRange
' #1 tFormatTemplatecatalogCells
' #1 tFormatTemplatecatalogPage
' #1 tFormatTemplatecatalogNew
' #1 tFormatStylesAndFormatting
' #1 tFormatAutoformat
' #1 tFormatConditionalFormatting
'*
'\************************************************************************

sub C_005_

Printlog Chr(13) + "--------- C_005_ ---------"

    Call tFormatStandard
    Call tFormatCharacter
    Call tFormatCell
    Call tFormatRowModifyRowHeight
    Call tFormatRowOptimalRowHeight
    Call tFormatRowHideShow
    Call tFormatColumnModifyColumnWidth
    Call tFormatColumnOptimalColumnWidth
    Call tFormatColumnHideShow
    Call tFormatSheetRenameSheet
    Call tFormatTableHideShow
    Call tFormatPageFormat
    Call tFormatPrinterRange
    Call tFormatPrintRangeEditPrintRange
    Call tFormatTemplatecatalogCells
    Call tFormatTemplatecatalogPage
    Call tFormatTemplatecatalogNew
    Call tFormatStylesAndFormatting
    Call tFormatAutoformat
    Call tFormatConditionalFormatting

End sub
'
'-----------------------------------------------------------
'
testcase tFormatStandard

    Call  hNewDocument
    call ZellenMarkieren (13,13)
    FormatDefaultCalc
    Kontext "DocumentCalc"
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFormatCharacter
'TODO: Test and add warnlogs
    call hNewDocument
    Kontext "DocumentCalc"
      DocumentCalc.typekeys "a"
      FormatCharacter
      Kontext
        active.SetPage TabFont
        kontext "TabFont"
          Call DialogTest ( TabFont )
      Kontext
        active.SetPage TabFontEffects
        kontext "TabFontEffects"
          Call DialogTest ( TabFontEffects )
      Kontext
        active.SetPage TabFontPosition
        Kontext "TabFontPosition"
          Call DialogTest ( TabFontPosition )
          TabFontPosition.Close
   
    Call hCloseDocument
endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatCell

    hNewDocument
    FormatCells

    Kontext
    active.SetPage TabZahlen
    Kontext "TabZahlen"
    Call DialogTest ( TabZahlen )

    Kontext
    active.SetPage TabFont
    Kontext "TabFont"
    Call DialogTest ( TabFont )

    Kontext
    active.SetPage TabFontEffects
    Kontext "TabFontEffects"
    Call DialogTest ( TabFontEffects )

        try
        Kontext
        active.SetPage TabAsianTypography
        Kontext "TabAsianTypography"
        Call DialogTest ( TabAsianTypography )
    catch
        printlog "Asian Language support isn't switched on"
    endcatch

    Kontext
    active.SetPage TabAusrichtung
    Kontext "TabAusrichtung"
    Call DialogTest ( TabAusrichtung )

    Kontext
    active.SetPage TabUmrandung
    Kontext "TabUmrandung"
    Call DialogTest ( TabUmrandung )

    Kontext
    active.SetPage TabHintergrund
    Kontext "TabHintergrund"
    Call DialogTest ( TabHintergrund )

    Kontext
    active.SetPage TabZellschutz
    Kontext "TabZellschutz"
    Call DialogTest ( TabZellschutz )

    TabZellschutz.Close
    hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatRowModifyRowHeight

    Call  hNewDocument
    FormatRowHeightCalc
    Kontext "ZeilenHoehe"
    DialogTest ( ZeilenHoehe )
    ZeilenHoehe.Close
    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatRowOptimalRowHeight

    Call  hNewDocument
    FormatRowOptimalHeightCalc
    Kontext "ZeileOptimaleHoehe"
    DialogTest ( ZeileOptimaleHoehe )
    ZeileOptimaleHoehe.Cancel
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFormatRowHideShow

    Call  hNewDocument
    FormatRowHide
    EditSelectAll
    FormatRowShow
    Kontext "DocumentCalc"
    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatColumnModifyColumnWidth

    Call  hNewDocument
    FormatColumnWidthCalc
    Kontext "SpaltenBreiteCalc"
    DialogTest ( SpaltenBreiteCalc )
    SpaltenBreiteCalc.Cancel
    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatColumnOptimalColumnWidth

    Call  hNewDocument
    FormatColumnOptimalWidthCalc
    Kontext "SpalteOptimaleBreite"
    DialogTest ( SpalteOptimaleBreite )
    SpalteOptimaleBreite.Cancel
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFormatColumnHideShow

    Call  hNewDocument
    FormatColumnHide
    EditSelectAll
    FormatColumnShow
    Kontext "DocumentCalc"
    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatSheetRenameSheet

    Call  hNewDocument
    FormatSheetRename
    Kontext "TabelleUmbenennen"
    DialogTest ( TabelleUmbenennen )
    TabelleUmbenennen.Cancel
    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatMergeCells

    Call  hNewDocument
    Kontext "DocumentCalc"
    fCalcSelectRange("A1:B1")
    FormatMergeCells
    fCalcSelectCell("B1")
    if fCalcGetSelectionString() = "A1" then
       printlog "Merging cells succeeded!"
    else
       warnlog "Merging cells seem to fail -> Check this out!"
    endif
    FormatMergeCells
    fCalcSelectCell("B1")
    if fCalcGetSelectionString() = "B1" then
       printlog "Removing cell merge succeeded!"
    else
       warnlog "Removing cell merge seem to fail -> Check this out!"
    endif
    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatTableHideShow

    Call  hNewDocument
    InsertSheetCalc
    Kontext "TabelleEinfuegenCalc"
    TabelleEinfuegenCalc.OK

    FormatSheetHide
    FormatSheetShow

    Kontext "TabelleEinblenden"
    DialogTest ( TabelleEinblenden )
    TabelleEinblenden.Cancel
    Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<Return>"
    Kontext "DocumentCalc"
    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatPageFormat

    call hNewDocument
    FormatPageCalc

    Kontext
    active.SetPage TabVerwalten
    Kontext "TabVerwalten"
    Printlog "TabOrganize"
    Call DialogTest ( TabVerwalten )

    Kontext
    active.SetPage TabSeite
    Kontext "TabSeite"
    Printlog "TabPage"
    Call DialogTest ( TabSeite )
    
    Kontext
    active.SetPage TabUmrandung
    Kontext
     Printlog "Check for '...Margin ... out of print range' message."
     if Active.Exists(2) then
      if Active.GetRT = 304 then
        Printlog Active.GetText
        Active.Yes
      end if
     end if
    Kontext "TabUmrandung"
    Printlog "TabBorder"
    Call DialogTest ( TabUmrandung )

    Kontext
    active.SetPage TabHintergrund
    Kontext "TabHintergrund"
    Printlog "TabBackground"
    'Call DialogTest2 ( TabHintergrund, 1 )
    'als.select 2
    'Call DialogTest2 ( TabHintergrund, 2 )
    Call Dialogtest (TabHintergrund)

    Kontext
    active.SetPage TabKopfzeile
    Kontext "TabKopfzeile"
    Printlog "TabHeader"
    Call DialogTest ( TabKopfzeile )
    Zusaetze.Click

    Kontext
    Active.SetPage TabUmrandung
    Kontext "TabUmrandung"
    printlog "TabHeaderBorder"
    Call DialogTest (TabUmrandung)

    Kontext
    active.SetPage TabHintergrund
    Kontext "TabHintergrund"
    printlog "TabHeaderBackground"
    call DialogTest2 (TabHintergrund,1)
    als.select 2
    call DialogTest2 (TabHintergrund,2)
    TabHintergrund.Cancel

    Kontext "TabKopfzeile"
    InhaltLinksRechtsGleich.Check
    Bearbeiten.Click

    Kontext "TabKopfzeileCalc"
    Call DialogTest ( TabKopfzeileCalc )
    TextAttribute.Click

    Kontext
    Active.setpage TabFont
    Kontext "TabFont"
    printlog "TabHeaderFont"
    Call DialogTest (TabFont)

    Kontext
    Active.setpage TabFontEffects
    Kontext "TabFontEffects"
    printlog "TabHeaderFontEffects"
    Call DialogTest (TabFontEffects)

    Kontext
    Active.setpage TabFontPosition
    Kontext "TabFontPosition"
    printlog "TabHeaderFontPosition"
    Call DialogTest (TabFontPosition)
    TabFontPosition.Cancel

    try

        Kontext "TabKopfzeileCalc"
            TabKopfzeileCalc.Cancel
        Kontext "TabKopfzeile"
                kontext
        active.SetPage TabFusszeile
        Kontext "TabFusszeile"
        DialogTest (TabFusszeile)
        printlog "TabFooter"

        Zusaetze.Click

        Kontext
        Active.SetPage TabUmrandung
        Kontext "TabUmrandung"
        printlog "TabFooterBorder"
        Call DialogTest (TabUmrandung)

        Kontext
        active.SetPage TabHintergrund
        Kontext "TabHintergrund"
        printlog "TabFooterBackground"
        call DialogTest2 (TabHintergrund,1)
        als.select 2
        call DialogTest2 (tabHintergrund,2)
        TabHintergrund.Cancel

        Kontext "TabFusszeile"
        InhaltLinksRechtsGleich.Check
        Bearbeiten.Click

        Kontext "TabFusszeileCalc"
        Call DialogTest ( TabFusszeileCalc )
        TextAttribute.Click
        Kontext
        Active.setpage TabFont
        Kontext "TabFont"
        printlog "TabFooterFont"
        Call DialogTest (TabFont)
        Kontext
        Active.setpage TabFontEffects
        Kontext "TabFontEffects"
        printlog "TabFooterFontEffects"
        Call DialogTest (TabFontEffects)
        Kontext
        Active.setpage TabFontPosition
        Kontext "TabFontPosition"
        printlog "TabFooterFontPosition"
        Call DialogTest (TabFontPosition)
        TabFontPosition.Cancel
        Kontext "TabFusszeileCalc"
        TabFusszeileCalc.Cancel

        Kontext "TabFusszeile"
    catch
        warnlog "For not comprehensible reasons, the switch to the tabpage 'TabFusszeile' isn't available"
        warnlog "in the language " & iSprache
    endcatch

    Kontext
    active.SetPage TabTabelleCalc
    printlog "TabSheetCalc"
    DialogTest (TabTabelleCalc)

    TabTabelleCalc.Close
        call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFormatPrinterRange

    Call  hNewDocument
    FormatPrintRangesDefine
    FormatPrintRangesRemove
    Kontext "DocumentCalc"
    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatPrintRangeEditPrintRange

    Call  hNewDocument
    FormatPrintRangesEdit
    Kontext "DruckbereicheBearbeiten"
    DialogTest ( DruckbereicheBearbeiten )
    DruckbereicheBearbeiten.Cancel
    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatTemplatecatalogCells
 Dim i as integer
  Call  hNewDocument
    FormatStylesCatalog
    Kontext "Vorlagenkatalog"
     printlog "Style catalog"
     printlog "select 1 (cell styles)"
     Vorlagen.Select(1)
     DialogTest ( Vorlagenkatalog )
  for i = 1 to 2
    if i = 1 then
      printlog "- New"
      Kontext "Vorlagenkatalog"
       Neu.Click
     else
      printlog "- Modify"
      Kontext "Vorlagenkatalog"
       Aendern.Click
    end if
    Kontext
     active.SetPage TabVerwalten
     printlog " +- Tab Organizer"
    Kontext "TabVerwalten"
     Call DialogTest ( TabVerwalten )
    Kontext
     active.SetPage TabZahlen
     printlog " +- Tab Numbers"
     Kontext "TabZahlen"
     Call DialogTest ( TabZahlen )
    Kontext
     active.SetPage TabFont
     printlog " +- Tab Font"
    Kontext "TabFont"
     Call DialogTest ( TabFont )
    Kontext
     active.SetPage TabAusrichtung
     printlog " +- Tab Alignment"
    Kontext "TabAusrichtung"
     Call DialogTest ( TabAusrichtung )
    Kontext
     active.SetPage TabUmrandung
     printlog " +- Tab Borders"
    Kontext "TabUmrandung"
     Call DialogTest ( TabUmrandung )
    Kontext
     active.SetPage TabHintergrund
     printlog " +- Tab Background"
    Kontext "TabHintergrund"
     Call DialogTest ( TabHintergrund )
    Kontext
     active.SetPage TabZellschutz
     printlog " +- Tab Cell Protection"
    Kontext "TabZellschutz"
     Call DialogTest ( TabZellschutz )
     TabZellschutz.Cancel
  next i
    Kontext "Vorlagenkatalog"
     Vorlagenkatalog.Close
   Call hCloseDocument
endcase
'
'-------------------------------------------------------------------------
'
testcase tFormatTemplatecatalogPage
 Dim i as integer
  Call  hNewDocument
    FormatStylesCatalog
    Kontext "Vorlagenkatalog"
     printlog "Style catalog"
     printlog "select 2 (page styles)"
     Vorlagen.Select(2)
  for i = 1 to 2
    if i = 1 then
      printlog "- New"
      Kontext "Vorlagenkatalog"
       Neu.Click
     else
      printlog "- Modify"
      Kontext "Vorlagenkatalog"
       Aendern.Click
    end if
    Kontext
     active.SetPage TabSeite
     printlog " +- Tab Organizer"
    Kontext "TabSeite"
     Call DialogTest ( TabSeite )
    Kontext
     active.SetPage TabVerwalten
    Kontext
     ' if there is no printer in the system you will get an error
     if Active.Exists(2) then
      if Active.GetRT = 304 then
        Printlog Active.GetText
        Active.No
        sleep(2)
      end if
     end if
     printlog " +- Tab Page"
    Kontext "TabVerwalten"
     Call DialogTest ( TabVerwalten )
    Kontext
     active.SetPage TabUmrandung
    Kontext
     ' if there is no printer in the system you will get an error
     if Active.Exists then
      if Active.GetRT = 304 then
        warnlog Active.GetText
        Active.No
      end if
     end if
     printlog " +- Tab Borders"
    Kontext "TabUmrandung"
     Call DialogTest ( TabUmrandung )
    Kontext
     active.SetPage TabHintergrund
     printlog " +- Tab Background"
    Kontext "TabHintergrund"
     Call DialogTest2 ( TabHintergrund, 1 )
     als.select(2)
     Call DialogTest2 ( TabHintergrund, 2 )
    Kontext
     active.SetPage TabKopfzeile
     printlog " +- Tab Header"
    Kontext "TabKopfzeile"
     Call DialogTest ( TabKopfzeile )
     Zusaetze.Click
    Kontext
     Active.SetPage TabUmrandung
     printlog " +- Tab Borders"
    Kontext "TabUmrandung"
     Call DialogTest (TabUmrandung)
    Kontext
     active.SetPage TabHintergrund
     printlog " +- Tab background"
    Kontext "tabHintergrund"
     call DialogTest2 (TabHintergrund,1)
     als.select 2
     call DialogTest2 (tabHintergrund,2)
     TabHintergrund.Cancel
    Kontext "TabKopfzeile"
     printlog "  +- Edit"
     Bearbeiten.Click
    Kontext "TabKopfzeileCalc"
     Call DialogTest ( TabKopfzeileCalc )
     printlog "  +- Click 'text attributes'"
     TextAttribute.Click
     Kontext
       Active.setpage TabFont
       printlog "   +- Tab Font"
      Kontext "TabFont"
       Call DialogTest (TabFont)
      Kontext
       Active.setpage TabFontEffects
       printlog "   +- Tab Fonteffects"
      Kontext "TabFontEffects"
       Call DialogTest (TabFontEffects)
      Kontext
       Active.setpage TabFontPosition
       printlog "   +- Tab Fontposition"
      Kontext "TabFontPosition"
       Call DialogTest (TabFontPosition)
       TabFontPosition.Cancel
      Kontext "TabKopfzeileCalc"
       TabKopfzeileCalc.Cancel
       try
        Kontext "TabKopfzeile"
        Kontext
         active.SetPage TabFusszeile
         printlog "   +- Tab Footnote"
        Kontext "TabFusszeile"
         Call DialogTest (TabFusszeile)
         Zusaetze.Click
        Kontext
         Active.SetPage TabUmrandung
         printlog "   +- Tab Borders"
        Kontext "TabUmrandung"
         Call DialogTest (TabUmrandung)
        Kontext
         active.SetPage TabHintergrund
         printlog "   +- Tab Background"
        Kontext "tabHintergrund"
         call DialogTest2 (TabHintergrund,1)
         als.select(2)
         call DialogTest2 (tabHintergrund,2)
         TabHintergrund.Cancel
        Kontext "TabFusszeile"
         Bearbeiten.Click
         printlog "   +- Edit"
        Kontext "TabFusszeileCalc"
         printlog "   +- Tab Footnotes"
         Call DialogTest ( TabFusszeileCalc )
         TextAttribute.Click
        Kontext
         Active.setpage TabFont
         printlog "   +- Tab Font"
        Kontext "TabFont"
         Call DialogTest (TabFont)
        Kontext
         Active.setpage TabFontEffects
         printlog "   +- Tab Fonteffects"
        Kontext "TabFontEffects"
         Call DialogTest (TabFontEffects)
        Kontext
         Active.setpage TabFontPosition
         printlog "   +- Tab Fontposition"
        Kontext "TabFontPosition"
         Call DialogTest (TabFontPosition)
         TabFontPosition.Cancel
        Kontext "TabFusszeileCalc"
         printlog "   +- Tab Footnotes"
         TabFusszeileCalc.Cancel
        Kontext "TabFusszeile"
       catch
        warnlog "For not comprehensible reasons, the switch to the tabpage 'TabFusszeile' isn't available"
        warnlog "in the language " & iSprache
       endcatch
    Kontext
     active.SetPage TabTabelleCalc
     printlog "   +- Tab FontTable"
    Kontext "TabTabelleCalc"
     DialogTest (TabTabelleCalc)
     TabTabelleCalc.Cancel
  next i
    Kontext "Vorlagenkatalog"
     Verwalten.Click
     printlog "- Organize"
    Kontext "DVVerwalten"
     DialogTest ( DVVerwalten )
     DVVerwalten.Close
    Kontext "Vorlagenkatalog"
     try
       Vorlagen.Select(1)
       Vorlagenkatalog.Close
       printlog "Dialog Template Catalog closed after TemplatesOrganize"
      catch
       printlog "Dialog Template Catalog closed with TemplatesOrganize"
     endcatch
   Call hCloseDocument
endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatTemplatecatalogNew

    Call hNewDocument
    FormatStylesCatalog
    Kontext "Vorlagenkatalog"
    DialogTest ( Vorlagenkatalog )
    Aendern.Click
    Kontext

    active.SetPage TabVerwalten
    Printlog "TabVerwalten"
    Kontext "TabVerwalten"
    Call DialogTest ( TabVerwalten )

    Kontext
    active.SetPage TabZahlen
    Printlog "TabZahlen"
    Kontext "TabZahlen"
    Call DialogTest ( TabZahlen )

    Kontext
    active.SetPage TabFont
    Printlog "TabFont"
    Kontext "TabFont"
    Call DialogTest ( TabFont )

    Kontext
    active.SetPage TabAusrichtung
    Printlog "TabAusrichtung"
    Kontext "TabAusrichtung"
    Call DialogTest ( TabAusrichtung )

    Kontext
    active.SetPage TabUmrandung
    Printlog "TabUmrandung"
    Kontext "TabUmrandung"
    Call DialogTest ( TabUmrandung )

    Kontext
    active.SetPage TabHintergrund
    Printlog "TabHintergrund"
    Kontext "TabHintergrund"
    Call DialogTest ( TabHintergrund )

    Kontext
    active.SetPage TabZellschutz
    Printlog "TabZellschutz"
    Kontext "TabZellschutz"
    Call DialogTest ( TabZellschutz )

    TabZellschutz.Cancel

    Kontext
    Vorlagenkatalog.Close
    Call hCloseDocument

endcase

'
'----------------------------------------------------------------------------
'
testcase tFormatStylesAndFormatting

    Call  hNewDocument

    FormatStylist
    Kontext "Gestalter"
    if Gestalter.notexists (2) then FormatStylist
    Kontext "Gestalter"
    Zellvorlagen.Click
    DialogTest2 (Gestalter,1)
    try
        Seitenvorlagen.Click
        DialogTest2 ( Gestalter,2 )
        AusSelektion.Click
        Kontext "VorlageErzeugen"
        DialogTest ( VorlageErzeugen )
        VorlageErzeugen.Cancel
    catch
        warnlog "No page styles available, could be bug:99070"
    endcatch
    Kontext "Gestalter"
    Gestalter.Close

    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatAutoformat
'///<u><b>Format::Autoformat ...</b></u>///
'///<ul>
    '///<li>Open new document</li>///
    Call  hNewDocument
    '///<li>Mark a range of cells</li>///
    call ZellenMarkieren (13,13)
    '///<li>Format::Autoformat ...</li>///
    FormatAutoformat
    Kontext "AutoformatCalc"
    '///<li>Click 'More' button</li>///
    '///<li>NOTE: This should enlarge the dialog</li>///
    Zusaetze.Click
    '///<li>Check AutoFormat dialog</li>///
    Call DialogTest ( AutoformatCalc )
    '///<li>Click 'Add...' button</li>///
    Einfuegen.Click
    Kontext "AutoFormatHinzufuegenCalc"
    '///<li>Check 'Add AutoFormat' dialog</li>///
    Call DialogTest ( AutoFormatHinzufuegenCalc )
    '///<li>Close 'Add AutoFormat' dialog</li>///
    AutoFormatHinzufuegenCalc.Close
    Kontext "AutoformatCalc"
    '///<li>Select random Autoformat, but NOT 'Default'</li>///
    FormatListe.Select 2
    '///<li>Click 'Rename' button</li>///
    Umbenennen.Click
    '///<li>Check 'Rename' dialog</li>///
    Kontext "Umbenennen"
    Call DialogTest ( Umbenennen )
    '///<li>Close 'Rename' dialog</li>///
    Umbenennen.Cancel
    '///<li>Close AutoFormat dialog</li>///
    Kontext "AutoformatCalc"
    AutoformatCalc.Cancel
    '///<li>Close document</li>///
    Call hCloseDocument
'///</ul>
endcase
'
'----------------------------------------------------------------------------
'
testcase tFormatConditionalFormatting

    Call  hNewDocument
    FormatConditionalFormatting
    Kontext "BedingteFormatierung"
    Call DialogTest ( BedingteFormatierung )
    BedingteFormatierung.close

    Call hCloseDocument

endcase
'
'----------------------------------------------------------------------------
'
