'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: c_008_.inc,v $
'*
'*  $Revision: 1.6 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:07:39 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : peter.junge@sun.com
'*
'* short description : Check the resources for menu item Window
'*
'*************************************************************************************************
'*
' #1 C_008_ ' Initial routine
' #1 tWindowNewWindow
' #1 tWindowCloseWindow
' #1 tWindowSplit
' #1 tWindowFreeze
'*
'\************************************************************************************************

sub C_008_

        Printlog Chr(13) + "--------- C_008_ ---------"
        Call tWindowNewWindow
        call tWindowCloseWindow
        call tWindowSplit
        call tWindowFreeze

end sub
'
'-----------------------------------------------------------
'
testcase tWindowNewWindow
'///<u><b>Window::New Window</b></u>///
'///<ul>
'///<li>Test included in 'tWindowCloseWindow'</li>///
'///</ul>
    printlog "Test included in 'tWindowCloseWindow'"

endcase
'
'-----------------------------------------------------------
'
testcase tWindowCloseWindow
'///<u><b>Window::Close Window</b></u>///
'///<ul>
    '///<li>Invoke Window::New window</li>///
    WindowNewWindow
    ' '///<li>Close toolbar 'tools' if exist</li>///
    ' Kontext "Toolbar"
    ' if Toolbar.exists(2) then
        ' Toolbar.Close
        ' qaErrorLog "Toolbar 'Tools' closed. It's unexpected but definitely no critical issue."
    ' endif
    '///<li>Invoke Window::Close Window</li>///
    WindowCloseWindow
    '///<li>Check if document count is NOT 0</li>///
    if getDocumentCount = 0 then
       warnlog "'Window::New Window' doesn't seem to because no UI was left behind! Return of #i41010#."
       qaErrorLog "Restarting the office to resume 'The first Doc!'"
       ExitRestartTheOffice
    endif
'///</ul>
endcase
'
'-----------------------------------------------------------
'
testcase tWindowSplit
'///<u><b>Window::Split</b></u>///
'///<ul>
    '///<li>Open new document</li>///
    Call  hNewDocument
    '///<li>Move away from cell 'A1'</li>///
    DocumentCalc.Typekeys "<Right><Down>"
    '///<li>Invoke Window::Split to activate splitted view</li>///
    WindowSplit
    '///<li>Invoke Window::Split to deactivate splitted view</li>///
    WindowSplit
    '///<li>Close document</li>///
    Call hCloseDocument
'///</ul>
endcase
'
'-----------------------------------------------------------
'
testcase tWindowFreeze
'///<u><b>Window::Freeze</b></u>///
'///<ul>
    '///<li>Open new document</li>///
    Call  hNewDocument
    '///<li>Move away from cell 'A1'</li>///
    DocumentCalc.Typekeys "<Right><Down>"
    '///<li>Invoke Window::Split to activate frozen view</li>///
    WindowFreeze
    '///<li>Invoke Window::Split to deactivate frozen view</li>///
    WindowFreeze
    '///<li>Close document</li>///
    Call hCloseDocument
'///</ul>
endcase

