'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: ch_102_.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:07:41 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : peter.junge@Sun.COM
'*
'* short description : Chart Level 1 test - section EDIT 1
'*
'************************************************************************
'*
' #1 CH_102_        ' Initial routine
' #0 tDummyInsertOLE ' Just load chart libraries once - timing issue on slow machines
' #0 tDummyCallBasedoc ' Just load chart libraries once - timing issue on slow machines
' #1 tEditUndoRedo  ' Undo redo test for chart
' #1 tEditClipboard ' Clipboard test for chart
'*
'\***********************************************************************

sub CH_102_

printLog Chr(13) + "---------  CH_102_    ----------"

'  call tDummyInsertOLE
'  call tDummyCallBasedoc
  call tEditUndoRedo
  call tEditClipboard

end sub
'
'-------------------------------------------------------------
'

testcase tDummyInsertOLE

   try
      call InsertOLE
      sleep (15)
      call hCloseDocument
   catch
      goto endsub
   endcatch
   
endcase

'
'-------------------------------------------------------------
'

testcase tDummyCallBasedoc

   try
      call basedocument ("CHART")
      sleep (15)
      call hCloseDocument
   catch
      goto endsub
   endcatch
   
endcase

'
'-------------------------------------------------------------
'

testcase tEditUndoRedo
'/// This test checks the undo/redo function by cutting the maintitle
'/// of an inserted chart. It is checked if the mainttilte is available
'/// after cut and undo it(maintilte should be there).
'/// Then it is checked if the maintitle is not
'/// avauilable after redo it (maintitle must not be there).

   call InsertOLE
   sleep (2)

   Kontext "DocumentChart"
     DocumentChart.MouseDown 50,2
     DocumentChart.MouseUp 50,2
     EditCut
     try
       FormatTitleMainTitle
       warnlog "Cut doesn't work"
       Kontext
         active.setpage TabUmrandungChart
         Kontext "TabUmrandungChart"
           TabUmrandungChart.cancel
     catch
     endcatch
     EditUndo
     Kontext "DocumentChart"
       DocumentChart.MouseDown 50,2
       DocumentChart.MouseUp 50,2
       try
         FormatTitleMainTitle
         Printlog "Undo works"
         Kontext
           active.setpage TabUmrandungChart
             Kontext "TabUmrandungChart"
               TabUmrandungChart.cancel
        catch
          Warnlog "Undo doesn't work"
        endcatch
        EditRedo
        Kontext "DocumentChart"
          DocumentChart.MouseDown 50,2
          DocumentChart.MouseUp 50,2
          try
            FormatTitleMainTitle
            Warnlog "Redo doesn't work"
            Kontext
              active.setpage TabUmrandungChart
              Kontext "TabUmrandungChart"
                TabUmrandungChart.cancel
        catch
          Printlog "Redo works"
        endcatch
        Kontext "DocumentCalc"
          DocumentCalc.TypeKeys "<Escape><Escape>"
          call hCloseDocument

endcase
'
'-------------------------------------------------------------
'
testcase tEditClipboard
'/// This test check if the title is still a title (it must not be), when it is
'/// cut and paste in an embedded chart.

   Dim Text$
   Call basedocument ("CHART")
   sleep (2)
   EditObjectEdit
   Kontext "DocumentChart"
     DocumentChart.MouseDown 50,9
     DocumentChart.MouseUp 50,9
     EditCut
     EditPaste
     try
       FormatTitleMainTitle
       Kontext
         active.setpage TabUmrandungChart
           Kontext "TabUmrandungChart"
             TabUmrandungChart.cancel
             warnlog "The title has been cut and paste, so the it isn't a title anymore"
     catch
       printlog "Cut and Paste is OK!"
     endcatch
   Kontext "DocumentChart"
     DocumentChart.TypeKeys "<Escape>",true
   Kontext "DocumentCalc"
     DocumentCalc.TypeKeys "<Escape>",true
   Call hCloseDocument

endcase

