'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: ch_004_.inc,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:07:51 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : peter.junge@sun.com
'*
'* short description : Chart resource test section INSERT
'*
'************************************************************************
'*
' #1 Ch_004_        ' Initial routine
' #1 tInsertTitle
' #1 tInsertLegend
' #1 tInsertDatalabel
' #1 tInsertAxes
' #1 tInsertGrids
' #1 tInsertStatistics
'*
'\************************************************************************

sub CH_004_

  printLog Chr(13) + "---------  CH_004_     ----------"

   call tInsertTitle
   call tInsertLegend
   call tInsertDatalabel
   call tInsertAxes
   call tInsertGrids
   call tInsertStatistics

end sub

'************************************************************
testcase tInsertTitle
'/// Dialog test INSERT -> TITLE
   Call basedocument
   EditObjectEdit
   InsertTitle
   Kontext "Titel"
   Call DialogTest (Titel)
   if zAchse.IsEnabled then WarnLog "Z-axis is active in the 2D-Chart"
   Titel.Cancel
   FormatChartType
   Kontext "Diagrammtyp"
   DreiD.Check
   Diagrammtyp.OK
   InsertTitle
   Kontext "Titel"
   if Not zAchse.IsEnabled then WarnLog "Z-Achse isn't active in the 3D-Chart"
   Titel.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   Call hCloseDocument

endcase
'-------------------------------------------------------------
testcase tInsertLegend
'/// Dialog test INSERT -> LEGEND
   Call basedocument
   EditObjectEdit
   InsertLegend
   Kontext "Legende"
   Call DialogTest ( Legende )
   Legende.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   Call hCloseDocument

endcase
'-------------------------------------------------------------
testcase tInsertDatalabel
'/// Dialog test INSERT -> DATA LABEL
   Call basedocument
   EditObjectEdit
   InsertDataLabels
   Kontext "Datenbeschriftung"
   WertAnzeigen.Check
   AlsProzent.Check
   AlsZahl.Check
   Call DialogTest (Datenbeschriftung)
   Datenbeschriftung.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   Call hCloseDocument

endcase
'-------------------------------------------------------------
testcase tInsertAxes
'/// Dialog test INSERT -> AXES
   Call basedocument
   EditObjectEdit
   InsertAxes
   Kontext "Achsen"
   Call DialogTest (Achsen)
   if zAchsePrim.IsEnabled then WarnLog "Z-Achse ist bei 2D-Chart aktiv"
   Achsen.Cancel
   FormatChartType
   Kontext "Diagrammtyp"
   DreiD.Check
   Diagrammtyp.OK
   InsertAxes
   Kontext "Achsen"
   Call DialogTest (Achsen)
   if Not zAchsePrim.IsEnabled then WarnLog "Z-Achse ist bei 3D-Chart nicht aktiv"
   Achsen.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   Call hCloseDocument

endcase

  '-------------------------------------------------------------
testcase tInsertGrids
'/// Dialog test INSERT -> GRIDS
   Call basedocument
   EditObjectEdit
   InsertGrids
   Kontext "Gitter"
   Call DialogTest (Gitter)
   if zAchseHaupt.IsEnabled then WarnLog "Z-AchsenHauptgitter ist bei 2D-Chart aktiv"
   'if zAchseHilfs.IsEnabled then WarnLog "Z-AchsenHilfsgitter ist bei 2D-Chart aktiv"
   'Wird als enabled gemeldet, obwohl er hȴndisch disabled erscheint."
   Gitter.Cancel
   FormatChartType
   Kontext "Diagrammtyp"
   DreiD.Check
   Diagrammtyp.OK
   InsertGrids
   Kontext "Gitter"
   Call DialogTest (Gitter)
   if Not zAchseHaupt.IsEnabled then WarnLog "Z-AchsenHauptGitter ist bei 3D-Chart nicht aktiv"
   if Not zAchseHilfs.IsEnabled then WarnLog "Z-AchsenHilfsGitter ist bei 3D-Chart nicht aktiv"
   Gitter.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   Call hCloseDocument

endcase

  '-------------------------------------------------------------
testcase tInsertStatistics
'/// Dialog test INSERT -> STATISTICS
   Call basedocument
   EditObjectEdit
   InsertStatistics
   Kontext "StatistikChart"
   Varianz.Check
   Call DialogTest (StatistikChart)
   StatistikChart.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   Call hCloseDocument

endcase

