'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: f_basic_delete_modules.inc,v $
'*
'*  $Revision: 1.6 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:07:59 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Delete modules while BASIC is running
'*
'*******************************************************************************
'**
' #1 tDeleteModulesAtRunningBasic ' Delete modules while BASIC is running
'**
'\******************************************************************************

testcase tDeleteModulesAtRunningBasic

    Dim i as Integer
    Dim iSel as Integer
    dim brc as boolean

    '///<h1>Work with macros - delete Modules while BASIC-IDE is running</h1>

    '///<ul>
    '///<li>open a new writer-doc</li>
    printlog "open a new writer-doc"
    gApplication = "Writer"

    Call hNewDocument()

    '///<li>create a new module for the new document (named TTModule)</li>
    printlog "create a new module "
    brc = hOpenBasicOrganizerFromDoc()
    brc = hCreateModuleForDoc()

    '///<li>insert a short script (1. page)</li>
    printlog "insert a short script (1. page)"

    brc = hInsertMacro( 1 )

    kontext "macrobar"
    printlog "- Click button:  Step Procedure"
    '///<li>activate "Step Procedure" on Toolbar</li>
    ProcedureStep.Click
    sleep(3)
    '///<li>check if disabled menu-items are shown and delete is not shown</li>

    kontext "basicide"
    printlog "check if disabled menu items are shown in context menu and 'delete' is not shown"
    Tabbar.OpenContextMenu

    try

        if hMenuItemGetCount = 5 then
            warnlog "Disabled entries are shown in context menu on tab bar => bugID 101972"
        end if


        if hMenuItemGetCount = 3 then
            warnlog "Delete is active in context menu for a running macro => BUG!"
        end if

    catch
        warnlog "Unable to retrieve the number of menuitems"
    endcatch

    hMenuClose
    '///<li>stop the running script</li>
    printlog "Stop the running script"

    kontext "macrobar"
    BasicStop.Click
    sleep(1)

    '///<li>close the BasicIDE and the document</li>
    printlog "close the documents"
    Call hCloseDocument()
    Call hCloseDocument()

    '///</ul> 

endcase

