'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: filedlg_folders.bas,v $
'*
'*  $Revision: 1.5 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:08:12 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
' **
' ** owner : joerg.skottke@sun.com
' **
' ** short description : check the internal file dialog (Folders/Navigation)
' **
'\******************************************************************************

sub main

   use "framework\filedlg\inc\filedlg_tools.inc"
   use "framework\filedlg\inc\filedlg1.inc"
   use "framework\filedlg\inc\filedlg5.inc"
   use "framework\filedlg\inc\filedlg6.inc"
   use "framework\tools\inc\key_tools.inc" 
   

   PrintLog Chr(13) + "Test of the FileOpen-Dialog (Folders/Navigation)"
   Call hStatusIn ( "framework", "filedlg_folders.bas", "Test the StarOffice/Suite own filedialog (folders)" )


   call tFolder1 ' create folders with different names ('new folder'-button)
   call tFolder2 ' create folders with same names ( 'new folder'-button )
   call tFolder3 ' create folders with lower and upper cases in
                 '  local-file-system ('new folder'-button)

   call tUpOneLevel1 ' click 'up one level' 10 times and check the results
   call tUpOneLevel2 ' go up one level with '..' 10 times and check the results
   call tUpOneLevel3 ' jump to the root with '/' or '\' and check the result
   call tUpOneLevel4 ' check the items under 'up one level'-button

   ' call tDefaultDirectory ' check the default-directoy-button

   Call hStatusOut

end sub

' ****************************************

sub LoadIncludeFiles

   use "global\system\inc\master.inc"
   use "global\system\inc\gvariabl.inc"
   gApplication = "WRITER"
   Call GetUseFiles

end sub

' Note:
' tDefaultDirectory (filedlg6.inc) relies on pathentries being at certain 
' positions in the pathlist in Tools/Options. These lists must be updated
' quite frequently as they are languagedependent and might even contain
' invalid entries. If time permits, the routine schould be simplified. 
