'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: filedlg_ftpaccess.bas,v $
'*
'*  $Revision: 1.4 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:08:12 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
' **
' ** owner : joerg.skottke@sun.com
' **
' ** short description : check special filenames and destinations
' **
'\******************************************************************************

sub main

   use "framework\filedlg\inc\FTPServer_tools.inc"
   use "framework\filedlg\inc\ftpserver1.inc"

   ' A FTP server that does not allow anonymous access (Solaris default)
   const CFTPSRV1    = "so-renoir/" ' server without ftp://
   const CFTPUSR1    = "autojsk"    ' loginname (valid!)
   const CFTPPWD1    = "autojsk"    ' password (valid!)
   const CFTPSERVER1 = "ftp://autojsk:autojsk@so-renoir/" 'sol. sparc

   ' A FTP server that allows anonymous access
   const CFTPSRV2    = "so-dali/" ' server without ftp://
   const CFTPUSR2    = "ftptest"    ' loginname (valid!)
   const CFTPPWD2    = "ftptest"    ' password (valid!)
   const CFTPSERVER2 = "ftp://ftptest:ftptest@so-dali/" 'sol. sparc

   call hStatusIn ( "framework", "filedlg_ftpaccess.bas", "test ftp-server access" )


   'Stopping execution for OpenOffice.org if servers have not been set.
   if ( ( gOOO = TRUE AND CFTPSRV1 = "so-renoir/" ) OR _
        ( gOOO = TRUE AND CFTPSRV2 = "so-dali/" ) ) then

      warnlog( "You have not defined a valid ftp-server" )
      printlog( "* Please edit the filedlg_ftpaccess.bas file to reflect your"
      printlog( "* testing environment. You need to specify a server, login "
      printlog( "* and a password. " )

   else

      ' check FileOpen w/wo proxies enabled in tools/options
      call tFTPServerProxies( CFTPSERVER1 )

      ' check basic ftp connection as anonymous and valid user (short test)
      call tFTPConnection( CFTPSRV2 , CFTPUSR2 , CFTPPWD2 )

      ' check the password dialog (short test)
      call tFTPPasswordDialog( CFTPSRV1 , CFTPUSR1 , CFTPPWD1 )

   endif

   call hStatusOut()

end sub

' ****************************************

sub LoadIncludeFiles

   use "global\system\inc\master.inc"
   use "global\system\inc\gvariabl.inc"
   gApplication = "WRITER"
   Call GetUseFiles

end sub
