'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: f_lvl1_tools.inc,v $
'*
'*  $Revision: 1.7 $
'*
'*  last change: $Author: tbo $ $Date: 2006/01/16 09:30:39 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* Owner : thorsten.bosbach@sun.com
'*
'* short description : Function Test for known global Issues
'*
'******************************************************************
'*
' #1 sToolsCustomizeKeyboardFunction
' #1 tToolsCustomizeKeyboardFunction
' #1 tToolsOptionsAPIConfiguration
'*
'\*****************************************************************

sub sToolsCustomizeKeyboardFunction
    dim aApplication() as string
    dim i,a,b as integer
    dim lList(1000) as string
    dim sTemp as string

    ' go through all applications:
    aApplication()=array("WRITER","MASTERDOC","HTMLDOKUMENT","CALC","IMPRESS","DRAW","MATH","INSIGHT")
    a=uBound(aApplication())
    sTemp = gApplication
    for i = 0 to a
        gApplication = aApplication(i)
        tToolsCustomizeKeyboardFunction(lList())
    next i
    gApplication = sTemp
    
    listsort(lList())
    a = ListCount(lList())
    printlog "Count1: " + a
    if (a>0) then
        b = 0
        sTemp=""
        for i=1 to a
            if (lList(i) <> sTemp) then
                printlog ""+i+": '" + lList(i) + "'"
                sTemp=lList(i)
                inc(b)
            endif
        next i
        printlog "Number of unique Errors: " + b
    endif
end sub

testcase tToolsCustomizeKeyboardFunction(lList())
    '/// idea from AS find .uno: in Keyboard Function list ///'
    dim sKeys(300,2) as string 
    dim i,a,b,c,d as integer
    dim sTemp, sTemp2 as string
    dim iBugCount(10) as integer
    dim i43969 as string ' ALL
    dim i60617 as string ' ALL

    i60617 = ".uno:ContinueNumbering"
    i43969 = ".uno:MacroOrganizer"

    '/// open application ///'
    Call hNewDocument
    sleep 2
    '/// Tools->Configure ///'
    ToolsCustomize
    sleep 3
    Kontext
    '/// switch to tabpage 'Keyboard' ///'
    Messagebox.SetPage TabTastatur         ' 2 ------------------
    Kontext "TabTastatur"
    for c = 1 to 2
        select case c
            case 1: '/// Check Checkbox 'StarOffice' ///'
                    StarOffice.Check
                    Printlog ("-------------------- Keylist for StarOpenOfficeSuite.org --------------------")
            case 2: '/// Check Checkbox '$APPLICATION' ///'
                    Application.Check
                    Printlog ("-------------------- Keylist for "+gApplication+" ------------------------")
        end select
        i = Bereich.getItemCount
        for a = 1 to i
            Bereich.select(a,true)
            sTemp = Bereich.getSelText
            for b=1 to Funktion.getItemCount
                sTemp2 = Funktion.getItemText(b)
                d = inStr(sTemp2,":")
                if (d>0) then
                    ' translators use ':'-> check if ' ' follows or CHR$ < 128
                    ' asc() returns 16 bit values in an integer -> sign is affected :-( -> use abs(asc())
                    if (((mid(sTemp2,d+1,1)<>" ")AND(abs(asc(mid(sTemp2,d+1,1)))<128)) AND (abs(asc(mid(sTemp2,d-1,1)))<128))then
                        listAppend(lList(),sTemp2)
                        if (inStr(i60617,sTemp2)>0) then
                            qaErrorLog "#i60617# ("+c+"/"+a+"/"+b+"): Provide real Name for Function: '"+sTemp+"'::'"+sTemp2+"'"
                        else
                                if (inStr(i43969,sTemp2)>0) then
                                    qaErrorLog "#i41265# ("+c+"/"+a+"/"+b+"): Provide real Name for Function: '"+sTemp+"'::'"+sTemp2+"'"
                                else
                                    warnlog "("+c+"/"+a+"/"+b+"): Provide real Name for Function: '"+sTemp+"'::'"+sTemp2+"'"
                                endif
                        endif
                        inc(iBugCount(3))
                    endif
                else
                  '  printlog "("+c+"/"+a+"/"+b+"): '"+sTemp+"'::'"+sTemp2+"'"
                endif
            next b
        next a
    next c
'    if (iBugCount(3) > 0) then WarnLog ""+iBugCount(3)+": Missing Name for funktion; is .uno:..."
    '/// cancel dialog 'Customize' ///'
    TabTastatur.cancel
    '/// close application ///'
    Call hCloseDocument
endcase

testcase tToolsOptionsAPIConfiguration
   Dim iJump as Integer
   Dim sComXML as String
   Dim sHelpTip as String
   Dim sHelpExtendedTip as String
   Dim bHelpTip as Boolean
   Dim bHelpExtendedTip as Boolean
   Dim Silent as Boolean
   Dim sTempPath as string
   Dim sTempList(10) as string
   Dim sLocalString as string

   'Used for GetXMLValueGlobal (DEPRECATED function!) to get no output in resultfile. 
   Silent = TRUE

    try
        ToolsOptions
        '///+<li>Tools / Language Settings / Languages
        call hToolsOptions ("Languagesettings", "Languages")
        '///+ Check if Asian language support is enabled and verify <i>gAsianSup</i> variable. 
        if (gAsianSup <> Aktivieren.IsChecked) then
            warnlog "gAsianSup differs from UI"
        endif
        '///+ Check if CTL (=complex text layout) is enabled amd set <i>gCTLSup</i> variable TRUE or FALSE.
        if (gCTLSup <> ComplexScriptEnabled.IsChecked) then
            warnlog "gCTLSup differs from UI"
        endif
    
        '///+<li>Check <i>gAccessibility</i> for Win32 (from Options UI)</li>
        call hToolsOptions ("STAROFFICE", "ACCESSIBILITY")
        try
            if (gPlatGroup <> "unx") then
                if (gAccessibility <> SupportAssistiveTechnologyTools.IsChecked) then
                    warnlog "gAccessibility differs from UI"
                endif
            endif
        catch
            if (NOT gAccessibility) then
                warnlog "gAccessibility differs from UI - catch"
            endif
        endcatch
    
        '///+ <li>Check the switch to the <i>system</i> dialogs to &quot;internal&quot; dialogs.
        call hToolsOptions ("StarOffice", "General")
        if StarOfficeDialogeBenutzen.Exists then
            if (NOT StarOfficeDialogeBenutzen.isChecked) then
                warnlog "StarOfficeDialogeBenutzen is not checked"
            endif
        end if

        '///+<li>Checking the <i>bubble help</i>. 
        call hToolsOptions ("StarOffice", "General")
        if (Tips.isChecked) then
            warnlog "Help Tip is checked"
        endif
            
    
        '///+<li>Checking the <i>work</i> directory in Tools / Options,
        call hToolsOptions ("StarOffice", "Paths")
        select case iSprache
            case 01   : iJump =  9      ' English (USA)
            case 03   : iJump =  0      ' Portuguese
            case 07   : iJump =  0      ' Russian
            case 30   : iJump =  0      ' Greek
            case 31   : iJump =  9      ' Netherlands
            case 33   : iJump = 12      ' French
            case 34   : iJump = 13      ' Spanish
            case 35   : iJump =  0      ' Finnish
            case 36   : iJump =  0      ' Hungaria
            case 37   : iJump =  0      ' Catalan
            case 39   : iJump =  7      ' Italian
            case 42   : iJump =  0      ' Czech
            case 43   : iJump =  0      ' Slowak
            case 44   : iJump =  0      ' English (GB)
            case 45   : iJump =  0      ' Danish
            case 46   : iJump =  11     ' Swedish
            case 47   : iJump =  0      ' Norwegian
            case 48   : iJump =  0      ' Polish
            case 49   : iJump =  1      ' German
            case 51   : iJump =  0      ' Slowak
            case 55   : iJump =  12     ' Portuguese (Brazil)
            case 66   : iJump =  14     ' Thai
            case 81   : iJump =  0      ' Japanese ' disabled, because locale dependant!
            case 82   : iJump =  0      ' Korean   ' disabled, because locale dependant!
            case 86   : iJump =  0      ' Chinese (simplified)  ' disabled, because locale dependant!
            case 88   : iJump =  0      ' Chinese (traditional) ' disabled, because locale dependant!
            case 90   : iJump =  0      ' Turkish
            case 91   : iJump =  0      ' Hindi
            case 96   : iJump =  16     ' Arab
            case 97   : iJump =  0      ' Hebrew
            case else : qaErrorlog "The work-dir can't changed to the internal office-work-dir! Please insert the language in this list!"
                        iJump =  0
        end select
    
        if iJump <> 0 then
            'DEBUG: printlog "**  master.inc::mMakeGeneralOptions::iJump(" & iSprache & ") = " & iJump
            sLocalString = Typ.getItemText(iJump,2)
            if  (sLocalString <> ConvertPath (gOfficePath + "user\work")) then
                warnlog ("Work Directory differs from API setting? : is: '" + sLocalString + "' should: '" + ConvertPath (gOfficePath + "user\work") + "'")
            endif
        else
            'TODO: figure out which Entry it could be
            for i = 1 to Typ.getItemCount
                if (Typ.getItemText(i,2) = ConvertPath (gOfficePath + "user\work")) then
                    qaErrorLog ("found WorkDirectory at position: " + i)
                    iJump = i
                endif
            next i
            if (iJump = 0) then
                warnlog ("No workdirectory candidate found.")
            endif
        end if

        '///+<li>Checking the directory for temporary files (=temp-path).
        select case iSprache
            case 01   : iJump = 12      ' English (USA)
            case 03   : iJump =  0      ' Portuguese
            case 07   : iJump =  0      ' Russian
            case 30   : iJump =  0      ' Greek
            case 31   : iJump = 14      ' Netherlands
            case 33   : iJump =  7      ' French
            case 34   : iJump =  1      ' Spanish
            case 35   : iJump =  0      ' Finnish
            case 36   : iJump =  0      ' Hungaria
            case 37   : iJump =  0      ' Catalan
            case 39   : iJump =  8      ' Italian
            case 42   : iJump =  0      ' Czech
            case 43   : iJump =  0      ' Slowak
            case 44   : iJump =  0      ' English (GB)
            case 45   : iJump =  0      ' Danish
            case 46   : iJump =  15     ' Swedish
            case 47   : iJump =  0      ' Norwegian
            case 48   : iJump =  18     ' Polish
            case 49   : iJump =  14     ' German
            case 51   : iJump =  0      ' Slowak
            case 55   : iJump =  1      ' Portuguese (Brazil)
            case 66   : iJump =  0      ' Thai
            case 81   : iJump =  0      ' Japanese ' disabled, because locale dependant!
            case 82   : iJump =  0      ' Korean   ' disabled, because locale dependant!
            case 86   : iJump =  0      ' Chinese (simplified)  ' disabled, because locale dependant!
            case 88   : iJump =  0      ' Chinese (traditional) ' disabled, because locale dependant!
            case 90   : iJump =  0      ' Turkish
            case 91   : iJump =  0      ' Hindi
            case 96   : iJump =  0      ' Arab
            case 97   : iJump =  0      ' Hebrew
            case else : qaErrorLog "The temp-dir can't changed to the internal office-temp-dir! Please insert the language in this list!"
                        iJump =  0
        end select
        if iJump <> 0 then
            'DEBUG: printlog "**  master.inc::mMakeGeneralOptions::iJump(" & iSprache & ") = " & iJump
            sLocalString = Typ.getItemText(iJump,2)
            if  (sLocalString <> ConvertPath (gOfficePath + "user\temp")) then
                warnlog ("Temp Directory differs from API setting? : is: '" + sLocalString + "' should: '" + ConvertPath (gOfficePath + "user\temp") + "'")
            endif
        else
            'TODO: figure out which Entry it could be
            for i = 1 to Typ.getItemCount
                if (Typ.getItemText(i,2) = ConvertPath (gOfficePath + "user\temp")) then
                    qaErrorLog ("found TempDirectory at position: " + i)
                    iJump = i
                endif
            next i
            if (iJump = 0) then
                warnlog ("No tempdirectory candidate found.")
            endif
        end if

        Kontext "ExtrasOptionenDlg"
        ExtrasOptionenDlg.OK
        sleep(4)
   catch
        warnlog "Error during walking through optionsdialog"
   endcatch
   '///+</ul>
endcase

