'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: t_xml_filter1.inc,v $
'*
'*  $Revision: 1.19 $
'*
'*  last change: $Author: jsi $ $Date: 2005/11/01 12:18:53 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Tools / XML Filter Settings Resource Test
'*
'************************************************************************
'*
' #1 tToolsXMLFilterSettings   'Resource test for 'Tools' / 'XML Filter Settings'
' #1 fInitialXMLSetting        'Checks the availibility of the Excel XML import filter
'*
'\***********************************************************************

testcase tToolsXMLFilterSettings
    Dim iCountOfXSLTStylesAtBeginning as integer
    Dim iCountOfXSLTStylesAfterInstallCheck as integer
    Dim iApplicationEntries as integer
    Dim ia as integer
    Dim ib as integer
    Dim ic as integer
    Dim sErrorPointerTextForResultfile as string
    Dim sFilterPackagePath as string
    Dim sDocXMLTestFile as string
    Dim sWhichFilterToUse as string
    Dim sTempReadFilterName as string
    Dim bREMOVEXSLT as boolean

    'Define the pointer where all warnlogs/QAErrorLogs will come from in this routine.
    sErrorPointerTextForResultfile = "global::tools::inc::t_xml_filter1,inc::tToolsXMLFilterSettings: "
 
    '/// Opening new document.
    printlog "- Opening new (application) document."
    call hNewDocument
    '/// Calling the menu item <i>Tools -&gt; XML Filter Settings</i>
    ToolsXMLFilterSettings
    printlog "- XML Filter Settings"
    Kontext "XMLFilterSettings"
    if XMLFilterSettings.Exists(1) then
        call Dialogtest (XMLFilterSettings)
    else
        warnlog sErrorPointerTextForResultfile & "Slot to open the 'XML Filter Settings dialog' failed. Exiting." 
        goto endsub
    end if
    'Counting the existing XSLT stylesheets to verify them after the
    'XSLT stylesheet Check. Setting bREMOVEXSLT = FALSE which only will
    'be TRUE if the count of before and after the check are different.
    bREMOVEXSLT = FALSE
    iCountOfXSLTStylesAtBeginning = FilterList.GetItemCount
    '/// Closing the XML Filter Settings-dialog.
    printlog "Closing the 'XML Filter Settings'-dialog."
    CloseBtn.Click   
    '/// Checking if there are any XSLT stylesheets available (<i>finitialXMLSetting(&quot;docbook or word or excel&quot;)</i>).
    printlog " + Checking if there are any XSLT stylesheets available."
    select case gApplication
        case "CALC"         : sWhichFilterToUse = "excel"
        case "WRITER"       : sWhichFilterToUse = "word"
        case else           : sWhichFilterToUse = "docbook"
    end select
    if finitialXMLSetting(sWhichFilterToUse) = FALSE then
        warnlog "It wasn't possible to use/install external XML filter. Test aborting!"
        goto endsub
    end if
    ToolsXMLFilterSettings
    printlog "Open XML Filter Settings dialog again."   
    Kontext "XMLFilterSettings"
    iCountOfXSLTStylesAfterInstallCheck = FilterList.GetItemCount
    if iCountOfXSLTStylesAfterInstallCheck <> iCountOfXSLTStylesAtBeginning then
        bREMOVEXSLT = TRUE
    end if
    '/// Checking disabling of buttons on this dialog.
    printlog " + Checking that Edit/Test/Delete/SaveToPackage buttons disabled when no filter is selected."
    if EditBtn.IsEnabled then
        FilterList.Typekeys "<MOD1 SPACE>"
        sleep(1)
    end if
    if EditBtn.IsEnabled then 
        warnlog sErrorPointerTextForResultfile & "Edit button: Enabled when no entry is selected!?"
    end if
    if TestXSLTs.IsEnabled then 
        warnlog sErrorPointerTextForResultfile & "TestXSLTs button: Enabled when no entry is selected!?"
    end if
    if DeleteBtn.IsEnabled then 
        warnlog sErrorPointerTextForResultfile & "Delete button: Enabled when no entry is selected!?"
    end if
    if SaveToPackage.IsEnabled then 
        warnlog sErrorPointerTextForResultfile & "SaveToPackage button: Enabled when no entry is selected!?"
    end if
    '/// Checking disabling of buttons on this dialog.
    printlog " + Checking that Edit/Test/Delete/SaveToPackage buttons enabled when one filter is selected."
    if NOT EditBtn.IsEnabled then
        FilterList.Typekeys "<SPACE>"
        sleep(1)
    end if
    if NOT EditBtn.IsEnabled then 
        warnlog sErrorPointerTextForResultfile & "Edit button: Disabled when one entry is selected!?"
    end if
    if NOT TestXSLTs.IsEnabled then 
        warnlog sErrorPointerTextForResultfile & "TestXSLTs button: Disabled when one entry is selected!?"
    end if
    if NOT DeleteBtn.IsEnabled then 
        warnlog sErrorPointerTextForResultfile & "Delete button: Disabled when one entry is selected!?"
    end if        
    if NOT SaveToPackage.IsEnabled then 
        warnlog sErrorPointerTextForResultfile & "SaveToPackage button: Disabled when one entry is selected!?"
    end if
    '/// <i>[Loop]</i>
    '///+ <ol><li>Clicking the &quot;New&quot; button</li>
    '///+ <li>Clicking the &quot;Edit&quot; button</li></ol>
    Kontext "XMLFilterSettings"
    FilterList.TypeKeys "<HOME>"
    for ic = 1 to iCountOfXSLTStylesAfterInstallCheck
        Kontext "XMLFilterSettings"        
        sleep(1)
        'read the filter names from the dialog.
        sTempReadFilterName = FilterList.GetItemText(ic)
        'lower case comparison!
        sTempReadFilterName = lcase(sTempReadFilterName)
        if InStr(sTempReadFilterName , sWhichFilterToUse) <> 0 then
            FilterList.TypeKeys "<DOWN> " , ic-1           	
            ' printlog "DEBUG: Filtername: " & FilterList.GetItemText(ic)
            sleep(1)
        end if
    next ic    
    for ia = 1 to 2
        Kontext "XMLFilterSettings"   
        select case ia
            case 1 :    printlog "+- New"
                        NewBtn.Click
            case 2 :    printlog "+- Edit"
                        EditBtn.Click
        end select
        sleep(1)
        Kontext "XMLFilter"
        if XMLFilter.Exists(2) then
            select case ia
                case 1 : printlog "  (XML Filter: New)"
                case 2 : printlog "  (XML Filter: Edit)"
            end select
            call Dialogtest (XMLFilter)
            Tabcontrol.SetPage TabXMLGeneral
            Kontext "TabXMLGeneral"
            printlog "  +- TabXMLGeneral"
            if ia = 1 then
                '/// If the &quot;New&quot;-button has been used:
                call Dialogtest (TabXMLGeneral)
                iApplicationEntries = Application.GetItemCount
                '///+ <ul><li>Checking the count of applications. Should be 8.</li></ul>
                printlog "   Checking the count of applications. Should be 8."
                if iApplicationEntries <> 8 then
                    warnlog "   +- There should be 8 applications listed in the 'Application'-listbox but there are " & iApplicationEntries & " available!"
                else
                    printlog "   +- 8 applications listed in 'Application' listbox."
                end if
            end if
            Kontext "XMLFilter"
            Tabcontrol.SetPage TabXMLTransformation
            Kontext "TabXMLTransformation"
            printlog "  +- TabXMLTransformation"
            call Dialogtest (TabXMLTransformation)
            '/// On tab page &quot;Transformation&quot; press all &quot;Browse&quot;-buttons.
            printlog "  +- On tab page 'Transformation' press all 'Browse'-buttons."
            for ib = 1 to 4
                Kontext "TabXMLTransformation"
                select case ib
                    case 1 :    printlog "    +- Browse button 'DTD'"
                                DTDBrowse.Click
                    case 2 :    printlog "    +- Browse button 'XSLT for export'"
                                XSLTForExportBrowse.Click
                    case 3 :    printlog "    +- Browse button 'XSLT for import'"
                                XSLTForImportBrowse.Click
                    case 4 :    printlog "    +- Browse button 'Template for import'"
                                BrowseTemplateForImport.Click
                end select
                sleep(2)
                Kontext "OeffnenDlg"
                if OeffnenDlg.Exists(1) then
                    '/// After every click on &quot;Browse&quot;-button an &quot;FileOpen&quot;-dialog shoud be visible. Cancel that dialog.
                    printlog "  +- After every click on 'Browse'-button an 'FileOpen'-dialog shoud be visible. Cancel that dialog."
                    call Dialogtest (OeffnenDlg)
                    OeffnenDlg.Cancel
                    sleep(3)
                else
                    warnlog sErrorPointerTextForResultfile & "File Open dialog did not appeared."
                end if
            next ib
            '/// [Loop end]
            Kontext "XMLFilter"
            printlog "  +- Closing 'XML Filter: New Filter'-dialog."
            XMLFilter.Cancel
            '/// Closing &quot;XML Filter: New Filter&quot;-dialog
        else
            warnlog "XML Filter dialog did not appeared!"
        end if
    next ia
    Kontext "XMLFilterSettings"
    '/// Clicking &quot;Test XLSTs&quot;-button.
    printlog "+- Clicking 'Test XLSTs'-button."
    TestXSLTs.Click
    sleep(1)
    'If it's an Import filter it makes no sense to test the export.
    if sWhichFilterToUse = "docbook" then
    	printlog "+- E X P O R T (Writer, Impress)"
        Kontext "TestXMLFilter"        
        if TestXMLFilter.Exists(1) then
            call Dialogtest(TestXMLFilter)
        else
            warnlog sErrorPointerTextForResultfile & "Testing of the XML filter not possible. Exiting."
            Kontext "XMLFilterSettings"
            '/// Closing the &quot;XML Filter Settings&quot;-dialog.
            printlog "+- Closing the 'XML Filter Settings'-dialog."
            'Deinstall the XSLT stylesheet if this routine has
            'added one at the beginning.
            if bREMOVEXSLT = TRUE then
                call sRemoveXSLTFilter
            end if
            Kontext "XMLFilterSettings"    
            CloseBtn.Click    
            '/// Closing the opened application document.
            printlog "- Closing the opened application document."    
            '/// ...if there is more than 1 document opened.
            if GetDocumentCount > 1 then
                call hCloseDocument
            end if
            'Here the routine stops if the test dialog is not opening.            
            goto endsub            
        end if
        ExportBrowseBtn.Click
        '/// Press first &quot;Browse&quot;-button on the &quot;Test XML Filter&quot;-dialog.
        printlog " +-Press first 'Browse'-button on the 'Test XML Filter'-dialog."
        sleep(2)
        Kontext "OeffnenDlg"
        if OeffnenDlg.Exists(1) then
            call Dialogtest (OeffnenDlg)
            OeffnenDlg.Cancel
            '/// Closing 'FileOpen'-Dialog.
            printlog "  +- Closing 'FileOpen'-Dialog."
            sleep(3)
        else
            warnlog sErrorPointerTextForResultfile & "File Open dialog did not occoured?!"
        end if
        Kontext "TestXMLFilter"
        '/// If the application is Writer (because the default XSLT stylesheets are only Writer filter).
        '///+<ul><li>Clicking on &quot;Current Document&quot;-button.</li></ul>
        if gApplication = "WRITER" then
            printlog " +- Clicking on 'Current Document'-button."
            CurrentDocument.Click
            sleep(3)
            '/// If Java is not [correctly] installed a messagebox will be shown and the test of the filter will be canceled!
            Kontext "Messagebox"
            if MessageBox.Exists(2) then
                warnlog Messagebox.GetText
                try
                    Messagebox.Cancel
                catch
                    Messagebox.OK
                endcatch
            else
                try
                    Kontext "XMLFilterOutput"
                    if XMLFilterOutput.Exists(1) then
                        '/// &quot;XML Filter Output&quot;-dialog should be visible.
                        printlog "  +- 'XML Filter Output'-dialog should be visible."
                        call Dialogtest(XMLFilterOutput)
                        '/// Clicking &quot;Validate&quot;-button.
                        printlog "   +- Clicking 'Validate'-button."
                        Validate.Click
                        sleep(2)
                        '/// Checking that the validate output control is visible inside the window.
                        printlog "  +- Checking that the validate output control is visible inside the window."
                        if NOT ValidateOutput.isVisible then
                            warnlog "   +- Validate output is not visible!"
                        end if
                        '/// Closing &quot;XML Filter Output&quot;-dialog.
                        printlog "   +- Closing 'XML Filter Output'-dialog."
                        XMLFilterOutput.Close
                        sleep(2)
                    else
                        warnlog sErrorPointerTextForResultfile & "XML Filter Ouput dialog did not occoured."
                    end if
                catch
                    warnlog "Testing of XSLTs does not work."
                endcatch
            end if
        else
            Kontext "TestXMLFilter"
            printlog " +- 'Current Document'-button should not be enabled if no !"
            if CurrentDocument.IsEnabled then
                Kontext "DocumentWriter"
                try
                    DocumentWriter.TypesKeys "A writer document exists!"
                catch
                    QAErrorLog "'Current Document'-button is enabled but a 'Writer' XML filter has been selected! If there's no Writer document (may be in the background) also opened it would be a bug!"
                endcatch
            end if
        end if
    end if
    printlog "+- I M P O R T"
    Kontext "TestXMLFilter"
    '/// Clicking &quot;Browse&quot;-button (Import).
    printlog "  +- Clicking 'Browse'-button (Import)."
    ImportBrowseBtn.Click
    sleep(2)
    Kontext "OeffnenDlg"
    if OeffnenDlg.Exists(1) then
        call Dialogtest (OeffnenDlg)
        '/// Closing &quot;FileOpen&quot;-dialog.
        printlog "   +- Closing 'FileOpen'-dialog."
        OeffnenDlg.Cancel
        sleep(3)
    else
        warnlog sErrorPointerTextForResultfile & "File Open dialog did not occoured?!"
    end if
    Kontext "TestXMLFilter"
    '/// Checking if 'Display Source'-checkbox is checked (should not be!).
    printlog "  +- Checking if 'Display Source'-checkbox is checked (should not be!)."
    if NOT DisplaySource.IsChecked then
        DisplaySource.Check
    else
        warnlog "  +- Display source should be NOT checked as default!"
    end if
    Kontext "TestXMLFilter"
    select case sWhichFilterToUse
        case "docbook"  :   '/// If DocBook XML is being tested use a DocBook XML file.
                            sDocXMLTestFile = ConvertPath(gTestToolPath & "global\input\xml_filter\docbook.xml")
        case "word"     :   '/// If Word XML is being tested use a Word XML file.
                            sDocXMLTestFile = ConvertPath(gTestToolPath & "global\input\xml_filter\word.xml")
        case "excel"    :   '/// If Excel XML is being tested use a Excel XML file.
                            sDocXMLTestFile = ConvertPath(gTestToolPath & "global\input\xml_filter\excel.xml")        
        case "xhtml"    :   '/// If XHTML is being tested that use a XHTML file.
                            sDocXMLTestFile = ConvertPath(gTestToolPath & "global\input\xml_filter\xhtml.xhtml")
        case else       :   warnlog sErrorPointerTextForResultfile & "Wrong parameter has been used! Exiting"
                            Kontext "TestXMLFilter"
                            '/// Closing the &quot;Test XML Filter&quot;-dialog.
                            printlog "  +- Closing the 'Test XML Filter'-dialog"
                            CloseBtn.Click                            
                            Kontext "XMLFilterSettings"
                            '/// Closing the &quot;XML Filter Settings&quot;-dialog.
                            printlog "+- Closing the 'XML Filter Settings'-dialog."
                            'Deinstall the XSLT stylesheet if this routine has
                            'added one at the beginning.
                            if bREMOVEXSLT = TRUE then
                                call sRemoveXSLTFilter
                            end if
                            Kontext "XMLFilterSettings"    
                            CloseBtn.Click    
                            '/// Closing the opened application document.
                            printlog "- Closing the opened application document."    
                            '/// ...if there is more than 1 document opened.
                            if GetDocumentCount > 1 then
                                Call hCloseDocument
                            end if
                            goto endsub
    end select
    '/// Clicking &quot;Browse&quot;-button (Import) again to test it with the XML file.
    printlog "  +- Clicking 'Browse'-button (Import) again to test it the XML file."
    ImportBrowseBtn.Click
    sleep(2)
    Kontext "OeffnenDlg"
    if OeffnenDlg.Exists(1) then
        call Dialogtest (OeffnenDlg)
        Dateiname.SetText sDocXMLTestFile
        sleep(3)
        Oeffnen.Click
        sleep(3)
        try
            Kontext "XMLFilterOutput"
            if XMLFilterOutput.Exists(3) then
                '/// &quot;XML Filter Output&quot;-dialog should be visible.
                printlog "   +- 'XML Filter Output'-dialog should be visible."
                call Dialogtest(XMLFilterOutput)
                '/// Clicking &quot;Validate&quot;-button.
                printlog "   +- Clicking 'Validate'-button."
                Validate.Click
                sleep(2)
                '/// Checking that the validate output control is visible inside the window.
                printlog "   +- Checking that the validate output control is visible inside the window."
                if NOT ValidateOutput.isVisible then
                    warnlog "   +- Validate output is not visible!"
                end if
                '/// Closing &quot;XML Filter Output&quot;-dialog.
                printlog "   +- Closing 'XML Filter Output'-dialog."
                Kontext "XMLFilterOutput"
                XMLFilterOutput.Close
                sleep(1)
            else
                warnlog sErrorPointerTextForResultfile & "No output window was visible! Exiting routine!"
                Kontext "TestXMLFilter"
                '/// Closing the &quot;Test XML Filter&quot;-dialog.
                printlog "  +- Closing the 'Test XML Filter'-dialog"
                CloseBtn.Click
                Kontext "XMLFilterSettings"
                '/// Closing the &quot;XML Filter Settings&quot;-dialog.
                printlog "+- Closing the 'XML Filter Settings'-dialog."
                'Deinstall the XSLT stylesheet if this routine has
                'added one at the beginning.
                if bREMOVEXSLT = TRUE then
                    call sRemoveXSLTFilter
                end if
                Kontext "XMLFilterSettings"    
                CloseBtn.Click    
                '/// Closing the opened application document.
                printlog "- Closing the opened application document."    
                '/// ...if there is more than 1 document opened.
                if GetDocumentCount > 1 then
                    call hCloseDocument
                end if
                'Here the routine stops if there is no Java installed or the output was not visible.            
                goto endsub            
            end if
        catch
            '/// If Java is not [correctly] installed a messagebox will be shown and the test of the filter will be canceled!
            Kontext "Messagebox"
            if MessageBox.Exists(2) then
                warnlog Messagebox.GetText
                try
                    Messagebox.Cancel
                catch
                    Messagebox.OK
                endcatch
                warnlog sErrorPointerTextForResultfile & "Java is not usable! Exiting routine!"
                Kontext "TestXMLFilter"
                '/// Closing the &quot;Test XML Filter&quot;-dialog.
                printlog "  +- Closing the 'Test XML Filter'-dialog"
                CloseBtn.Click
                Kontext "XMLFilterSettings"
                '/// Closing the &quot;XML Filter Settings&quot;-dialog.
                printlog "+- Closing the 'XML Filter Settings'-dialog."
                'Deinstall the XSLT stylesheet if this routine has
                'added one at the beginning.
                if bREMOVEXSLT = TRUE then
                    call sRemoveXSLTFilter
                end if
                Kontext "XMLFilterSettings"    
                CloseBtn.Click    
                '/// Closing the opened application document.
                printlog "- Closing the opened application document."    
                '/// ...if there is more than 1 document opened.
                if GetDocumentCount > 1 then
                    call hCloseDocument
                end if                            
                goto endsub            
            end if
        endcatch
    else
        warnlog sErrorPointerTextForResultfile & "File Open dialog missing! Not able to load test documents. Exiting routine!"
        Kontext "TestXMLFilter"
        '/// Closing the &quot;Test XML Filter&quot;-dialog.
        printlog "  +- Closing the 'Test XML Filter'-dialog"
        CloseBtn.Click
        Kontext "XMLFilterSettings"
        '/// Closing the &quot;XML Filter Settings&quot;-dialog.
        printlog "+- Closing the 'XML Filter Settings'-dialog."
        'Deinstall the XSLT stylesheet if this routine has
        'added one at the beginning.
        if bREMOVEXSLT = TRUE then
            call sRemoveXSLTFilter
        end if
        Kontext "XMLFilterSettings"    
        CloseBtn.Click    
        '/// Closing the opened application document.
        printlog "- Closing the opened application document."    
        '/// ...if there is more than 1 document opened.
        if GetDocumentCount > 1 then
            call hCloseDocument
        end if           
        goto endsub
    end if
    '/// Closing the tested XML document
    printlog "   +- Closing the tested XML document"
    '/// ...if there is more than 1 document opened.
    if GetDocumentCount > 1 then
        call hCloseDocument
    else
        QAErrorLog "#i27370# Normaly there should be a second document but there is none!"
    end if
    sleep(1)
    Kontext "TestXMLFilter"
    '/// Clicking on &quot;Recent File&quot;-Button.
    printlog "  +- Clicking on 'Recent File'-Button."
    RecentFile.Click
    Kontext "XMLFilterOutput"
    '/// &quot;XML Filter Output&quot;-dialog should be visible.
    printlog "   +- 'XML Filter Output'-dialog should be visible."
    Kontext "XMLFilterOutput"
    '/// Closing &quot;XML Filter Output&quot;-dialog.
    printlog "  +- Closing 'XML Filter Output'-dialog."
    XMLFilterOutput.Close
    sleep(1)
    '/// Closing the tested XML document
    printlog "   +- Closing the tested XML document"
    '/// ...if there is more than 1 document opened.
    if GetDocumentCount > 1 then
        call hCloseDocument
    else
        QAErrorLog "#i27370# Normaly there should be a second document but there is none!"
    end if
    sleep(1)
    Kontext "TestXMLFilter"
    '/// Closing the &quot;Test XML Filter&quot;-dialog.
    printlog "  +- Closing the 'Test XML Filter'-dialog"
    CloseBtn.Click
    Kontext "XMLFilterSettings"
    '/// Clicking &quot;Delete&quot;-button.
    printlog " +- Clicking 'Delete'-button"
    DeleteBtn.Click
    Kontext
    if Active.Exists(1) then
        if Active.GetRT = 304 then
            Active.No
        end if
    end if
    Kontext "XMLFilterSettings"
    '/// Clicking 'Save to Package'-button.
    printlog " +- Clicking 'Save to Package'-button."
    SaveToPackage.Click
    sleep(2)
    Kontext "SpeichernDlg"
    if SpeichernDlg.Exists(1) then
        call Dialogtest(SpeichernDlg)
        SpeichernDlg.Cancel
        '/// Closing 'File Save As'-Dialog.
        printlog "  +- Closing 'File Save As'-Dialog."
    else
        warnlog sErrorPointerTextForResultfile & "Save As dialog missing!"
    end if
    Kontext "XMLFilterSettings"
    '/// Clicking 'Open Package'-button.
    printlog " +- Clicking 'Open Package'-button."
    OpenPackage.Click
    sleep(2)
    Kontext "OeffnenDlg"
    if OeffnenDlg.Exists(1) then
        call Dialogtest(OeffnenDlg)
        OeffnenDlg.Cancel
        '/// Closing 'FileOpen'-Dialog.
        printlog "  +- Closing 'FileOpen'-Dialog."
    else
        warnlog sErrorPointerTextForResultfile & "File open dialog missing!"
    end if    
    Kontext "XMLFilterSettings"
    '/// Closing the &quot;XML Filter Settings&quot;-dialog.
    printlog "+- Closing the 'XML Filter Settings'-dialog."
    'Deinstall the XSLT stylesheet if this routine has
    'added one at the beginning.
    if bREMOVEXSLT = TRUE then
        call sRemoveXSLTFilter
    end if
    Kontext "XMLFilterSettings"    
    CloseBtn.Click    
    '/// Closing the opened application document.
    printlog "- Closing the opened application document."    
    '/// ...if there is more than 1 document opened.
    if GetDocumentCount > 1 then
        call hCloseDocument
    else
        QAErrorLog "#i27370# Normaly there should be a second document but there is none!"
    end if
endcase

'-------------------------------------------------------------------------

sub fInitialXMLSetting( sXMLFilterType as string ) as boolean
'/// This small function adds the latest and greatest XSLT stylesheet
'///+ to the office.<br>
'///+ The result is TRUE if the packages are already available or if they 
'///+ have been installed successfully in this routine.
'/// <u>Input</u>: excel, word, docbook, xhtml
'/// <u>Output</u>: TRUE or FALSE 
    Dim iCountOfDefaultXSLTStyles as integer
    Dim iSecondCountOfDefaultXSLTStyles as integer
    Dim sFilterPackagePath as string
    Dim sTempReadFilterName as string    
    Dim ia as integer

    'Setting boolean to FALSE
    fInitialXMLSetting = FALSE
    '/// Opening new document.
    printlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: Opening new " & gApplication & " document."
    call hNewDocument
    '/// Calling the menu item <i>Tools -&gt; XML Filter Settings</i>
    ToolsXMLFilterSettings
    printlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: Opening the XML Filter Settings dialog."
    Kontext "XMLFilterSettings"
    call Dialogtest (XMLFilterSettings)
    '/// Checking if there are any XSLT stylesheets available.
    printlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: Checking if there are any XSLT stylesheets available."
    iCountOfDefaultXSLTStyles = FilterList.GetItemCount   
    ' printlog "DEBUG (a): " & iCountOfDefaultXSLTStyles
    if iCountOfDefaultXSLTStyles <> 0 then
        '/// Check if the same filter already exists.
        'Using lowercased input parameter. 
        sXMLFilterType = lcase(sXMLFilterType)                
        for ia = 1 to iCountOfDefaultXSLTStyles
            Kontext "XMLFilterSettings"
            'read the filter names from the dialog.
            sTempReadFilterName = FilterList.GetItemText(ia)
            ' printlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: DEBUG: (" & ia & ") " & sTempReadFilterName
            'lower case comparison!
            sTempReadFilterName = lcase(sTempReadFilterName)
            'if a _part_ of the filtername matches the readed filter name the criteria is true!
            if InStr(sTempReadFilterName , sXMLFilterType) <> 0 then
                fInitialXMLSetting = TRUE
                Kontext "XMLFilterSettings"
                CloseBtn.Click
                Call hCloseDocument
                exit sub
            end if
        next ia
        'if no filter name maches the for...next loop will be left
        'and the same routine as used for 0 filter installed will
        'be used to install a filter package.        
    end if
    printlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: The XML filter is not available: Adding the " & sXMLFilterType & " XML filter."
    '///+ The packages will be used from &quot;qatesttool/global/input/xslt_stylesheets/*.jar&quot;
    ' printlog "DEBUG: " & sXMLFilterType
    select case sXMLFilterType
        case "excel"     : sFilterPackagePath = ConvertPath(gTestToolPath & "global\input\xslt_stylesheets\excel.jar")
        case "word"      : sFilterPackagePath = ConvertPath(gTestToolPath & "global\input\xslt_stylesheets\word.jar")
        case "docbook"   : sFilterPackagePath = ConvertPath(gTestToolPath & "global\input\xslt_stylesheets\docbook.jar")
        case "xhtml"     : sFilterPackagePath = ConvertPath(gTestToolPath & "global\input\xslt_stylesheets\xhtml.jar")                    
    end select
    OpenPackage.Click
    Kontext "OeffnenDlg"
    call Dialogtest (OeffnenDlg)
    Dateiname.SetText sFilterPackagePath
    sleep(3)
    Oeffnen.Click
    sleep(3)
    Kontext
    if Active.Exists(3) then
        if Active.GetRT = 304 then
            printlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: " & Active.GetText
            Active.OK
            Kontext "XMLFilterSettings"
            iSecondCountOfDefaultXSLTStyles = FilterList.GetItemCount
            printlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: Checking again the count of installed XSLT stylesheets."
            if iSecondCountOfDefaultXSLTStyles <> (iCountOfDefaultXSLTStyles+1) then
                warnlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: It was not possible to add " & sXMLFilterType & "-XML filter!"
                warnlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: Test aborted!"
                exit sub
            else
                printlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: XML filter has been installed!"
                fInitialXMLSetting = TRUE
            end if
        end if
    end if
    Kontext "XMLFilterSettings"
    '/// Closing the XML Filter Settings-dialog.
    printlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: Closing the 'XML Filter Settings'-dialog."
    CloseBtn.Click
    '/// Closing the opened application document.
    printlog "global::tools::inc::t_xml_filter1,inc::fInitialXMLSetting: Closing the opened application document."
    call hCloseDocument
end sub

'-------------------------------------------------------------------------

sub sRemoveXSLTFilter
    Dim sXMLFilterType as string
    Dim iCountOfDefaultXSLTStyles as integer
    Dim ia as integer
    Dim sTempReadFilterName as string
    Kontext "XMLFilterSettings"
    select case lcase(gApplication)
        case "calc"         : sXMLFilterType = "excel"
        case "writer"       : sXMLFilterType = "word"
        case else           : sXMLFilterType = "docbook"
    end select
    iCountOfDefaultXSLTStyles = FilterList.GetItemCount
    if iCountOfDefaultXSLTStyles <> 0 then
        '/// Search for the filter in filter list.
        'Using lowercased input parameter.                 
        for ia = 1 to iCountOfDefaultXSLTStyles
            Kontext "XMLFilterSettings"
            'read the filter names from the dialog.
            sTempReadFilterName = FilterList.GetItemText(ia)
            'lower case comparison!
            if InStr(sTempReadFilterName , sXMLFilterType) <> 0 then
                '/// If the filter has been found delete it.
                FilterList.TypeKeys "<HOME>"
                sleep(1)
                FilterList.TypeKeys "<DOWN>" , (ia-1)
                sleep(1)
                DeleteBtn.Click
                Kontext
                if Active.Exists(1) then
                    if Active.GetRT = 304 then
                        Active.Yes
                    end if
                end if                                
                exit sub
            end if
        next ia
    else
        warnlog "The count of XML filters has to be >0! Problem?"
    end if    
end sub

