'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: i_pengine.inc,v $
'*
'*  $Revision: 1.5 $
'*
'*  last change: $Author: fredrikh $ $Date: 2005/12/02 11:57:10 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* Owner : fredrik.haegg@sun.com
'*
'* short description : Tests the shaddow-function on a picture
'*
'*******************************************************************
'*
' #1 tipengine
'*
'\*******************************************************************

testcase tipengine
'   dim i,t,q as integer
'   dim e as string
'   dim sFileName as string

'/// the Presentation-Engine consists of showing the presentation, with all it's effects. ///'

'/// Create a new presentation. ///'
 Call hNewDocument
 sleep 1

'/// Insert a new slide. ///'
   InsertSlide
   sleep 2
   hTypekeys "<Pagedown>"
   sleep 2

'/// Menu: Slideshow: Check every menu-item. ///'

'Exists:
' #1 tSlideShowSlideShow
' #1 tSlideShowRehearseTimings
' #1 tSlideShowSlideShowSettings
' #1 tSlideShowCustomSlideShow
' #1 tSlideShowSlideTransition
' #1 tSlideShowShowHideSlide

'   Slideshow menu 1 - Slide show
'   Slideshow menu 2 - Slide show settings
'   Slideshow menu 3 - Rehearse timings
'   Slideshow menu 4 - Interaction
'   Slideshow menu 6 - Slide Transition
'   Slideshow menu 7 - Show / Hide slide
'   Slideshow menu 8 - Custom Slide show


pRINTLog " Here starts the test "

'Presentation - Start / Stop. Different ways to do it.
'Presentation - Effects.
'LeftWindow

'/// Slideshow Settings: Range: test all three alternatives. ///'
'/// Test if the Slideshow-types (Default, Window, Auto) works. ///'
'/// Check if the checkboxes works. ///'
'/// Close dialogue. ///'
'/// Add an object. ///'
'/// Custom Animation: Add an Animation to the object. ///'
'/// Run the slideshow. ///'

'/// Change to the next effect and continue through every animation in ///'
'/// Entrance, Emphasis, Exit and Motion Paths. ///'
'/// While testing - test the speed-choices for every kind of animation. ///'
'/// Check if the "Change" and "Remove"-buttons. ///'
'/// Check the Start, "Direction" and "Speed" variables. ///'
'/// Add two effects to one object and change the order. ///'
'/// Try the Play and "Slide Show"-button. ///'
'/// Try the Automatic preview-button. ///'

'/// Slidetransition. ///'
'/// Go through every kind of effect, speed, and sound. ///'
'/// Check loop until next sound. ///'
'/// Check the Advance slide with mouseclick-function. ///'
'/// Check the "Apply to all slides", "Play", and "Slide Show"-buttons. ///'
'/// Check Automatic preview. ///'

'/// Some effects doesnt have a right / left orientation. Test these. ///'
'/// Possibility: check random effects and see if something hangs. ///'

'/// Load/Save-test: Does the settings last? ///'

'/// Are two different objects dependant or independent from each other? ///'

'/// Close Application ///'
   Call hCloseDocument
   Printlog "Finished Level1-test for Presentation-Engine"
endcase


testcase tSlideShowInteraction
   Dim Datei$
   Dim i as integer
   Dim Zaehler as integer
   dim b115364 as boolean

   Datei$ =ConvertPath (gOfficePath + "user\work\interac.sxi")

'   '/// save file as presentation with name '"user\\work\\diashow.sxi")' ///'
'   hSpeichernUnterMitFilterKill ( sFile , gImpressFilter, FALSE )
'   Printlog "saved presetation: '" + sFile + "'"

   '/// open application ///'
   Call hNewDocument
   sleep 5
   setStartCurrentPage(FALSE)   '/// Set "start with current page to OFF ///'

   '/// call 'Insert->Slide' three times and name the slides 2, 3, 4 and create a rectanglȯû on it  ///'
   '///+ we now have 4 slides ?! :-) ///'
   for i = 2 to 4
      InsertSlide
      sleep 2
      hTypekeys "<Pagedown>"
      sleep 2
      Call hRechteckErstellen (i*10,i*10,i*20,i*20)
      sleep 2
   next i

   '///  check state of navigator ! expected: closed -> open navigator ///'
   Kontext "Navigator"
   if Navigator.exists then
      warnlog "Navigator: already open :-("
   else
      printlog "Navigator: NOT available :-( will be opened now!"
      EditNavigator
   endif
   sleep 3

   '/// Slide Show->Interaction ///'
   SlideShowInteraction
      Kontext "TabInteraktion"
      sleep 1
      if AktionBeiMausklick.GetItemCount = 13 Then
         Printlog "- List is complete"
      else
         Warnlog "- Number of possible actions is wrong. It should be: 13, but it is: " + AktionBeiMausklick.GetItemCount
      end if
      sleep 1

      AktionBeiMausklick.Select 1                       'Keine Aktion bei Mausclick
         Printlog (AktionBeiMausklick.GetSelText + " chosen")
         If Durchsuchen.IsVisible then Warnlog "- Control should be invisible because AktionBeiMausklick = " + AktionBeiMausKlick.GetSelText
         sleep 1

      Kontext "TabInteraktion"
      AktionBeiMausklick.Select 2                       'Sprung zur vorhergehenden Seite
         Printlog (AktionBeiMausklick.GetSelText + " chosen")
         if Durchsuchen.IsVisible Then Warnlog "- Control should be invisible, beacause Action = " + AktionBeiMausKlick.GetSelText
      TabInteraktion.OK
      sleep 2
   Kontext "DocumentImpress"
   gMouseClick 90,90
   sleep 1
   gMouseClick 50,50
    sleep 2

   Kontext "NavigatorDraw"
       sleep 2
      if Not Liste.GetSelIndex = 3 Then
         Warnlog "- jumped to wrong slide"
      else
         Printlog "- jumped to correct slide"
      end if
      sleep 1

   Kontext "DocumentImpress"
   DocumentImpress.TypeKeys "<MOD1 A>"
   sleep 1

   SlideShowInteraction
      sleep 2
      Kontext "TabInteraktion"
      AktionBeiMausklick.select 3                       'Sprung zur naechsten Seite
         Printlog (AktionBeiMausKlick.GetSelText + " chosen")
      TabInteraktion.OK
      sleep 1

   Kontext "DocumentImpress"
   gMouseClick 90,90
   sleep 2
   gMouseClick 50,50
   Kontext "NavigatorDraw"
      if Liste.GetSelIndex <> 4 Then
         Warnlog "- Jumped to wrong slide"
      else
         Printlog " Jumped to correct slide"
      end if
      sleep 1
   kontext "DocumentImpress"
   DocumentImpress.TypeKeys "<MOD1 A>"
   sleep 1

   SlideShowInteraction
      sleep 1
      Kontext "TabInteraktion"
      AktionBeiMausklick.select 4                        'Sprung zur ersten Seite
         Printlog AktionBeiMausKlick.GetSelText
         sleep 1
      TabInteraktion.OK
      sleep 1
   Kontext "DocumentImpress"
   gMouseClick 90,90
   gMouseClick 50,50
   Kontext "NavigatorDraw"
      if Liste.GetSelIndex <> 1 Then Warnlog "- jumped to wrong slide"
      Letzte.Click 'Liste.Select 4
   Kontext "DocumentImpress"
   DocumentImpress.TypeKeys "<MOD1 A>"
   sleep 2

    try
        SlideShowInteraction
    catch
        warnlog "SlideshowInteraction diasabled :-("
    endcatch
      Kontext "TabInteraktion"
      AktionBeiMausklick.select 5                       'Sprung zur letzten Seite
         printlog AktionBeiMausKlick.GetSelText
      TabInteraktion.OK
      sleep 1
   Kontext "NavigatorDraw"
      if Not Liste.GetSelIndex = 1 Then Warnlog "- jumped to wrong slide"

   kontext "DocumentImpress"
   Call hRechteckErstellen 20,20,50,50
   sleep 1
   DocumentImpress.TypeKeys "<MOD1 A>"
   sleep 1
    try
        FormatGroupGroup
    catch
        warnlog "GROUP?"
    endcatch
   sleep 1
'      Kontext "NameDlgObject"
'      sleep 1
'      NameField.SetText "Objekt1"
'      NameDlgObject.OK
'   sleep 2

   SlideShowInteraction
      Kontext "TabInteraktion"
      AktionBeiMausklick.select 6                       'Sprung zu Seite oder Objekt
         printlog AktionBeiMausKlick.GetSelText
         sleep 2
         if Not ListeSprungZuSeiteObjekt.IsVisible Then Warnlog " list seems to be invisible"
         Seite.SetText S2
         Suchen.Click
            if ListeSprungZuSeiteObjekt.GetSelIndex <> 3 Then Warnlog " Search does not work"
            printlog ListeSprungZuSeiteObjekt.GetSelIndex
      TabInteraktion.OK
      sleep 1

   Kontext "DocumentImpress"
   gMouseClick 90,90
   gMouseClick 25,25,
   sleep 2
   Kontext "NavigatorDraw"
      if Liste.GetSelIndex <> 2 Then Warnlog "- Jumped to wrong destination"
      printlog Liste.GetSelIndex
      Liste.Select 4
   Kontext "DocumentImpress"
   DocumentImpress.TypeKeys "<MOD1 A>"
   sleep 1

       Kontext "DocumentImpress"
        DocumentImpress.TypeKeys "<MOD1 A>"
        sleep 1
        SlideShowInteraction
         Kontext "TabInteraktion"
         sleep 1
         AktionBeiMausKlick.Select 7                    'Sprung zu Dokument
           Printlog AktionBeiMausKlick.GetSelText + " chosen"
           try
              Durchsuchen.Click
              sleep 1
              Kontext "OeffnenDlg"
              sleep 1
               Dateiname.SetText ConvertPath (gTesttoolPath + "graphics\level1\input\recht_49.sxi")
              Oeffnen.Click
              sleep 10
              ' check if the document is writable
              if fIsDocumentWritable = false then
                 ' make the document writable and check if it's succesfull
                 if fMakeDocumentWritable = false then
                    warnlog "The document can't be make writeable. Test stopped."
                    goto endsub
                 endif
              endif
           catch
              Warnlog "- Search button could not be accessed"
           endcatch
         sleep 1
         Kontext "TabInteraktion"
         sleep 1
         TabInteraktion.OK
         sleep 3
         Kontext "DocumentImpress"
         DocumentImpress.MouseDown 90,90
         DocumentImpress.MouseUp 90,90
        sleep 2
         Kontext "DocumentImpress"
         DocumentImpress.Mousedown 30,30
kontext
       b115364 = false
if messagebox.exists then
   printlog "baeh: '" + messagebox.gettext + "'"
   try
       messagebox.ok  ' was default in so7
   catch
       warnlog "behaviour changed #115364# mother document gets closed :-("
       if fileExists(ConvertPath (gOfficePath + "user\work\bug115364.sxi")) then
           kill ConvertPath (gOfficePath + "user\work\bug115364.sxi")
       endif
       messagebox.yes ' don't save changes, before going on!
       b115364 = true
       kontext "SpeichernDlg"
       Dateiname.setText ConvertPath (gOfficePath + "user\work\bug115364.sxi")
       Speichern.click
       sleep 10
   endcatch
else
   printlog "OK :-)"
endif
         Kontext "DocumentImpress"
         DocumentImpress.MouseUp 30,30
'		 gMouseDoubleClick 30,30

'         sleep 3
'            Kontext "SpeichernDlg"
'             sleep 1
'             Dateityp.Select "StarImpress 5.0"
'             sleep 2
'             AutomatischeDateinamenserweiterung.Check
'             sleep 1
'             Dateiname.SetText ConvertPath (Datei$)
'             sleep 3
'              Speichern.Click
'              sleep 2
'               Kontext "Active"
'                if Active.Exists Then Active.Yes
'               sleep 10

         try
              ViewDrawing
              sleep 1
              Kontext "DocumentImpress"
              DocumentImpress.MouseDown 25,25
              DocumentImpress.MouseUp 25,25
         catch
              Warnlog "- Jump to document did not work or preview window did not appear"
         endcatch
         sleep 2
       if (not b115364) then
         Call hCloseDocument
       else
         Call hCloseDocument
           hDateiOeffnen (ConvertPath (gOfficePath + "user\work\bug115364.sxi"))
       endif
         sleep 5
'         hDateiOeffnen (Datei$)
   sleep 1
   Kontext "NavigatorDraw"
      sleep 1
      Naechste.click

   Kontext "DocumentImpress"
   DocumentImpress.TypeKeys "<MOD1 A>"
   sleep  1

   SlideShowInteraction
      Kontext "TabInteraktion"
      sleep 1
      AktionBeiMausKlick.Select 9
         Printlog AktionBeiMausKlick.GetSelText + " chosen"
         sleep 1
      Tabinteraktion.OK
   sleep 2

   SlideShowInteraction
      Kontext "TabInteraktion"
      sleep 1
      if not AktionBeiMausKlick.GetSelIndex = 9 Then Warnlog "- Not the right action chosen"
      sleep 1
      AktionBeiMausKlick.Select 9                          'Klang abspielen
           Printlog  AktionBeiMausKlick.GetSelText + "- chosen"
         sleep 1
      Tabinteraktion.OK
      sleep 2
         Kontext "NavigatorDraw"
           sleep 1
           Liste.Select 2
           Kontext "DocumentImpress"
            DocumentImpress.TypeKeys "<MOD1 A>"
            sleep  1
           SlideShowInteraction
            Kontext "TabInteraktion"
            sleep 1
             Durchsuchen.Click
             sleep 1
             Kontext "OeffnenDlg"
             sleep 1
'             Dateiname.SetText ConvertPath (gOfficePath + "user\gallery\sounds\apert.wav")
             Dateiname.SetText ConvertPath (gTesttoolPath + "graphics\level1\input\blip.wav")
             sleep 1
             Oeffnen.Click
                sleep 1
                Kontext "Active"
                 if Active.Exists Then
                    Warnlog Active.GetText + "  Gallery might be empty"
                    Active.OK
                    sleep 1
                    Kontext "OeffnenDlg"
                    OeffnenDlg.Cancel
                    sleep 1
                 end if
                Kontext "TabInteraktion"
                SetClipboard Klangwahl.GetText
             TabInteraktion.OK
             sleep 1
             SlideShowInteraction
             Kontext "TabInteraktion"
             sleep 1
             if Klangwahl.GetText <> GetClipboardText then Warnlog "- Not the right sound chosen"
             TabInteraktion.OK
             sleep 1
             InsertGraphicsFromFile
              sleep 1
             Kontext "GrafikeinfuegenDlg"
             sleep 1
             if Verknuepfen.IsChecked then Verknuepfen.UnCheck
             Dateiname.SetText ConvertPath (gTesttoolPath + "global\input\graf_inp\enter.bmp")
             Oeffnen.Click
             sleep 3
             Kontext "NavigatorDraw"
             sleep 1
             Liste.Select 4
             sleep 1
             SlideShowInteraction
             Kontext "TabInteraktion"
             sleep 1
             AktionBeiMausKlick.Select 11                       'Objektaktion ausfuehren
                Printlog  AktionBeiMausKlick.GetSelText + " chosen"
             sleep 1
            Zaehler=Effekt.GetItemCount
         for i=1 to Zaehler
            Effekt.Select i
            Printlog Effekt.GetSelText + " chosen"
            if i=1 Then
               if Langsam.IsEnabled Then Warnlog "- Control should not be enabled, because no effect chosen"
               if Mittel.IsEnabled Then Warnlog "- Control should not be enabled, because no effect chosen"
               if Schnell.IsEnabled Then Warnlog "- Control should not be enabled, because no effect chosen"
            end if
'                      for i= 20 to 23
'                          if not UnsichtbareFarbe.IsEnabled Then Warnlog "- Unsichtbare Farbe steht nicht zur Verfuegung bei dieser Aktion"
'                          UnsichtbareFarbe.Select 10
'                          TabInteraktion.OK
'                          sleep 1
'                          SlideShowInteraction
'                           Kontext "TabInteraktion"
'                           sleep 1
'
'                            if UnsichtbareFarbe.GetSelNr = 10 Then
'                               Printlog "- Eintrag wurde korrekt uebernommen"
'                            else
'                               Warnlog "- Unsichtbare Farbe wurde nicht uebernommen fuer diese Aktion"
'                            end if
'                       TabInteraktion.OK
'                       sleep 1
'                       SlideShowInteraction
'                       sleep 1
'                       Kontext "TabInteraktion"
'                       sleep 1
'                       if Effekt.GetSelNr <> i Then Warnlog "- Dieser Effekt wurde nicht uebernommen"
'                   next i
            sleep 1

            TabInteraktion.OK
            sleep 1
            SlideShowInteraction
            Kontext "TabInteraktion"
            sleep 1
         next i
         TabInteraktion.OK
         sleep 1
   SlideShowInteraction
      Kontext "TabInteraktion"
      sleep 1
      AktionBeiMausKlick.Select 10                       'Objekt ausblenden
         Printlog AktionBeiMausKlick.GetSelText + " chosen"
         ListeObjektAktion.Select 1
         sleep 1
      TabInteraktion.OK
   sleep 1
   gMouseClick 90,90
   sleep 1
   gMouseClick 55,55
   sleep 1
   Kontext "DocumentImage"

   SlideShowInteraction
      Kontext "TabInteraktion"
      sleep 1
      AktionBeiMausKlick.Select 13 			'Makro
         Printlog AktionBeiMausKlick.GetSelText + " chosen"
         sleep 2
         Durchsuchen.Click
            sleep 5
            Kontext "Makro"
            sleep 5
            Makro.Cancel
         sleep 2
      Kontext "TabInteraktion"
      sleep 1
      TabInteraktion.OK
      sleep 3

   SlideShowInteraction
      Kontext "TabInteraktion"
      sleep 2
      if not AktionBeiMausKlick.GetSelIndex = 12 Then Warnlog "- Wrong action used"
      sleep 1
      AktionBeiMausKlick.Select 14           'Praesentation beenden
         Printlog AktionBeiMausKlick.GetSelText
      Tabinteraktion.OK
      sleep 1

   SlideShowPresentationSettings
      Kontext "Bildschirmpraesentation"
      if not Fenster.IsChecked Then Fenster.Check
      BildschirmPraesentation.OK
   sleep 2
   Kontext "DocumentImpress"
   DocumentImpress.TypeKeys "<MOD1 F2>"
      sleep 5
      Kontext "DocumentPresentation"
      sleep 2
      DocumentPresentation.MouseDown 50,50
      DocumentPresentation.MouseUp 50,50
      sleep 5
      try
         Kontext "DocumentImpress"
         DocumentImpress.TypeKeys "<MOD1 A>"
         Printlog "- Slideshow ended at right point"
      catch
         Warnlog "- Program is still in slideshow mode"
         Kontext "DocumentPresentation"
         DocumentPresentation.TypeKeys "<ESCAPE>"
      endcatch

   Kontext "DocumentImpress"
   DocumentImpress.TypeKeys "<SHIFT MOD1 F5>"
   sleep 3
   setStartCurrentPage(TRUE)   '/// Set "start with current page to ON = Default ///'
   Call hCloseDocument
endcase

'   Slideshow menu 5 - Custom Animation

testcase tSlideShowCustomAnimation
    dim bError as boolean

    '/// open application ///'
    Call hNewDocument
    '/// create textbox with text ///'
    Call hTextrahmenErstellen ("Test text to test text effects", 10, 10, 20, 40 )
    '/// Slide Show->Custom Animation... ///'
    SlideShowCustomAnimation
        Kontext "Tasks"
        '/// click button 'Add...' ///'
        EffectAdd.click
        '/// Dialog 'Custom Animation' comes up ///'
        kontext
        '/// Switch to TabPage: Entrance ///'
        active.setPage(TabEntrance)
        kontext "TabEntrance"
        if TabEntrance.exists(5) then
            DialogTest(TabEntrance)
            '/// select in the listbox 'Effects' the second entry///'
            Effects.select(2)
            Speed.getItemCount
            AutomaticPreview.unCheck
            sleep 1
            AutomaticPreview.Check
            kontext
            '/// Switch to TabPage: Emphasis ///'
            active.setPage(TabEmphasis)
            kontext "TabEmphasis"
            if TabEmphasis.exists(5) then
                DialogTest(TabEmphasis)
            else
                bError = true
                warnlog "Impress:Tasks Pane:Custom Animation:TabEmphasis tabPage doesn't work."
            endif
            kontext
            '/// Switch to TabPage: Exit ///'
            active.setPage(TabExit)
            kontext "TabExit"
            if TabExit.exists(5) then
                DialogTest(TabExit)
            else
                bError = true
                warnlog "Impress:Tasks Pane:Custom Animation:TabExit tabPage doesn't work."
            endif
            kontext
            '/// Switch to TabPage: Motion Paths ///'
            active.setPage(TabMotionPaths)
            kontext "TabMotionPaths"
            if TabMotionPaths.exists(5) then
                DialogTest(TabMotionPaths)
                qaErrorLog("#i44701# selection needs to be made on the page where you say 'OK'")
                Effects.select(2)
            else
                bError = true
                warnlog "Impress:Tasks Pane:Custom Animation:TabMotionPaths tabPage doesn't work."
            endif
            '/// Close dialog 'Custom Animation' with 'OK' ///'
            TabMotionPaths.OK
            bError = false
        else
            bError = true
            warnlog "Impress:Tasks Pane:Custom Animation:Add... button didn't work."
        endif
        Kontext "Tasks"
        if (NOT bError) then
            '/// click button 'Change...' ///'
            EffectChange.click
            '/// Dialog 'Custom Animation' comes up ///'
            kontext
            '/// Switch to TabPage: Entrance ///'
            active.setPage(TabEntrance)
            kontext "TabEntrance"
            if (NOT TabEntrance.exists(5)) then
                warnlog "Impress:Tasks Pane:Custom Animation:Change... button didn't work."
            endif
            TabEntrance.cancel
            Kontext "Tasks"
            EffectStart.getItemCount
            if EffectProperty.isEnabled then
                EffectProperty.getItemCount
            endif
            '/// CLick on button '...' (Options) ///'
            EffectOptions.click
            kontext "TabEffect"
            if TabEffect.exists(5) then
                dialogTest(TabEffect)
                Sound.getItemCount
                AfterAnimation.getItemCount
                '/// switch to TabPage 'Timing' ///'
                Kontext
                active.setPage TabTiming
                kontext "TabTiming"
                if TabTiming.exists(5) then
                    dialogTest(TabTiming)
                    TimingStart.getItemCount
                    Delay.getText
                    Speed.getItemCount
                    Repeat.getItemCount
                    Rewind.ischecked
                    TriggerAnimate.isChecked
                    TriggerStart.isChecked
                    Shape.getItemCount
                else
                    warnlog "Impress:Tasks Pane:Custom Animation:Effect Options: Timing TabPage didn't work."
                endif
                '/// switch to TabPage 'Timing' ///'
                Kontext
                active.setPage TabTextAnimation
                kontext "TabTextAnimation"
                if TabTextAnimation.exists(5) then
                    dialogTest(TabTextAnimation)
                    GroupText.getItemCount
                    AnimateAttachedShape.isChecked
                    TabTextAnimation.cancel
                else
                    warnlog "Impress:Tasks Pane:Custom Animation:Effect Options: TextAnimation TabPage didn't work."
                endif
            else
                warnlog "Impress:Tasks Pane:Custom Animation:... button didn't work."
            endif
            Kontext "Tasks"
            EffectSpeed.getItemCount
            EffectList.getItemCount
            EffectPlay.click
            EffectSlideShow.click
            sleep 1
            kontext "DocumentPresentation"
            if DocumentPresentation.exists (5) then
                printlog "Presentation started :-)"
                DocumentPresentation.typeKeys "<escape>"
            else
                warnlog "Impress:Tasks Pane:Custom Animation:Slide Show button doesn't start slideshow!"
            endif
            kontext "Tasks"
            EffectAutomaticPreview.isChecked
            '/// click button 'Remove' ///'
            EffectRemove.click
        endif
    '/// close application ///'
    Call hCloseDocument
endcase

