'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: i_pengine2.inc,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:25:01 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* Owner : fredrik.haegg@sun.com
'*
'* short description : Tests the Presentation-Engines effects
'*
'*******************************************************************
'*
' #1 tiPengineAnimationEffectsPreview
'*
'\*******************************************************************

testcase tiPengineAnimationEffectsPreview
    dim bError as boolean
'    dim i,s,q,e,o as integer

    '/// open application ///'
    Call hNewDocument
    '/// create textbox with text ///'
    Call hTextrahmenErstellen ("Test text to test text effects", 35, 35, 70, 70 )
    '/// Slide Show->Custom Animation... ///'
    SlideShowCustomAnimation
        Kontext "Tasks"
        '/// click button 'Add...' ///'
        EffectAdd.click
        '/// Dialog 'Custom Animation' comes up ///'
        kontext
        '/// Switch to TabPage: Entrance ///'
        active.setPage(TabEntrance)
        kontext "TabEntrance"
        if TabEntrance.exists(5) then
           DialogTest(TabEntrance)
           TestAnimations
           '/// Switch to TabPage: Emphasis ///'
           kontext
           active.setPage(TabEmphasis)
           kontext "TabEmphasis"
              if TabEmphasis.exists(5) then
                 DialogTest(TabEmphasis)
                 TestAnimations
              else
                 bError = true
                 warnlog "Impress:Tasks Pane:Custom Animation:TabEmphasis tabPage doesn't work."
              endif
           kontext
           '/// Switch to TabPage: Exit ///'
           active.setPage(TabExit)
           kontext "TabExit"
              if TabExit.exists(5) then
                 DialogTest(TabExit)
                 TestAnimations
              else
                 bError = true
                 warnlog "Impress:Tasks Pane:Custom Animation:TabExit tabPage doesn't work."
              endif
           kontext
           '/// Switch to TabPage: Motion Paths ///'
           active.setPage(TabMotionPaths)
           kontext "TabMotionPaths"
              if TabMotionPaths.exists(5) then
                 DialogTest(TabMotionPaths)
'                 qaErrorLog("#i44701# selection needs to be made on the page where you say 'OK'")
                 TestAnimations
              else
                 bError = true
                 warnlog "Impress:Tasks Pane:Custom Animation:TabMotionPaths tabPage doesn't work."
              endif
           kontext
           '/// Switch to TabPage: Entrance ///'
           active.setPage(TabEntrance)
           kontext "TabEntrance"
           if TabEntrance.exists(5) then
              Effects.Select 4
              '/// Close dialog 'Custom Animation' with 'OK' ///'
              TabEntrance.OK
           else
              warnlog "Error when switching Tab"
           endif
           bError = false
        else
           bError = true
           warnlog "Impress:Tasks Pane:Custom Animation:Add... button didn't work."
        endif
        Kontext "Tasks"
        if (NOT bError) then
            '/// click button 'Change...' ///'
            EffectChange.click
            '/// Dialog 'Custom Animation' comes up ///'
            kontext
            '/// Switch to TabPage: Entrance ///'
            active.setPage(TabEntrance)
            kontext "TabEntrance"
            if (NOT TabEntrance.exists(5)) then
                warnlog "Impress:Tasks Pane:Custom Animation:Change... button didn't work."
            endif
            TabEntrance.Cancel
            Kontext "Tasks"
            EffectStart.GetItemCount
            if EffectProperty.IsVisible then
                EffectProperty.GetItemCount
            endif
            '/// CLick on button '...' (Options) ///'
            EffectOptions.Click
            kontext "TabEffect"
            if TabEffect.Exists(5) then
                dialogTest(TabEffect)
                Sound.GetItemCount
                AfterAnimation.GetItemCount
                '/// switch to TabPage 'Timing' ///'
                Kontext
                Active.SetPage TabTiming
                kontext "TabTiming"
                if TabTiming.Exists(5) then
                    dialogTest(TabTiming)
                    TimingStart.GetItemCount
                    Delay.GetText
                    Speed.GetItemCount
                    Repeat.GetItemCount
                    Rewind.Ischecked
                    TriggerAnimate.IsChecked
                    TriggerStart.IsChecked
                    Shape.GetItemCount
                else
                    warnlog "Impress:Tasks Pane:Custom Animation:Effect Options: Timing TabPage didn't work."
                endif
                '/// switch to TabPage 'Timing' ///'
                Kontext
                active.setPage TabTextAnimation
                kontext "TabTextAnimation"
                if TabTextAnimation.Exists(5) then
                    dialogTest(TabTextAnimation)
                    GroupText.GetItemCount
                    AnimateAttachedShape.IsChecked
                    TabTextAnimation.Cancel
                else
                    warnlog "Impress:Tasks Pane:Custom Animation:Effect Options: TextAnimation TabPage didn't work."
                endif
            else
                warnlog "Impress:Tasks Pane:Custom Animation:... button didn't work."
            endif
            Kontext "Tasks"
            EffectSpeed.GetItemCount
            EffectList.GetItemCount
            EffectPlay.Click
            sleep 3
            EffectSlideShow.Click
            sleep 1
            kontext "DocumentPresentation"
            if DocumentPresentation.Exists (5) then
                printlog "Presentation started :-)"
                DocumentPresentation.TypeKeys "<escape>"
            else
                warnlog "Impress:Tasks Pane:Custom Animation:Slide Show button doesn't start slideshow!"
            endif
            kontext "Tasks"
            EffectAutomaticPreview.Check
            '/// click button 'Remove' ///'
            EffectRemove.Click
        endif
    '/// close application ///'
    Call hCloseDocument
endcase

testcase tiPengineAnimationEffectsOptions
    dim bError as boolean
    dim i,s,q,e,o,p,d,u,t,l,w as integer
    dim Effectname1 as string
    dim StartName1 as string
    dim PropertyName1 as string

'/// open application ///'
Call hNewDocument
'/// create textbox with text ///'
Call hTextrahmenErstellen ("Test text to test text effects", 35, 35, 70, 70 )
'/// Slide Show->Custom Animation... ///'
SlideShowCustomAnimation
   Kontext "Tasks"
   '/// click button 'Add...' ///'
   EffectAdd.click
   '/// Dialog 'Custom Animation' comes up ///'
   kontext
   '/// Switch to TabPage: Entrance ///'
   active.setPage(TabEntrance)
   kontext "TabEntrance"
   if TabEntrance.exists(5) then
      AutomaticPreview.UnCheck
      Printlog "Testing effects in - TabEntrance"
      i = Effects.GetItemCount
      For o = 1 to 2
          p = 7555
          Effects.TypeKeys "<HOME>"
          For e = 1 to i
              sleep 1
              Printlog "Effect Nr: " + Effects.GetSelIndex + ". Name: " + Effects.GetSelText
              Effectname1 = Effects.GetSelText
              if AutomaticPreview.IsChecked = TRUE then sleep 1
              d = Effects.GetSelIndex
              TabEntrance.Ok
              optionstest2
              Kontext "Tasks"
              if Tasks.Exists then
                 EffectChange.Click
              else
                 Warnlog "Something wrong when exiting Impress:Tasks Pane:Custom Animation: ... (options)"
              endif
              kontext "TabEntrance"
              Effects.TypeKeys "<DOWN>", e '/// Select the next entry ///'
              p = Effects.GetSelIndex
              If p = d Then e = i 'p > 2 AND
          Next e
          kontext "TabEntrance"
          For q = 1 to s
              Speed.Select q
          Next q
          Printlog "Test of Entrance-list ended."
          s = Speed.GetItemCount
      Next o

      '/// Switch to TabPage: Emphasis ///'
      kontext
      active.setPage(TabEmphasis)
      kontext "TabEmphasis"
      if TabEmphasis.exists(5) then
         Printlog "Testing effects in - TabEmphasis"
         i = Effects.GetItemCount
         For o = 1 to 2
             p = 7555
             Effects.TypeKeys "<HOME>"
             For e = 1 to i
                 sleep 1
                 Printlog "Effect Nr: " + Effects.GetSelIndex + ". Name: " + Effects.GetSelText
                 Effectname1 = Effects.GetSelText
                 if AutomaticPreview.IsChecked = TRUE then sleep 1
                 d = Effects.GetSelIndex
                 TabEmphasis.Ok
                 Kontext "Tasks"
                 if EffectStart.isEnabled then
                    optionstest2
                    t = EffectStart.GetItemCount
                    for u = 1 to t
                        EffectStart.Select u
                        StartName1 = EffectStart.GetSelText
                        printlog "EffectStart selected " + StartName1
                        If EffectProperty.isEnabled then
'                           w = EffectProperty.GetItemCount
'                           if w > 0 then
'                              for l = 1 to w
'                                  EffectProperty.Select l
'                                  PropertyName1 = EffectProperty.GetSelText
'                                  printlog "Properties for the effect: " + PropertyName1
'                                  EffectSlideShow.Click
'                                  Sleep 2
'                                  kontext "DocumentPresentation"
'                                  if DocumentPresentation.Exists (5) then
'                                    DocumentPresentation.MouseDown 50,50
'                                    DocumentPresentation.MouseUp 50,50
'                                    Sleep 2
'                                    DocumentPresentation.TypeKeys "<Space>"
'                                     DocumentPresentation.TypeKeys "<Escape>"
'                                  else
'                                     Warnlog "Effect: " + Effectname1 + " didn't work when it started with: " + StartName1 + "and ended with: " + PropertyName1
'                                  endif
'                                  Kontext "Tasks"
'                              Next l
'                           endif
                        Else
                           EffectSlideShow.Click
                           Sleep 2
                           kontext "DocumentPresentation"
                           if DocumentPresentation.Exists (5) then
                              DocumentPresentation.MouseDown 50,50
                              DocumentPresentation.MouseUp 50,50
                              Sleep 2
                              DocumentPresentation.TypeKeys "<Space>"
                              DocumentPresentation.TypeKeys "<Escape>"
                           else
                              Warnlog "Effect: " + Effectname1 + " didn't work when it started with: " + StartName1
                           endif
                           Kontext "Tasks"
                        Endif
                    Next u
                 Endif
                 Kontext "Tasks"
                 if Tasks.Exists then
                    EffectChange.Click
                 else
                    Printlog "Presentation didn't end. Error?"
                 endif
                 kontext "TabEmphasis"
                 Effects.TypeKeys "<DOWN>", e + 1 '/// Select the next entry ///'
                  p = Effects.GetSelIndex
                  If p = d Then e = i 'p > 2 AND
             Next e
             kontext "TabEmphasis"
             For q = 1 to s
                 Speed.Select q
             Next q
             Printlog "Test of Entrance-list ended."
             s = Speed.GetItemCount
         Next o
      else
         bError = true
         warnlog "Impress:Tasks Pane:Custom Animation:TabExit tabPage doesnt work."
      endif
      kontext
      '/// Switch to TabPage: Exit ///'
      active.setPage(TabExit)
      kontext "TabExit"
      if TabExit.exists(5) then
         Printlog "Testing effects in - TabExit"
         i = Effects.GetItemCount
         For o = 1 to 2
             p = 7555
             Effects.TypeKeys "<HOME>"
             For e = 1 to i
                 sleep 1
                 Printlog "Effect Nr: " + Effects.GetSelIndex + ". Name: " + Effects.GetSelText
                 Effectname1 = Effects.GetSelText
                 if AutomaticPreview.IsChecked = TRUE then sleep 1
                 d = Effects.GetSelIndex
                 TabExit.Ok
                 Kontext "Tasks"
                 if EffectStart.isEnabled then
                    optionstest2
                    t = EffectStart.GetItemCount
                    for u = 1 to t
                        EffectStart.Select u
                        StartName1 = EffectStart.GetSelText
                        printlog "EffectStart selected " + StartName1
                        If EffectProperty.isEnabled then
                           w = EffectProperty.GetItemCount
                           if w > 0 then
                              for l = 1 to w
                                  EffectProperty.Select l
                                  PropertyName1 = EffectProperty.GetSelText
                                  printlog "Properties for the effect: " + PropertyName1
                                  EffectSlideShow.Click
                                  Sleep 2
                                  kontext "DocumentPresentation"
                                  if DocumentPresentation.Exists (5) then
                                     DocumentPresentation.MouseDown 50,50
                                     DocumentPresentation.MouseUp 50,50
                                     Sleep 2
                                     DocumentPresentation.TypeKeys "<Space>"
                                     DocumentPresentation.TypeKeys "<Escape>"
                                  else
                                     Warnlog "Effect: " + Effectname1 + " didn't work when it started with: " + StartName1 + "and ended with: " + PropertyName1
                                  endif
                                  Kontext "Tasks"
                              Next l
                           endif
                        Else
                           EffectSlideShow.Click
                           Sleep 2
                           kontext "DocumentPresentation"
                           if DocumentPresentation.Exists (5) then
                              DocumentPresentation.MouseDown 50,50
                              DocumentPresentation.MouseUp 50,50
                              Sleep 2
                              DocumentPresentation.TypeKeys "<Space>"
                              DocumentPresentation.TypeKeys "<Escape>"
                           else
                              Warnlog "Effect: " + Effectname1 + " didn't work when it started with: " + StartName1
                           endif
                           Kontext "Tasks"
                        Endif
                    Next u
                 Endif
                 Kontext "Tasks"
                 if Tasks.Exists then
                    EffectChange.Click
                 else
                    Printlog "Presentation didn't end. Error?"
                 endif
                 kontext "TabExit"
                 Effects.TypeKeys "<DOWN>", e + 1 '/// Select the next entry ///'
                 p = Effects.GetSelIndex
                 If p = d Then e = i 'p > 2 AND
             Next e
             kontext "TabExit"
             For q = 1 to s
                Speed.Select q
             Next q
             Printlog "Test of Entrance-list ended."
             s = Speed.GetItemCount
         Next o
         bError = false
      else
         bError = true
         warnlog "Impress:Tasks Pane:Custom Animation:TabExit tabPage doesnt work."
      endif
      kontext
      '/// Switch to TabPage: Motion Paths ///'
      active.setPage(TabMotionPaths)
      kontext "TabMotionPaths"
      if TabMotionPaths.exists(5) then
         Printlog "Testing effects in - TabMotionPaths"
         i = Effects.GetItemCount
         For o = 1 to 2
             p = 7555
             Effects.TypeKeys "<HOME>"
             For e = 1 to i
                 sleep 1
                 Printlog "Effect Nr: " + Effects.GetSelIndex + ". Name: " + Effects.GetSelText
                 Effectname1 = Effects.GetSelText
                 if AutomaticPreview.IsChecked = TRUE then sleep 1
                 d = Effects.GetSelIndex
                 TabMotionPaths.Ok
                 Kontext "Tasks"
                 if EffectStart.isEnabled then
                    t = EffectStart.GetItemCount
                    for u = 1 to t
                        EffectStart.Select u
                        StartName1 = EffectStart.GetSelText
                        printlog "EffectStart selected " + StartName1
                        If EffectProperty.isEnabled then
                           optionstest2
                           w = EffectProperty.GetItemCount
                           if w > 0 then
                              for l = 1 to w
                                  EffectProperty.Select l
                                  PropertyName1 = EffectProperty.GetSelText
                                  printlog "Properties for the effect: " + PropertyName1
                                  EffectSlideShow.Click
                                  Sleep 2
                                  kontext "DocumentPresentation"
                                  if DocumentPresentation.Exists (5) then
                                     DocumentPresentation.MouseDown 50,50
                                     DocumentPresentation.MouseUp 50,50
                                     Sleep 2
                                     DocumentPresentation.TypeKeys "<Space>"
                                     DocumentPresentation.TypeKeys "<Escape>"
                                  else
                                     Warnlog "Effect: " + Effectname1 + " didn't work when it started with: " + StartName1 + "and ended with: " + PropertyName1
                                  endif
                                  Kontext "Tasks"
                              Next l
                           endif
                        Else
                           EffectSlideShow.Click
                           Sleep 2
                           kontext "DocumentPresentation"
                           if DocumentPresentation.Exists (5) then
                              DocumentPresentation.MouseDown 50,50
                              DocumentPresentation.MouseUp 50,50
                              Sleep 2
                              DocumentPresentation.TypeKeys "<Space>"
                              DocumentPresentation.TypeKeys "<Escape>"
                           else
                              Warnlog "Effect: " + Effectname1 + " didn't work when it started with: " + StartName1
                           endif
                           Kontext "Tasks"
                        Endif
                    Next u
                 Endif
                 Kontext "Tasks"
                 if Tasks.Exists then
                    EffectChange.Click
                 else
                    Printlog "Presentation didn't end. Error?"
                 endif
                 kontext "TabMotionPaths"
                 Effects.TypeKeys "<DOWN>", e + 1 '/// Select the next entry ///'
'                 if p = 2 then Effects.TypeKeys "<DOWN>"
                  p = Effects.GetSelIndex
                  If p = d Then e = i 'p > 2 AND
             Next e
             kontext "TabMotionPaths"
             For q = 1 to s
                 Speed.Select q
             Next q
             Printlog "Test of Entrance-list ended."
             s = Speed.GetItemCount
         Next o
         bError = false
      else
         bError = true
         warnlog "Impress:Tasks Pane:Custom Animation:TabMotionPaths tabPage doesn't work."
      endif
      kontext
      '/// Switch to TabPage: Entrance ///'
      active.setPage(TabEntrance)
      kontext "TabEntrance"
      if TabEntrance.exists(5) then
         Effects.Select 4
         '/// Close dialog 'Custom Animation' with 'OK' ///'
         TabEntrance.OK
      else
         warnlog "Error when switching Tab"
      endif
      bError = false
   else
      bError = true
      warnlog "Impress:Tasks Pane:Custom Animation:Add... button didnt work."
   endif
   kontext "Tasks"
   EffectAutomaticPreview.Check
   '/// click button 'Remove' ///'
   EffectRemove.Click
   '/// close application ///'
   Call hCloseDocument
endcase

Function TestAnimations
   '/// select in the listbox 'Effects' the second entry///'
   Dim i,s,q,e,o,p as Integer
   i = Effects.GetItemCount
   s = Speed.GetItemCount
   AutomaticPreview.Check
'   Kontext
   For o = 1 to 2
           Effects.TypeKeys "<HOME>"
           For e = 1 to i
               If e <> p Then
                  if AutomaticPreview.isChecked = TRUE then sleep 2
                  Printlog "Effect has position Nr: " + Effects.GetSelIndex + ". Name of effect: " + Effects.GetSelText
                  Effects.TypeKeys "<DOWN>" 'Select the next entry
                  p = Effects.GetSelIndex
               Else
                  Printlog "Test of effects ended."
                  e = i
               Endif
           Next e
       For q = 1 to s
           Speed.Select q
           sleep 1
       Next q
       AutomaticPreview.Check
   Next o
   sleep 1
   AutomaticPreview.Check
   Kontext
end Function

function optionstest2
    dim filedialogue as boolean
    dim lala, optsound, os, oa, odc, ota, ets, etspeed, etrep, etshap, etgt as integer

     Kontext "Tasks"
        EffectOptions.Click
        kontext "TabEffect"
        if TabEffect.Exists(5) then
           Sound.Select 5
           AfterAnimation.Select 2
           if DimColor.isEnabled then
              DimColor.Select 5
           else
              Warnlog "DimColor should have been enabled"
           endif
           TextAnimation.Select 3
           if DelayBetweenCharacters.isEnabled then
              DelayBetweenCharacters.More 5
           else
              Warnlog "DelayBetweenCharacters should have been enabled"
           endif
           '/// switch to TabPage 'Timing' ///'
           Kontext
           Active.SetPage TabTiming
           kontext "TabTiming"
           if TabTiming.Exists(5) then
              TimingStart.Select 2
              if Delay.isVisible AND Delay.isEnabled then
                 Delay.More 5
              else
                 Warnlog "Delay in Effect Options were not to be found."
              endif
              if Speed.isVisible AND Speed.isEnabled then
                 Speed.Select 3
              else
                 Warnlog "Speed in Effect Options were not to be found."
              endif
              if Repeat.isVisible AND Repeat.isEnabled then
                 for etrep = 1 to Speed.GetItemCount
                 Repeat.Select etrep
                 next etrep
              else
                 Warnlog "Repeat in Effect Options were not to be found."
              endif
              Rewind.Check
              Rewind.UnCheck
              TriggerAnimate.IsChecked
              TriggerStart.IsChecked
              if Shape.isVisible AND Shape.isEnabled then
                 for etshap = 1 to Shape.GetItemCount
                 Shape.Select etshap
                 next etshap
              else
                 Warnlog "Shape in Effect Options were not to be found."
              endif
           else
              warnlog "Impress:Tasks Pane:Custom Animation:Effect Options: Timing TabPage didn't work."
           endif
           '/// switch to TabPage 'Timing' ///'
           Kontext
           active.setPage TabTextAnimation
           kontext "TabTextAnimation"
           if TabTextAnimation.Exists(5) then
              lala = GroupText.GetItemCount
              for etgt = 1 to lala
                  GroupText.Select etgt
                  if AutomaticallyAfter.IsEnabled then
                     AutomaticallyAfter.Check
                     AutomaticallyAfter.TypeKeys "<UP>"
                  endif
                  if AnimateAttachedShape.IsEnabled then
                     AnimateAttachedShape.Check
                     if AnimateAttachedShape.IsChecked = FALSE then
                        Warnlog "AnimateAttachedShape should have been checked"
                     endif
                  endif
                  if InreverseOrder.IsEnabled then
                     InreverseOrder.Check
                     if InreverseOrder.IsChecked = FALSE then
                        Warnlog "InreverseOrder should have been checked"
                     endif
                  endif
              next etgt
              TabTextAnimation.Cancel
           else
              warnlog "Impress:Tasks Pane:Custom Animation:Effect Options: TextAnimation TabPage didn't work."
           endif
        else
           warnlog "Impress:Tasks Pane:Custom Animation:... button didn't work."
        endif
        Kontext "Tasks"
end function
