'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: i_stylist.inc,v $
'*
'*  $Revision: 1.5 $
'*
'*  last change: $Author: fredrikh $ $Date: 2005/11/24 18:59:43 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* Owner : fredrik.haegg@sun.com
'*
'* short description :
'*
'*******************************************************************
'*
' #1 tFormatStylistBackground
' #1 fGetSetPageBackground
'*
'\*******************************************************************

testcase tFormatStylistBackground
'/// special test for BUG # 96364 "Background style looses functionality over PPT Ex/import" ///'
    dim sFilter (50) as string
    dim sFileList (30) as string
    dim i,x,y as integer
    dim iColor as integer
    dim sFileName as string
    dim Exlist(20) as string

    sFilter (0) = 0

    if (glLocale(5) = "") then
        qaErrorLog("Language dependant string 'Background' is missing; get it from the stylist and insert it into the locale-file mentioned in the .bas file!")
        goto endsub
    endif

    '/// if not exists : gOfficePath + '\\user\\impress\\level1\\', create it ///'
    if app.dir (ConvertPath ( gOfficePath + "user/work/impress") ) = "" then
        app.mkdir ConvertPath ( gOfficePath + "user/work/impress")
    endif
    if app.dir (ConvertPath ( gOfficePath + "user/work/impress/level1")) = "" then
        app.mkdir ConvertPath ( gOfficePath + "user/work/impress/level1")
    endif

    '/// open application ///'
    Call  hNewDocument

    iColor = 10
    '/// change background color via stylist ///'
    if (iColor <> fGetSetPageBackground (iColor,0)) then
        warnlog "Stylist background was not changed as expected :-( "+iColor
    endif
    '/// check if it is the same in Format -> Page ///'
    if fGetSetPageBackground (0,1) <> iColor then
        warnlog " First stage error! Difference between stylist and menu entry :-( "+iColor
    endif

    '/// save this in 3 formats: ///'
    '///+  - StarImpress 5.0 ///'
    '///+  - StarOffice 6.0 Presentation ///'
    '///+  - Microsoft PowerPoint 97/2000/XP ///'
    FileSaveAs
    sleep 2
    Kontext "SpeichernDlg"
    for i = 0 to 2
        if i=0 then x = Dateityp.GetItemCount
        if (i) then  ' set border, whenm start from beginning/end
            y = ((i-1)*2)+1     ' set filter from beginning
        else
            y = x-3     ' set filter from end
        endif
        ListAppend(sFilter(), Dateityp.GetItemText (y))
    next i
    SpeichernDlg.Cancel


    sFileName = convertpath( gOfficePath + "user/work/impress/level1")
    GetFileList ( sFileName, "isty_*.*", Exlist() )
    KillFileList ( Exlist() )

    for i = 1 to (ListCount(sFilter()))
     sleep 1
      printlog "Going to save: '"+sFileName+"isty_"+(i)+"'..."
     sleep 1
      hSpeichernUnterMitFilterKill (sFileName+"isty_"+(i), sFilter(i), True )
      printlog " saved with filter ("+i+"/3): "+ sFilter(i)
    next i

    '/// close impress ///'
    FileClose
    sleep 1
    kontext ' active about information loss ?
    if active.exists (5) then active.yes
    sleep 10

    '/// open just saved files ///'
    sFileName = ConvertPath ( gOfficePath + "user/work/impress/level1/" )
    GetFileList ( sFileName, "isty_*", sFileList() )

    x = ListCount ( sFileList() )
    for i = 1 to x
     printlog "("+i+"/"+x+"): "+sFileList(i)
      hDateiOeffnen ( sFileList(i) )
      Sleep 5
      If hIsNamedDocLoaded (sFileList(i)) Then
         printlog "  used filter: " + hGetUsedFilter()
      else
         warnlog "document didn't get loaded"
      endif
      sleep 5
      '/// check if stylist, menue and prediction are as expected ///'
     iColor = 10
      if ((fGetSetPageBackground (0,0) <> iColor) OR (fGetSetPageBackground (0,1) <> iColor)) then
         warnlog "Background was not as expected on loading :-( "+iColor
      endif
      iColor = 20
      '/// change background in stylist ///'
      if (fGetSetPageBackground (iColor,0) <> iColor) then
         warnlog "Stylist background was not changed as expected :-( "+iColor
      endif
      sleep 1
      '/// check if background is same in format menu ///'
      if (fGetSetPageBackground (0,1) <> iColor) then
         warnlog "Format menu background is wrong :-( "+iColor
      endif

      hCloseDocument
      sleep 2
    next i
endcase

function fGetSetPageBackground (iSelect as integer, iWhere as integer) as integer
'/// Get or Set the Page Background via stylist (iWhere = 0) or format menue (...= 1) ///'
'///+ if iSelect > 0 then set, else get ///'
'///+ return selected color number or -1 on error ///'

   if (iWhere = 0) then
      '/// Stylist -> Background -> Kontext menu -> modify -> Area -> Color ///'
      fGetSetPageBackground = -1 ' worst case
      Kontext "Stylist"
      if Stylist.NotExists (5) then
         FormatStylist
        Kontext "Stylist"
        if Stylist.NotExists (5) then warnlog "Could not open stylist :-("
      end if
      Praesentationsvorlagen.Click
      sleep 1
      hDoubleClickInList (vorlagenliste, glLocale(5), TRUE)
      sleep 1
      vorlagenliste.OpenContextMenu
      sleep 1
      hMenuSelectNr (1)
   else
      '/// Format -> Page -> Background -> Color ///''FormatPage
      sleep 1
      try          ' this was just paranoia to find a not mentioned messagebox
         FormatSlideDraw
      catch
         warnlog "slooooow slot TBO :-("
         exit function
      endcatch
      sleep 1
      Kontext
      if (active.getrt = 373) then
        Active.SetPage TabArea
      else
         warnlog active.getrt
         if (active.getrt = 304) then
         warnlog active.gettext
         endif
      endif        ' paranoia end ----------------------------------------------
   endif

   kontext "TabArea"
   if TabArea.exists then
      FillOptions.Select 2 ' Select "Colour"
      if (iSelect > 1) then   ' Select the entry
'         Color.Check
         if (iSelect < ColourList.GetItemCount) then
            ColourList.Select iSelect
         else
            warnlog "Select entry is larger than list :-("
         endif
         fGetSetPageBackground = ColourList.GetSelIndex
         TabArea.OK
         sleep 2
         kontext
         if (active.exists (2)) then
            warnlog "active about <changing the background for all pages ?>: '" + active.gettext + "'"
            active.yes
         else
            printlog "No message about 'changing the background for all pages ?' :-("
         endif
      else ' yust read the selected entry
         if FillOptions.GetSelIndex = 2 then
            fGetSetPageBackground = ColourList.GetSelIndex
            TabArea.Cancel
         else
            warnlog "Can't get value, because something different than color is selected :-("
         endif
      endif
   else
      warnlog "Error: Can't get context menu ?"
   endif

   if (iWhere = 0) then
        sleep 1 ' ABSOLUT NECESSARRY !!! (TBO) else crash on UNIX on following command!!!!
        FormatStylist ' closing
   endif
   sleep 4
end function
