'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: i_opt_1_.inc,v $
'*
'*  $Revision: 1.9 $
'*
'*  last change: $Author: fredrikh $ $Date: 2005/12/02 11:59:50 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* Owner : fredrik.haegg@sun.com
'*
'* short description :
'*
'*******************************************************************
' #1 tiAlwaysWithCurrentPage
'\******************************************************************

testcase tiAlwaysWithCurrentPage()
    dim i as integer

    hCloseDocument()
    '/// open file 'impdraw\\level1\\input\\diashow.sxi' ///'
    hDateiOeffnen  ConvertPath (gTesttoolPath + "graphics\input\diashow.sxi")
    sleep 10
    ' check if the document is writable
    if fIsDocumentWritable = false then
        ' make the document writable and check if it's succesfull
        if fMakeDocumentWritable = false then
            warnlog "The document can't be make writeable. Test stopped."
            goto endsub
        endif
    endif
    '///<b> test with default option </b>///'
    printlog "Checked: 'Always with current page' - default"
'    if (setStartCurrentPage(true) <> true) then
'        qaerrorlog "presupposition not met; checked now: 'Always with current page'"
'    endif
    setStartCurrentPage(true)
    Kontext "NavigatorDraw"
    if NavigatorDraw.exists (5) then
        warnlog "presupposition not met: navigator should be closed on loading the document!"
    else
        EditNavigator
    endif

    '/// presupposition: after loading we are on slide one ///'
    i = fGetSlideNumber()
    if (i<>1) then
        warnlog "Presupposition not met. After loading the file not the first slide is up. It is number: " + i
    endif
    '/// press Key [Page Down] two times to get to slide number three ///'
    hTypeKeys ("<home><PageDown><PageDown>")
    '/// start the slideshow with 'Slide Show->Slide Show' ///'
    SlideShowSlideshow
        kontext "DocumentPresentation"
        '/// open the navigator Edit->Navigator ///'
            Kontext "NavigatorDraw"
            if (not NavigatorDraw.exists(5)) then
                EditNavigator
            endif
            '/// the slideshow has to start on slide 3 ///'
            for i = 3 to 4
                Kontext "NavigatorDraw"
                if (not NavigatorDraw.exists(5)) then
                    EditNavigator
                endif
                fGetSlideNumber(i)
                DocumentPresentation.TypeKeys "<pagedown>"
                sleep 5
            next i
            try
                DocumentPresentation.mousedown (50,50,1)
                DocumentPresentation.mouseup (50,50,1)
            catch
                warnlog "TimeOut on pressing mouse button."
            endcatch
            try
                gMouseClick 50,50  ' this one works to recognice the not ending !
                Printlog "- Slideshow ended at the right time"
            catch
                Warnlog "- Slideshow still running "
                kontext "DocumentPresentation"
                DocumentPresentation.TypeKeys "<ESCAPE>"
            endcatch
            sleep 2

    '///<b> test with changed option </b>///'
    setStartCurrentPage(false)
    printlog "UnChecked: 'Always with current page'"
    '/// press Key [Home] to get to the first slide ///'
    kontext "DocumentImpress"
    hTypeKeys "<ESCAPE>"           '/// Deselect object ///'
    hTypeKeys "<home>"
    Kontext "NavigatorDraw"
    if (not NavigatorDraw.exists(5)) then
       EditNavigator
    endif
    i = fGetSlideNumber()
    if (i<>1) then
        warnlog "Presupposition not met. Not the first slide is up. It is number: " + i
    endif
    '/// press Key [Page Down] two times to get to slide number three ///'
    hTypeKeys ("<PageDown><PageDown>")
    '/// start the slideshow with 'Slide Show->Slide Show' ///'
    SlideShowSlideshow
        kontext "DocumentPresentation"
        '/// open the navigator Edit->Navigator ///'
            Kontext "NavigatorDraw"
            if (not NavigatorDraw.exists(5)) then
                EditNavigator
            endif
            '/// the slideshow has to start on slide 1 ///'
            for i = 1 to 4
            Kontext "NavigatorDraw"
            if (not NavigatorDraw.exists(5)) then
                EditNavigator
            endif
                fGetSlideNumber(i)
                DocumentPresentation.TypeKeys "<pagedown>"
                sleep 5
            next i
            DocumentPresentation.TypeKeys "<pagedown>"
            try
                gMouseClick 50,50  ' this one works to recognice the not ending !
                Printlog "- Slideshow ended at the right time"
            catch
                Warnlog "- Slideshow still running "
                kontext "DocumentPresentation"
                DocumentPresentation.TypeKeys "<ESCAPE>"
            endcatch
            sleep 2
            Kontext "NavigatorDraw"
            if (not NavigatorDraw.exists(5)) then
                EditNavigator
            endif
            i = fGetSlideNumber()
            if (i<>3) then
                qaerrorlog "#i56779# - We are not on the starting slide number three after ending the slideshow. It is number: " + i
            endif

    '/// close the navigator Edit->Navigator ///'
    Kontext "NavigatorDraw"
    if NavigatorDraw.exists(5) then
        EditNavigator
    endif

    '///<b> restore the changed option </b>///'
    printlog "Restore: check 'Always with current page'"
    setStartCurrentPage(true)
    hCloseDocument
    hNewDocument()
endcase

function fGetSlideNumber (optional sCompare as integer) as integer
    '/// PRESUPPOSITION: open Navigator ///'
    '///+ ENTRY: with or without a string ///'
    '///+ if string is given, it is compared with the actual selected slidename in the navigator, if not equal print warnlog ///'
    '///+ RETURN:  selected slidename in the navigator / empty string if navvigator is not open ///'
    '///+ EXIT: kontext on  DocumentPresentation ///'

    Kontext "NavigatorDraw"
    if NavigatorDraw.exists (5) then
        EditNavigator ' to Workaround not updated navi :-(
        sleep 3
        EditNavigator
        sleep 3
        '/// check in list, if the page changed ///'
        fGetSlideNumber = val (right (Liste.GetSelText, 1))
    else
        warnlog "Navigator not open! in function fGetSlideNumber"
        fGetSlideNumber = ""
    endif
    if (isMissing (sCompare) = False) then ' if optional parameter exists
        if fGetSlideNumber <> sCompare then
            Warnlog "Slide Number is '" + fGetSlideNumber + "'; should: '" + sCompare + "'"
        endif
    endif
    Kontext "DocumentPresentation"
end function

