'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: w_autotext.inc,v $
'*
'*  $Revision: 1.9 $
'*
'*  last change: $Author: hde $ $Date: 2006/02/08 10:56:13 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : helge.delfs@sun.com
'*
'* short description : Test of autotext in writer
'*
'************************************************************************
'*
' #1 tEditAutotext_1
' #1 tEditAutotext_2
' #1 tEditAutotext_3
'*
'\***********************************************************************


sub w_autotext

    Call tEditAutotext_1  ' Create a new Autotext
    Call tEditAutotext_2  ' Create a new autotext (Text only)
    Call tEditAutotext_3

end sub



testcase tEditAutotext_1
    Dim j as integer, sAll as integer, i as integer
    Dim Vergleich1$,Vergleich2$,Vergleich3$,Vergleich4$
    Printlog "- Create a new autotext with content!"
    '/// New Writerdocument ///
    Call hNewDocument
    '/// Create a new autotext category
    if wCreateAutotextCategory( "AANewCategory" ) = false then
        Warnlog "Unable to create new Autotext category"
        Kontext "Autotext"
        if Autotext.Exists then Autotext.Close
        Call hCloseDocument
        goto endsub
    endif       
    wait 500
    Kontext "Autotext"
    Autotext.Close
    
    '/// Insert some text and format text ///
    Call wDokSchreiben("This becomes an autotext!")
    ' Format word 'This'
    Call wDokSchreiben("<Home><Right>")
    FormatCharacter
    Kontext
    Active.SetPage TabFont
    kontext "TabFont"
    if gAsianSup = True then
        FontWest.Select 5
        if StyleWest.GetItemCount >= 3 then
            StyleWest.Select 3
        else
            For i = 6 to FontWest.GetItemCount
                FontWest.Select i
                try
                    StyleWest.Select 3
                    exit for
                catch
                endcatch
            next i
        endif
        Vergleich1$ = FontWest.GetSelText                
        Vergleich2$ = StyleWest.GetSelText
        SizeWest.Select 5
        Vergleich3$ = SizeWest.GetSelText
    else
        Font.Select 5
        if Style.GetItemCount >= 3 then
            Style.Select 3
        else
            For i = 6 to Font.GetItemCount
                Font.Select i
                try
                    Style.Select 3
                    exit for
                catch
                endcatch
            next i
        endif
        Vergleich1$ = Font.GetSelText
        Vergleich2$ = Style.GetSelText
        Size.Select 5
        Vergleich3$ = Size.GetSelText
    endif
    wait 100
    Kontext
    Active.Setpage TabHyperlinkZeichen
    Kontext "TabHyperlinkZeichen"
    UrlName.Settext "http://www.irgendwas.de"
    TargetFrame.Select 2
    Vergleich4$ = TargetFrame.GetSelText
    TabHyperlinkZeichen.Ok

    Call wDokSchreiben("<End>")
    Call wDokSchreiben("<Shift Home>")

    '/// Call Edit / Autotext ///
    EditAutotext
    Kontext "Active"
    if Active.Exists then
        QAErrorlog Active.Gettext
        Active.Ok
    endif
    Kontext "Autotext"
    '/// Uncheck 'Preview and Select first group in List ///
    Vorschau_anzeigen.Uncheck
    Kontext "Autotext"
    if wSelectAutotextCategory( "AANewCategory" ) = false then
        Warnlog "Unable to select Autotext category"
        Kontext "Autotext"
        if Autotext.Exists then Autotext.Close
        Call hCloseDocument
        goto endsub
    endif  
    wait 500

    '/// Insert a name for the Autotext and a Shortcut ///
    NameText.Settext "HDEAutotext"
    Kuerzel.Settext "HDE"
    '/// Select 'New' in Menubutton 'Autotext' ///
    wait 500   
    if Menue.IsEnabled then 
        Menue.Click
    else
        Warnlog "Unable to create autotext->Button 'Autotext' is disabled"
        Autotext.Close
        Call hCloseDocument
        goto endsub
    endif
    
    wait 500
    try
        Call hMenuSelectNr ( 1 )
    catch
        Warnlog "Menu Autotext->'New' disabled ! Test failed !"
        Call hMenuClose
        Kontext "Autotext"
        Autotext.Cancel
        Call hCloseDocument
        goto endsub
    endcatch
    '/// Check if Autotext has been added to list ///
    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            Warnlog "Unable to add autotext: " + Active.Gettext
            Active.Ok
            Kontext "Autotext"
            Autotext.Cancel
            Call hCloseDocument
            goto endsub
        endif
    endif

    Kontext "Autotext"
    Liste.Select 1
    for j=1 to 10
        Liste.TypeKeys "-"
        Liste.TypeKeys "<Down>"
        wait 500
    next j

    Liste.Select 1
    Liste.TypeKeys "+"

    sAll = Liste.GetItemCount
    For j = 1 to sAll
        Liste.TypeKeys "<Down>"
        if Liste.Gettext = "HDEAutotext" then
            printlog "Autotext has been found!"
            Autotext.Ok
            j = sAll + 2
        endif
    next j
    '/// Check if content has been added to named autotext ///
    Kontext "Autotext"
    if Autotext.Exists then
        Warnlog "New autotext has not been found!"
        Autotext.Close
    else
        Call wDocSetContext
        Call wDokSchreiben("<Shift Home>")
        EditCopy
        if GetClipboardtext <> "This becomes an autotext!" then
            Warnlog "Autotext has no content!"
        else
            Call wDokSchreiben ("<Home><Right>")
            FormatCharacter
            Kontext
            Active.SetPage TabFont
            Kontext "TabFont"
            if gAsianSup = True then
                if Vergleich1$ <> FontWest.GetSelText then Warnlog "Wrong Font in Autotext!"
                if Vergleich2$ <> StyleWest.GetSelText then Warnlog "Wrong Fontstyle in Autotext!"
                if Vergleich3$ <> SizeWest.GetSelText then Warnlog "Wrong Fontsize in Autotext!"
            else
                if Vergleich1$ <> Font.GetSelText then Warnlog "Wrong Font in Autotext!"
                if Vergleich2$ <> Style.GetSelText then Warnlog "Wrong Fontstyle in Autotext!"
                if Vergleich3$ <> Size.GetSelText then Warnlog "Wrong Fontsize in Autotext!"
            endif
            wait 100
            Kontext
            Active.Setpage TabHyperlinkZeichen
            Kontext "TabHyperlinkZeichen"
            if UrlName.Gettext <> "http://www.irgendwas.de/" then Warnlog "Wrong hyperlink has been added to text!"
            if Vergleich4$ <> TargetFrame.GetSelText then Warnlog "Wrong targetFrame has been added to text!"
            TabHyperlinkZeichen.Cancel
        endif
    endif

    '/// Delete whole category with created autotext ///
    Call wDeleteAutotextCategory( "AANewCategory" )
    Kontext "Autotext"
    if Autotext.Exists then Autotext.Close
    Call hCloseDocument

endcase

'---------------------------------------------------

testcase tEditAutotext_2
    Dim j as integer, sAll as integer, i as integer
    Dim Vergleich1$,Vergleich2$,Vergleich3$,Vergleich4$
    Printlog "- Create a new autotext with content! (Text only)"
    '/// New Writerdocument ///
    Call hNewDocument
    '/// Create a new autotext category
    if wCreateAutotextCategory( "AANewCategory" ) = false then
        Warnlog "Unable to create new Autotext category"
        Kontext "Autotext"
        if Autotext.Exists then Autotext.Close
        Call hCloseDocument
        goto endsub
    endif       
    wait 500
    Kontext "Autotext"
    Autotext.Close
    Call wDocSetContext
    '/// Insert some text and format text ///
    Call wDokSchreiben("This becomes an autotext!")
    ' Format word 'This'
    Call wDokSchreiben("<Home><Right>")
    FormatCharacter
    Kontext
    Active.SetPage TabFont
    kontext "TabFont"
    if gAsianSup = true then
        FontWest.Select 5
        if StyleWest.GetItemCount >= 3 then
            StyleWest.Select 3
        else
            For i = 6 to FontWest.GetItemCount
                FontWest.Select i
                try
                    StyleWest.Select 3
                    exit for
                catch
                endcatch
            next i
        endif
        Vergleich1$ = FontWest.GetSelText
        Vergleich2$ = StyleWest.GetSelText
        SizeWest.Select 5
        Vergleich3$ = SizeWest.GetSelText
    else
        Font.Select 5
        if Style.GetItemCount >= 3 then
            Style.Select 3
        else
            For i = 6 to Font.GetItemCount
                Font.Select i
                try
                    Style.Select 3
                    exit for
                catch
                endcatch
            next i
        endif
        Vergleich1$ = Font.GetSelText
        Vergleich2$ = Style.GetSelText
        Size.Select 5
        Vergleich3$ = Size.GetSelText
    endif
    wait 100
    Kontext
    Active.Setpage TabHyperlinkZeichen
    Kontext "TabHyperlinkZeichen"
    UrlName.Settext "http://www.irgendwas.de"
    TargetFrame.Select 2
    Vergleich4$ = TargetFrame.GetSelText
    TabHyperlinkZeichen.Ok

    Call wDokSchreiben("<End>")
    Call wDokSchreiben("<Shift Home>")

    '/// Call Edit / Autotext ///
    EditAutotext
    Kontext "Active"
    if Active.Exists then
        QAErrorlog Active.Gettext
        Active.Ok
    endif
    Kontext "Autotext"

    '/// Uncheck 'Preview and Select first group in List ///
    Vorschau_anzeigen.Uncheck
    Kontext "Autotext"
    if wSelectAutotextCategory( "AANewCategory" ) = false then
        Warnlog "Unable to select Autotext category"
        Kontext "Autotext"
        if Autotext.Exists then Autotext.Close
        Call hCloseDocument
        goto endsub
    endif  
    wait 500

    '/// Insert a name for the Autotext and a Shortcut ///
    NameText.Settext "HDEAutotext"
    Kuerzel.Settext "HDE"
    '/// Select 'New' in Menubutton 'Autotext' ///
    wait 500
    Menue.Click
    wait 500
    try
        Call hMenuSelectNr ( 2 )
    catch
        Warnlog "Menu Autotext->'New' disabled ! Test failed !"
        Call hMenuClose
        Kontext "Autotext"
        Autotext.Cancel
        Call hCloseDocument
        goto endsub
    endcatch
    '/// Check if Autotext has been added to list ///
    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            Warnlog "Unable to add autotext: " + Active.Gettext
            Active.Ok
            Kontext "Autotext"
            Autotext.Cancel
            Call hCloseDocument
            goto endsub
        endif
    endif


    Kontext "Autotext"
    Liste.Select 1
    for j=1 to 10
        Liste.TypeKeys "-"
        Liste.TypeKeys "<Down>"
        wait 500
    next j

    Liste.Select 1
    Liste.TypeKeys "+"

    sAll = Liste.GetItemCount
    For j = 1 to sAll
        Liste.TypeKeys "<Down>"
        if Liste.Gettext = "HDEAutotext" then
            printlog "Autotext has been found!"
            Autotext.Ok
            j = sAll + 2
        endif
    next j
    '/// Check if content has been added to named autotext ///
    Kontext "Autotext"
    if Autotext.Exists then
        Warnlog "New autotext has not been found!"
        Autotext.Close
    else
        Call wDocSetContext
        Call wDokSchreiben("<Home><Up>" , 4)
        Call wDokSchreiben("<Shift End>")
        EditCopy
        if GetClipboardtext <> "This becomes an autotext!" then
            Warnlog "Autotext has no content!"
        else
            Call wDokSchreiben ("<Home><Right>")
            FormatCharacter
            Kontext
            Active.SetPage TabFont
            Kontext "TabFont"
            if gAsianSup = true then
                if Vergleich1$ = FontWest.GetSelText then Warnlog "Wrong Font in Autotext!"
                if Vergleich2$ = StyleWest.GetSelText then Warnlog "Wrong Fontstyle in Autotext!"
                if Vergleich3$ = SizeWest.GetSelText then Warnlog "Wrong Fontsize in Autotext!"
            else
                if Vergleich1$ = Font.GetSelText then Warnlog "Wrong Font in Autotext!"
                if Vergleich2$ = Style.GetSelText then Warnlog "Wrong Fontstyle in Autotext!"
                if Vergleich3$ = Size.GetSelText then Warnlog "Wrong Fontsize in Autotext!"
            endif
            wait 100
            Kontext
            Active.Setpage TabHyperlinkZeichen
            Kontext "TabHyperlinkZeichen"
            if UrlName.Gettext = "http://www.irgendwas.de/" then Warnlog "Wrong hyperlink has been added to text!"
            if Vergleich4$ = TargetFrame.GetSelText then Warnlog "Wrong targetFrame has been added to text!"
            TabHyperlinkZeichen.Cancel
        endif
    endif

    '/// Delete whole category with created autotext ///
    Call wDeleteAutotextCategory( "AANewCategory" )
    Kontext "Autotext"
    if Autotext.Exists then Autotext.Close
    Call hCloseDocument

endcase

'---------------------------------------------------

testcase tEditAutotext_3
    Dim i as Integer
    Dim j as Integer
    Dim AlterWert as String
    Dim hauMatsch as integer

    '/// Edit / Autotext ///
    PrintLog "- Edit / Autotext"
    '/// New document ///
    Call  hNewDocument
    '/// Select Edit / Autotext ///
    EditAutotext
    Kontext "Active"
    if Active.Exists then
        QAErrorlog Active.Gettext
        Active.Ok
    endif

    printlog "  - Select and Insert all Autotexts "
    '/// Select and Insert all autotexts ///
    Sleep 1
    Kontext "AutoText"
    Vorschau_anzeigen.Uncheck
    Liste.Select 1
    for j=1 to 10
        Liste.TypeKeys "-"
        Liste.TypeKeys "<Down>"
        wait 500
    next j

    hauMatsch = Liste.GetItemCount

    for i = 1 to hauMatsch
        Liste.Select 1
        for j=1 to Liste.GetItemCount
            Liste.TypeKeys "-"
            Liste.TypeKeys "<Down>"
            wait 500
        next j
        Vorschau_anzeigen.Check

        Liste.Select i
        Liste.TypeKeys "+"

        Call tCheckAutotextInGroup(Liste.GetItemCount-hauMatsch,i)

    next i

    '/// Create a new categorie ///
    printlog "  - Create new categorie"

    Liste.Select 1
    for j=1 to hauMatsch
        Liste.TypeKeys "-"
        Liste.TypeKeys "<Down>"
        wait 500
    next j
    Liste.Select 1
    Liste.TypeKeys "+"        ' Grundzustand wieder herstellen

    '/// Select 'Categories' ///
    Bereiche.Click
    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            QAErrorlog Active.Gettext
            Active.Ok
        endif
    endif    
    Kontext "BereicheBearbeitenAutoText"
    Bereich.SetText "AAAAAA"
    if gClient=true then Pfad.Select Convertpath(gOfficepath + "user\autotext")
    '/// In dialog click 'New' ///
    if Neu.IsEnabled then
        Neu.Click
    else
        if gNetzInst = False then
            Warnlog "Categorie couldn't be inserted (Button 'New' is disabled, no further Test!"
        else
            Printlog "No creating of Categories in Network-Installation!"
        endif
        goto endsub
    endif
    Sleep 1
    '/// Close dialog and check if categorie has been created ///
    BereicheBearbeitenAutoText.OK
    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            QAErrorlog Active.Gettext
            Active.Ok
        endif
    endif    
    Kontext "AutoText"
    Liste.Select 1
    if Liste.GetText <> "AAAAAA" then
        Warnlog "New categorie hasn't been created"
        goto endsub
    else
        AutoText.Close
        EditAutotext
        Kontext "Active"
        if Active.Exists then Active.Ok
            Kontext "AutoText"
            Liste.Select 1
            if Liste.GetText <> "AAAAAA" then
                Warnlog "New categorie has been deleted ( after closing and reopening dialog )"
                goto endsub
            endif
    endif

    '/// Rename the new categorie ///
    printlog "  -  Rename new categorie!"
    '/// Select 'Categories' ///
    Bereiche.Click
    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            QAErrorlog Active.Gettext
            Active.Ok
        endif
    endif        
    Kontext "BereicheBearbeitenAutoText"
    Bereich.SetText "AAAAAArrghh"
    Wait 500
    '/// In dialog click 'rename' ///
    if Umbenennen.IsEnabled then
        Umbenennen.Click
        BereicheBearbeitenAutoText.OK
        Kontext "Active"
        if Active.Exists then
            if Active.GetRT = 304 then
                QAErrorlog Active.Gettext
                Active.Ok
            endif
        endif            
    else
        Warnlog "Categorie couldn't be renamed (Button is disabled), no further test!"
        Bereich.SetText "AAAAAA"
        if Loeschen.IsEnabled then
            Loeschen.Click      ' versuchen den Eintrag zu l�schen
            BereicheBearbeitenAutoText.OK
            Kontext "MessageBox"
            if MessageBox.Exists(2) then MessageBox.Yes
            Kontext "Active"
            if Active.Exists then
                if Active.GetRT = 304 then
                    QAErrorlog Active.Gettext
                    Active.Ok
                endif
            endif                
        endif
        goto endsub
        '/// Close dialog and check if Categorie has been renamed ///
    endif

    Sleep 1
    Kontext "AutoText"
    Liste.Select 1
    if Liste.GetText <> "AAAAAArrghh" then
        Warnlog "Categorie hasn't been correctly renamed"
        AlterWert=Liste.Gettext
    else
        AutoText.Close
        EditAutotext
        Kontext "Active"
        if Active.Exists then Active.ok
        Kontext "AutoText"
        Liste.Select 1
        if Liste.GetText <> "AAAAAArrghh" then
            Warnlog "Renamed categorie doesn't exist ( after closing and reopening the dialog )"
            AlterWert=Liste.Gettext
            goto endsub
        endif
    endif
    AlterWert=Liste.Gettext

    '/// Delete new categorie ///
    printlog "  - Delete new categorie"
    '/// Select 'Categories' ///
    Bereiche.Click
    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            QAErrorlog Active.Gettext
            Active.Ok
        endif
    endif        
    Kontext "BereicheBearbeitenAutoText"
    Bereich.SetText AlterWert
    '/// Select 'Delete', close document and check if categorie has been deleted ///
    if Loeschen.IsEnabled then
        Loeschen.Click
    else
        Warnlog "Categorie couldn't be deleted (Button is disabled)!"
    endif

    BereicheBearbeitenAutoText.OK
    Kontext "MessageBox"
    if Not MessageBox.Exists(2) then
        Warnlog "No messsage after deleting Categorie and closing the Dialog !"
    else
        MessageBox.No
        Kontext "Active"
        if Active.Exists then
            if Active.GetRT = 304 then
                QAErrorlog Active.Gettext
                Active.Ok
            endif
        endif    
        Kontext "AutoText"
        Liste.Select 1
        if Liste.GetText <> AlterWert then
            Warnlog "After denying the 'Deletemessage' the categorie has been deleted!"
        else
            Bereiche.Click
            Kontext "Active"
            if Active.Exists then
                if Active.GetRT = 304 then
                    QAErrorlog Active.Gettext
                    Active.Ok
                endif
            endif                
            Kontext "BereicheBearbeitenAutoText"
            Bereich.SetText AlterWert
            if Loeschen.IsEnabled then
                Loeschen.Click
                BereicheBearbeitenAutotext.Ok
                Kontext "MessageBox"
                if MessageBox.Exists(2) then MessageBox.Yes
                Kontext "Active"
                if Active.Exists then
                    if Active.GetRT = 304 then
                        QAErrorlog Active.Gettext
                        Active.Ok
                    endif
                endif                    
                Sleep 2
                Kontext "AutoText"
                Liste.Select 1
                if Liste.GetText = AlterWert then Warnlog "Though the categorie has been deleted it is always there!"
            else
                Warnlog "Area couldn't be deleted (Button is disabled)!"
            endif
        endif
    endif

    printlog "  - Insert Autotext with ShortCuts"
    '/// try to insert  autotexts with Shotcut ///
    Kontext "Autotext"
    Autotext.Cancel

    Call wDokSchreiben "<Return>", 3
    Call wBlindtextEinfuegen

    Kontext "Active"
    if Active.Exists then
        QAErrorlog Active.GetText
        Active.OK
    end if
    Sleep 1
    Call wDokSchreiben "<Mod1 A>"
    Sleep 1
    EditCopy
    '/// Check if autotext has been inserted ///
    if GetClipboardText = "" then Warnlog "Autotext couldn't be inserted with Short-Cut!"

    '/// Close document ///
    Call hCloseDocument
endcase
