'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: w_fields.bas,v $
'*
'*  $Revision: 1.7 $
'*
'*  last change: $Author: jsi $ $Date: 2006/01/18 14:41:12 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner :  helge.delfs@sun.com
'*
'* short description : Test of content and update reliability of the fields 
'*
'\*******************************************************************

global gSeperator , gMeasurementUnit as String

sub main

   Dim StartZeit
   Dim sLocaleSetting , sWestern , sAsian  as String
   Dim bAsianLanguage                      as Boolean
   
   StartZeit = Now()

   use "writer\tools\inc\w_tools.inc"
   use "writer\tools\inc\w_tool3.inc"
   use "writer\tools\inc\w_tool7.inc"   
   use "writer\level1\inc\tools\tools1.inc"
   use "writer\level1\inc\tools\tools2.inc"
   use "writer\level1\inc\fields\w_fields1.inc"
   use "writer\level1\inc\fields\w_fields2.inc"
   use "writer\level1\inc\fields\w_fields3.inc"
   use "writer\level1\inc\fields\w_fields4.inc"
   use "writer\level1\inc\fields\w_fields5.inc"
   use "writer\level1\inc\fields\w_fields6.inc"   
   use "writer\level1\inc\fields\w_fields7.inc"   
   
   printlog Chr(13) + "Loading of Include - Files takes: " + Wielange ( StartZeit )
   printlog Chr(13) + "******* Writer - Level 1 - Test *******"

   Call hStatusIn ( "writer", "w_fields.bas" , "Fields" )

    'Software Configuration:
    'Getting the decimal seperator from global function
    gSeperator = GetDecimalSeperator()
    'Setting the measurement unit to centimeters.
    gMeasurementUnit = fSetMeasurementToCM()
     
     sLocaleSetting = fSetLocale(fGetLanguageName(1))
     sWestern       = fSetWestern(fGetLanguageName(1))
             
   printlog Chr(13) + " --- Test Fields - General Test ---"
           
      Call tFields_1
      Call tFields_2
      Call tFields_3
      Call tFields_4
      Call tFields_5
      Call tFields_6
      Call tFields_7

      Call tFieldsOther_0
      Call tFieldsOther_1_1
      Call tFieldsOther_1_2
      Call tFieldsOther_2
      Call tFieldsOther_3
      Call tFieldsOther_4
      Call tFieldsOther_5
      Call tFieldsOther_6_1
      Call tFieldsOther_6_2
      Call tFieldsOther_7
      Call tFieldsOther_8
      Call tFieldsOther_9

   printlog Chr(13) + " --- Test Fields - Reference ---"

      Call tFieldsReferences     
      Call tSetReferences_1
      Call tSetReferences_2 
      Call tInsertReference_1
      Call tInsertReference_2
      Call tInsertReference_3
      Call tInsertReference_4
      Call tInsertReference_5
      Call tInsertReference_6
      Call tInsertReference_7
      Call tInsertReference_8_1
      Call tInsertReference_8_2
      Call tInsertBookmark_1
      Call tInsertBookmark_2
      Call tInsertBookmark_3
      Call tInsertBookmark_4
      Call tInsertBookmark_5

   printlog Chr(13) + " --- Test Fields - Doc information ---"

      Call tDocInformation_1     
      Call tDocInformation_2
      Call tDocInformation_3     
      Call tDocInformation_4     
      Call tDocInformation_5      
      Call tDocInformation_6
      Call tDocInformation_7_1
      Call tDocInformation_7_2
      Call tDocInformation_8
      Call tDocInformation_9
      Call tDocInformation_10
      
   printlog Chr(13) + " --- Test Fields - Variables ---"

      Call tVariables_1      
      Call tVariables_2
      Call tVariables_3
      Call tVariables_4
      Call tVariables_5
      Call tVariables_6
      Call tVariables_7
      Call tVariables_8
      Call tVariables_9
'   mark below 2 cases due to bug i33446      
'      Call tVariables_10
'      Call tVariables_11
                        
   printlog Chr(13) + " --- Test Fields - Functions ---"

      Call tFunctions_1      
      Call tFunctions_2
      Call tFunctions_3      
      Call tFunctions_4      
      Call tFunctions_5      
      Call tFunctions_6      
      Call tFunctions_7      
      Call tFunctions_8
      Call tFunctions_9
      Call tFunctions_10      
      Call tFunctions_11    
      Call tFunctions_12     
      Call tFunctions_13                        

   printlog Chr(13) + " --- Test Fields - L10N ---"

     'Set 'Asian Language support' ON
      bAsianLanguage = ActiveDeactivateAsianSupport(TRUE)
      Call tL10N_1
      Call tL10N_2
      Call tL10N_3      
      if bAsianLanguage = FALSE then 
          Call fSetLocale(fGetLanguageName(1))
          Call ActiveDeactivateAsianSupport(FALSE)
      end if

  'Recover to default             
   Call fSetLocale(sLocaleSetting)
   Call fSetWestern(sWestern)
   
   Call hStatusOut

   Printlog Chr(13) + "End of Level 1 Test - Fields"
   Printlog "Duration: "+ WieLange ( StartZeit )
   Printlog "Date: " +  Date + "    Time: " + Time

end sub

sub LoadIncludeFiles
   use "global\system\inc\master.inc"
   use "global\system\inc\gvariabl.inc"
   Call GetUseFiles
   gApplication = "Writer"
end Sub
