'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: w_003_.inc,v $
'*
'*  $Revision: 1.15 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:27:31 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*                                                                **
'* owner : helge.delfs@sun.com                                    **
'*                                                                **
'* short description :                                            **
'*                                                                **
'\******************************************************************

sub w_003_
    printLog Chr(13) + "--------- View Menu (w_003_.inc) ----------"


	Call tViewPrintLayout
	Call tViewWebLayout
    if gApplication = "HTMLDOKUMENT" then
		Call tViewHTMLSource
	endif

	Call tViewToolbars

	Call tViewStatusBar
	if Ucase(gPlatform) = "SOLARIS" then
		Call tViewInputMethodStatus
	endif
	Call tViewRuler

    Call tViewTextBoundaries
    Call tViewFieldShadings
    Call tViewFields
    Call tViewNonprintingCharacters
    Call tViewHiddenParagraphs

    Call tViewDataSources

	Call tViewFullScreen
	Call tViewZoom

end sub

'------------------------------------------------------

testcase tViewZoom
    PrintLog "- View / Zoom"

    Call hNewDocument
    '/// Open new document ///

    ViewZoom
    '/// View / Zoom ///
    Kontext "Massstab"
    if Massstab.Exists then
        DialogTest ( Massstab )
        '/// Close 'Zoom' dialog with cancel ///
        Massstab.Cancel
    else
        Warnlog "Dialog 'Zoom' does not exist."
    endif
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewDataSources
    PrintLog "- View / Data Sources"

    Call hNewDocument
    '/// Open new document ///
    ViewCurrentDatabaseWriter
    '/// View / Data Sources ///

    Sleep 5
    Kontext "DatabaseBeamer"
    if Not DatabaseBeamer.Exists then
        Warnlog "Database Beamer has not been opened!"
    else
        '/// Close database beamer with : View Data Sources ///
        ViewCurrentDatabaseWriter
        Kontext "DatabaseBeamer"
        if DatabaseBeamer.Exists then
            Warnlog "Could not close Databasebeamer with same slot!"
            ViewBeamer
            Kontext "DatabaseBeamer"
            if DatabaseBeamer.Exists then Warnlog "Could not close Databasebeamer with Slot->View Beamer!"
        endif
    end if
    Sleep 1

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tViewToolbars
    PrintLog "- View / Toolbars"
	Dim i as integer

    '/// Close all documents until only backing window is opened
    ' Close all document down to backing window
    Do Until GetDocumentCount = 0
        Call hCloseDocument
    Loop
    
    '/// Open a new writer document
    Call hNewDocument

	printlog "- Toolbar 'Align'"
	printlog "-  open"
	Call hToolbarSelect("Align", true)
	printlog "-  close"
	Call hToolbarSelect("Align", false)
	printlog "-  reset"
	Call hToolbarSelect("Align", true, true) 

	printlog "- Toolbar 'Bullets And Numbering'"
	printlog "-  open"
	Call hToolbarSelect("BulletsAndNumbering", true)
	printlog "-  close"
	Call hToolbarSelect("BulletsAndNumbering", false)
	printlog "-  reset"
	Call hToolbarSelect("BulletsAndNumbering", true, true)

	printlog "- Toolbar 'Drawing'"
	printlog "-  open"
	Call hToolbarSelect("Drawing", true)
	printlog "-  close"
	Call hToolbarSelect("Drawing", false)
	printlog "-  reset"
	Call hToolbarSelect("Drawing", true, true)
    
   	printlog "- Toolbar 'Drawing Object Properties'"
	printlog "-  open"
	Call hToolbarSelect("DrawingObjectProperties", true)
	printlog "-  close"
	Call hToolbarSelect("DrawingObjectProperties", false)
	printlog "-  reset"
	Call hToolbarSelect("DrawingObjectProperties", true, true)

   	printlog "- Toolbar 'Form Controls'"
	printlog "-  open"
	Call hToolbarSelect("FormControls", true)
	printlog "-  close"
	Call hToolbarSelect("FormControls", false)
	printlog "-  reset"
	Call hToolbarSelect("FormControls", true, true)
    
   	printlog "- Toolbar 'Form Design'"
	printlog "-  open"
	Call hToolbarSelect("FormDesign", true)
	printlog "-  close"
	Call hToolbarSelect("FormDesign", false)
	printlog "-  reset"
	Call hToolbarSelect("FormDesign", true, true)
    
   	printlog "- Toolbar 'Form Navigation'"
	printlog "-  open"
	Call hToolbarSelect("FormNavigation", true)
	printlog "-  close"
	Call hToolbarSelect("FormNavigation", false)
	printlog "-  reset"
	Call hToolbarSelect("FormNavigation", true, true)
    
	' The following toolbar is disabled because it will be found in all documents
	' therefore they can't be reactivated once deactivated
	 printlog "- Toolbar 'Formatting'"
	 printlog "-  open"
	 Call hToolbarSelect("Formatting", true)
	 printlog "-  close"
	 Call hToolbarSelect("Formatting", false)
	 printlog "-  reset"
	 Call hToolbarSelect("Formatting", true, true)
    
	printlog "- Toolbar 'Frame'"
	printlog "-  open"
	Call hToolbarSelect("Frame", true)
	printlog "-  close"
	Call hToolbarSelect("Frame", false)
	printlog "-  reset"
	Call hToolbarSelect("Frame", true, true)
    
	printlog "- Toolbar 'Insert'"
	printlog "-  open"
	Call hToolbarSelect("Insert", true)
	printlog "-  close"
	Call hToolbarSelect("Insert", false)
	printlog "-  reset"
	Call hToolbarSelect("Insert", true, true)

	printlog "- Toolbar 'Insert Object'"
	printlog "-  open"
	Call hToolbarSelect("InsertObject", true)
	printlog "-  close"
	Call hToolbarSelect("InsertObject", false)
	printlog "-  reset"
	Call hToolbarSelect("InsertObject", true, true)

	printlog "- Toolbar 'Media Playback'"
	printlog "-  open"
	Call hToolbarSelect("MediaPlayback", true)
	printlog "-  close"
	Call hToolbarSelect("MediaPlayback", false)
	printlog "-  reset"
	Call hToolbarSelect("MediaPlayback", true, true)

	printlog "- Toolbar 'OLE Object'"
	printlog "-  open"
	Call hToolbarSelect("OLEObject", true)
	printlog "-  close"
	Call hToolbarSelect("OLEObject", false)
	printlog "-  reset"
	Call hToolbarSelect("OLEObject", true, true)

	printlog "- Toolbar 'Page Preview'"
	printlog "-  open"
	Call hToolbarSelect("PagePreview", true)
	printlog "-  close"
	Call hToolbarSelect("PagePreview", false)
	printlog "-  reset"
	Call hToolbarSelect("PagePreview", true, true)
    
	printlog "- Toolbar 'Picture'"
	printlog "-  open"
	Call hToolbarSelect("Picture", true)
	printlog "-  close"
	Call hToolbarSelect("Picture", false)
	printlog "-  reset"
	Call hToolbarSelect("Picture", true, true)
    
    ' The following toolbar is disabled because it will be found in all documents
    ' therefore they can't be reactivated once deactivated
	 printlog "- Toolbar 'Standard'"
	 printlog "-  open"
	 Call hToolbarSelect("Standard", true)
	 printlog "-  close"
	 Call hToolbarSelect("Standard", false)
	 printlog "-  reset"
	 Call hToolbarSelect("Standard", true, true)
    
	printlog "- Toolbar 'Standard (Viewing Mode)'"
	printlog "-  open"
	Call hToolbarSelect("StandardViewingMode", true)
	printlog "-  close"
	Call hToolbarSelect("StandardViewingMode", false)
	printlog "-  reset"
	Call hToolbarSelect("StandardViewingMode", true, true)
    
	printlog "- Toolbar 'Table'"
	printlog "-  open"
	Call hToolbarSelect("Table", true)
	printlog "-  close"
	Call hToolbarSelect("Table", false)
	printlog "-  reset"
	Call hToolbarSelect("Table", true, true)
    
	printlog "- Toolbar 'Text Object'"
	printlog "-  open"
	Call hToolbarSelect("TextObject", true)
	printlog "-  close"
	Call hToolbarSelect("TextObject", false)
	printlog "-  reset"
	Call hToolbarSelect("TextObject", true, true)

	printlog "- Toolbar 'Tools'"
	printlog "-  open"
	Call hToolbarSelect("Tools", true)
	printlog "-  close"
	Call hToolbarSelect("Tools", false)
	printlog "-  reset"
	Call hToolbarSelect("Tools", true, true)
    
	printlog "- Toolbar 'Hyperlink Bar'"
	printlog "-  open"
	Call hToolbarSelect("HyperlinkBar", true)
	printlog "-  close"
	Call hToolbarSelect("HyperlinkBar", false)
	printlog "-  reset"
	Call hToolbarSelect("HyperlinkBar", true, true)
    
	printlog "- Toolbar 'Formula'"
	printlog "-  open"
	Call hToolbarSelect("Formula", true)
    OL_SW_Rechenleiste.TypeKeys "<Enter>"

    Call hCloseDocument
    '/// Close active document ///

    '/// Open a new default document
    Call hNewDocument
endcase

'-----------------------------------------------------------

testcase tViewTextBoundaries
    PrintLog "- View / Text Boundaries"

    Call hNewDocument
    '/// Open new document ///
    ViewTextBoundaries
    '/// View / Text Boundaries ///
    Sleep 2
    ViewTextBoundaries
    '/// View / Text Boundaries ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'------------------------------------------------------

testcase tViewFieldShadings
    PrintLog "- View / Field Shadings"

    Call hNewDocument
    '/// Open new document ///
    ViewFieldShadings
    '/// View / Field Shadings ///
    Sleep 2
    ViewFieldShadings
    '/// View / Field Shadings ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'------------------------------------------------------

testcase tViewFields
    PrintLog "- View / Fields"

    Call hNewDocument
    '/// Open new document ///
    ViewFields
    '/// View / Fields ///
    Sleep 2
    ViewFields
    '/// View / Fields ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'------------------------------------------------------

testcase tViewNonprintingCharacters
    PrintLog "- View / Nonprinting Characters"

    Call hNewDocument
    '/// Open new document ///
    ViewNonprintingCharacters
    '/// View / Nonprinting characters ///
    Sleep 2
    ViewNonprintingCharacters
    '/// View / Nonprinting characters ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewHiddenParagraphs
    printLog "- View / Hidden Paragraphs"

    Call hNewDocument
    '/// Open new document ///

    ViewHiddenParagraphs
    '/// View / Hidden paragraphs  ///
    Sleep 2
    ViewHiddenParagraphs
    '/// View / Hidden paragraphs  ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewWebLayout
    PrintLog "- View / WebLayout"

    Call hNewDocument
    '/// Open new document ///
    Sleep 2
    ViewOnlineLayout
    '/// View / Web Layout  ///
    Sleep 2
    ViewOnlineLayout
    '/// View / Online Layout  ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewFullScreen
    PrintLog "- View / Full Screen"

    Call hNewDocument
    '/// Open new document ///
    ViewFullScreen
    '/// View / Full Screen  ///
    Sleep 2
    ViewFullScreen
    '/// View / Full Screen  ///
    Sleep 2
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewPrintLayout
    PrintLog "- View / Print Layout"
    '/// ONLY HTML-Document ///

    Call hNewDocument
    '/// Open new document ///
    Sleep 2
    ViewPrintLayout
    '/// View / Print Layout  ///
    Sleep 2
    ViewPrintLayout
    '/// View / Print Layout  ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewStatusBar
    PrintLog "- View / Status Bar"

    Call hNewDocument
    '/// Open new document ///
    Sleep 2
    ViewToolbarsStatusbar
    '/// View / Statusbar  ///
    Sleep 2
    ViewToolbarsStatusbar
    '/// View / Print Layout  ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewRuler
    PrintLog "- View / Ruler"

    Call hNewDocument
    '/// Open new document ///
    Sleep 2
    ViewRuler
    '/// View / Ruler  ///
    Sleep 2
    ViewRuler
    '/// View / Ruler  ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewInputMethodStatus
    PrintLog "- View / Input Method Status"

    Call hNewDocument
    '/// Open new document ///
    Sleep 2
    try
		ViewInputMethodStatus
	catch
		Warnlog "Menuentry 'Input Method Status' is disabled!"
		Call hCloseDocument
		goto endsub
	endcatch
    '/// View / View / Input Method Status  ///
    Sleep 2
    ViewInputMethodStatus
    '/// View / View / Input Method Status  ///
    Call hCloseDocument
    '/// Close active document ///

endcase


'-----------------------------------------------------------

testcase tViewHTMLSource
    PrintLog "- View / HTML Source"
    '/// ONLY HTML-Document ///

    Call hNewDocument
    '/// Open new document ///
    Sleep 2
    AnsichtHTMLQuelltext
    '/// View / HTML-Source  ///
    Sleep 1
    '/// Save-As dialog has to come up ///
    Kontext "SpeichernDlg"
    Dateiname.Settext Convertpath(gofficepath + "user\work\sourcecode.html")
    '/// Save sourcecode ///
    Speichern.Click
    Kontext "Active"
    If Active.Exists then
        if Active.GetRT = 304 then
            try
                Active.Yes
            catch
                Warnlog Active.Gettext
                Active.Ok
            endcatch
        endif
    endif
    Sleep 2
	Kontext "DocumentHTMLSourceView"
	DocumentHTMLSourceView.TypeKeys "Check for bug: #116402"
	wait 500
    AnsichtHTMLQuelltext
    '/// View / HTML-Source  ///
    Sleep 1
    Call hCloseDocument
    '/// Close active document ///
endcase

