'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: w_006_.inc,v $
'*
'*  $Revision: 1.15 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:27:32 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : helge.delfs@sun.com
'*
'* short description : Call all functions in table menu
'*
'\***********************************************************************


sub w_006_
    printLog Chr(13) + "--------- Table Menu (w_006_.inc) ----------"


   '   Table
    Call tFormatTable
    Call tFormatSplitTables
    Call tFormatJoinTables
    Call tFormatNumberFormat
    Call tFormatCell
    Call tFormatRow
    Call tFormatAutoformatTable

	
	
end sub




testcase tFormatTable
    PrintLog "- Format / Table"

    Call hNewDocument
    '/// Open new document ///

    Call hTabelleEinfuegen
    '/// Insert a table ///

    TableProperties
    '/// Format / Table ///

    Kontext
    '/// In dialog step through all tabpages ///
    Active.SetPage TabTabelle
    Kontext "TabTabelle"
    Call DialogTest ( TabTabelle )

    Kontext
    Active.SetPage TabTextflussTabelle
    Kontext "TabTextflussTabelle"
    Call DialogTest ( TabTextflussTabelle )

    Kontext
    Active.SetPage TabSpaltenTabelle
    Kontext "TabSpaltenTabelle"
    Call DialogTest ( TabSpaltenTabelle )

    Kontext
    Active.SetPage TabUmrandung
    Kontext "TabUmrandung"
    Call DialogTest ( TabUmrandung )

    Kontext
    Active.SetPage TabHintergrund
    Kontext "TabHintergrund"
    Call DialogTest ( TabHintergrund )

    TabHintergrund.Cancel
    '/// Close dialog ///

    Call hCloseDocument
    '/// Close active document ///

endcase

'----------------------------------------------------------


testcase tFormatSplitTables
    PrintLog "- Format / Split Table"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Call wDokSchreiben ("<Mod1 a>")
    '/// Select all ///
    Sleep 1
    FormatSplitTable
    '/// Format / Split Table ///
    Kontext "TabelleAuftrennen"
    Call DialogTest ( TabelleAuftrennen )
    '/// Close dialog ///
    TabelleAuftrennen.Cancel
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tFormatJoinTables
    PrintLog "- Format / Join Table"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Call wDokSchreiben ("<Down><Down>")
    '/// Point cursor under the table ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Call wDokSchreiben ("<Down><Down>")
    '/// Point cursor under the table ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Call wDokSchreiben ("<Up><Up>")
    '/// Point cursor in 3rd table ///
    FormatMergeTables
    '/// Format / Merge Tables ///
    Kontext "TabellenVerbinden"
    Call DialogTest (TabellenVerbinden)
    '/// Close dialog ///
    TabellenVerbinden.Cancel
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tFormatNumberFormat
    printLog "- Format / Number Format"

    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Format / Number Format ///
    FormatNumberFormat
    Kontext "Zahlenformat"
    Call DialogTest ( Zahlenformat )
    '/// Close dialog ///
    Zahlenformat.Cancel
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tFormatCell
    PrintLog "- Format / Cell"

    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///

    FormatColumnSelect
    '/// Format / Column / Select ///
    FormatCellMerge
    '/// Format / Cell / Merge ///
    FormatCellSplit
    '/// Format / Cell / Split ///
    Kontext "ZellenTeilen"
    Call DialogTest ( ZellenTeilen )
    ZellenTeilen.OK
    '/// Close dialog 'Split Table' ///
    FormatCellProtect
    '/// Format / Cell / Proptect ///
    Call wDokSchreiben ("<UP>")
    '/// Format / Cell / Unprotect ///
    FormatCellUnprotect

    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tFormatRow
    PrintLog "- Format / Row"

    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '///  Insert a table ///

    FormatRowHeight
    '/// Format / Row / Height ///
    Kontext "ZellenHoehe"
    Hoehe.SetText "2,5"
    '/// Close dialog ///
    Call DialogTest ( ZellenHoehe )
    ZellenHoehe.OK

    FormatColumnSelect
    '/// Format / Column / Select ///
    Wait 500
    FormatRowSpaceEqually
    '/// Format / Row / Space equally ///
    Wait 500
    FormatRowSelect
    '/// Format / Row / Select ///
    Wait 500
    FormatRowOptimalHeight
    '/// Format / Row / Optimal Height ///
    Wait 500
    FormatRowInsert
    '/// Format / Row / Insert ///
    Kontext "EinfuegenZeilen"
    Anzahl.SetText "3"
    Call DialogTest ( EinfuegenZeilen )
    '/// Close dialog ///
    EinfuegenZeilen.OK

    FormatRowDelete
    '/// Format / Row / Delete ///

    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tFormatAutoformatTable
    PrintLog "- Format / Autoformat - Table"

    Call hNewDocument
    '/// Open new document ///
    Sleep 2
    Call hTabelleEinfuegen
    '/// Insert a table ///

    FormatAutoformat
    '/// Format / Autoformat ///
    Sleep 2

    Kontext "AutoformatTabelle"
    '/// In dialog click 'More..' ///
    Zusaetze.Click
    Call DialogTest ( AutoformatTabelle )

    Einfuegen.Click
    '/// Click 'Add' ///
    Kontext "AutoformatHinzufuegenWriter"
    Call DialogTest ( AutoformatHinzufuegenWriter )
    TabellenName.SetText "Hallo"
    '/// Enter a new table name ///
    AutoformatHinzufuegenWriter.OK

    Kontext "AutoformatTabelle"
    '/// Click 'Rename' ///
    Umbenennen.Click
    Kontext "AutoformatHinzufuegenWriter"
    Call DialogTest ( AutoformatHinzufuegenWriter )
    '/// Enter an new table name ///
    TabellenName.SetText "Hallo1"
    AutoformatHinzufuegenWriter.OK
    Kontext "AutoformatTabelle"
    Loeschen.Click
    '/// Click 'Delete' ///
    Kontext
    Active.OK

    AutoformatTabelle.Cancel
    '/// Close dialog ///

    Call hCloseDocument
    '/// Close active document ///

endcase

