'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: sxc7_03.inc,v $
'*
'*  $Revision: 1.10 $
'*
'*  last change: $Author: jsi $ $Date: 2005/10/25 10:09:37 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : XML Calc Include File
'*
'\***********************************************************************************
   Dim Isliste(250) as string
   Dim OutputPath as string
   Dim iStateMacroSecurity as integer

sub sxc7_03
    printlog "------------------- sxc_03.inc ---------------------"

    call tchart_export
    call tconditional_formatting
    call tcontrols01
    call tdatabase_ranges
    call tfilter_and_subtotals1
    call tfilter_and_subtotals4
    call tmatrixformula_and_notes
    call tpassword3
'    call tAsisanVerticalWriting 'wrn:1
'    call tNativeNumberTransliteration
end sub

'-------------------------------------------------------------------------

testcase tchart_export
    printlog "+- chart_export.sdc"
    if bDebugVersion = TRUE then
        warnlog "#41970# - Assertion in DEBUG version breaks automated testing. This testcase will be ignored."
        goto endsub
    end if
    call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\level1\input\calc\so_binary\chart_export.sdc"))
    if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\calc\level1\chart_export.sxc") , gCalc7Filter) = TRUE then
        '/// Closing the document also if there is a verification dialog.
        call hCloseAndLooseDocument
        sleep(3)
        UnpackStorage( gOfficePath & ConvertPath("user\work\xml\calc\level1\chart_export.sxc") , gOfficePath & ConvertPath("user\work\xml\calc\level1\chart_export") )
        if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\chart_export\styles.xml")) = FALSE then
            warnlog "XML-file 'styles.xml' not well formed!"
        end if
        if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\chart_export\meta.xml")) = FALSE then
            warnlog "XML-file 'meta.xml' not well formed!"
        end if
        if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\chart_export\content.xml")) = FALSE then
            warnlog "XML-file 'content.xml' not well formed!"
        else
            call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\calc\level1\chart_export.sxc"))
            sleep(2)
            call hCloseDocument
            sleep(2)
        end if
    else
        warnlog "It was not possible to save the document as XML!"
    end if
endcase

'-------------------------------------------------------------------------

testcase tconditional_formatting
  printlog "+- conditional_formatting.sdc"

  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\level1\input\calc\so_binary\conditional_formatting.sdc"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\calc\level1\conditional_formatting.sxc") , gCalc7Filter) = TRUE then
    '/// Closing the document also if there is a verification dialog.
    call hCloseAndLooseDocument
    sleep(3)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\calc\level1\conditional_formatting.sxc") , gOfficePath & ConvertPath("user\work\xml\calc\level1\conditional_formatting") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\conditional_formatting\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\conditional_formatting\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\conditional_formatting\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\calc\level1\conditional_formatting.sxc"))
      sleep(2)
      call hCloseDocument
      sleep(2)
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase tcontrols01
    Dim cWhereCalled as string
    
    printlog "+- controls01.sdc"

    cWhereCalled = "xml::level1::inc::sxc7_03.inc::tcontrols01: "
      
    '/// Open Tools/Options -> OpenOffice.org/Security
    ToolsOptions   
    Call hToolsOptions( "Staroffice" , "Security" )    
    '/// Click on the macro security button
    Kontext "TabSecurity"
    MacroSecurity.Click    
    '/// Ensure we are on the Security Level page
    Kontext
    Active.SetPage TabSecurityLevel    
    Kontext "TabSecurityLevel"
    '/// Set the <b>medium</b> security level    
    medium.Check
    '/// Close Tools/Options    
    TabSecurityLevel.OK    
    Kontext "OptionenDLG"
    OptionenDLG.OK
    
        call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\level1\input\calc\so_binary\controls01.sdc") , 1)
        printlog "- Accepting to run macro"
    
        Kontext "SecurityWarning"
        if SecurityWarning.Exists(1) then
            SecurityWarning.OK
        else
            warnlog "No Macro Security Warning occoured while loading 'controls01.sdc'."
            QAErrorLog "Macro Security level: " & iStateMacroSecurity    
        end if
        sleep(2)  
        if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\calc\level1\controls01.sxc") , gCalc7Filter) = TRUE then
        '/// Closing the document also if there is a verification dialog.
            call hCloseAndLooseDocument
            sleep(3)
            UnpackStorage( gOfficePath & ConvertPath("user\work\xml\calc\level1\controls01.sxc") , gOfficePath & ConvertPath("user\work\xml\calc\level1\controls01") )
            if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\controls01\styles.xml")) = FALSE then
                warnlog "XML-file 'styles.xml' not well formed!"
            end if
            if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\controls01\meta.xml")) = FALSE then
                warnlog "XML-file 'meta.xml' not well formed!"
            end if
            if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\controls01\content.xml")) = FALSE then
                warnlog "XML-file 'content.xml' not well formed!"
            else
                call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\calc\level1\controls01.sxc") , 1)
                '/// Accept the security warning and enable executing the macros.
                Kontext "SecurityWarning"
                if SecurityWarning.Exists(1) then
                    SecurityWarning.OK
                else
                    warnlog "No Macro Security Warning occoured while loading 'controls01.sxc'."
                end if
                sleep(2)
                call hCloseDocument
                sleep(2)
            end if
        else
            warnlog "It was not possible to save the document as XML!"
        end if
    
endcase

'-------------------------------------------------------------------------

testcase tdatabase_ranges
  printlog "+- database_ranges.sdc"

  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\level1\input\calc\so_binary\database_ranges.sdc"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\calc\level1\database_ranges.sxc") , gCalc7Filter) = TRUE then
    '/// Closing the document also if there is a verification dialog.
    call hCloseAndLooseDocument
    sleep(3)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\calc\level1\database_ranges.sxc") , gOfficePath & ConvertPath("user\work\xml\calc\level1\database_ranges") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\database_ranges\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\database_ranges\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\database_ranges\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\calc\level1\database_ranges.sxc"))
      sleep(2)
      call hCloseDocument
      sleep(2)
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase tfilter_and_subtotals1
  printlog "+- filter_and_subtotals1"

  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\level1\input\calc\so_binary\filter_and_subtotals1.sdc"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals1.sxc") , gCalc7Filter) = TRUE then
    '/// Closing the document also if there is a verification dialog.
    call hCloseAndLooseDocument
    sleep(3)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals1.sxc") , gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals1") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals1\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals1\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals1\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals1.sxc"))
      sleep(2)
      call hCloseDocument
      sleep(2)
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase tfilter_and_subtotals4
  printlog "+- filter_and_subtotals4.sdc"

  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\level1\input\calc\so_binary\filter_and_subtotals4.sdc"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals4.sxc") , gCalc7Filter) = TRUE then
    '/// Closing the document also if there is a verification dialog.
    call hCloseAndLooseDocument
    sleep(3)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals4.sxc") , gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals4") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals4\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals4\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals4\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\calc\level1\filter_and_subtotals4.sxc"))
      sleep(2)
      call hCloseDocument
      sleep(2)
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase tmatrixformula_and_notes
  printlog "+- matrixformula_and_notes.sdc"

  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\level1\input\calc\so_binary\matrixformula_and_notes.sdc"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\calc\level1\matrixformula_and_notes.sxc") , gCalc7Filter) = TRUE then
    '/// Closing the document also if there is a verification dialog.
    call hCloseAndLooseDocument
    sleep(3)     
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\calc\level1\matrixformula_and_notes.sxc") , gOfficePath & ConvertPath("user\work\xml\calc\level1\matrixformula_and_notes") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\matrixformula_and_notes\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\matrixformula_and_notes\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\matrixformula_and_notes\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\calc\level1\matrixformula_and_notes.sxc"))
      sleep(2)
      call hCloseDocument
      sleep(2)
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase tpassword3
  printlog "+- password3.sdc"

  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\level1\input\calc\so_binary\password3.sdc"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\calc\level1\password3.sxc") , gCalc7Filter) = TRUE then
    '/// Closing the document also if there is a verification dialog.
    call hCloseAndLooseDocument
    sleep(3)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\calc\level1\password3.sxc") , gOfficePath & ConvertPath("user\work\xml\calc\level1\password3") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\password3\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\password3\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\calc\level1\password3\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\calc\level1\password3.sxc"))
      sleep(2)
      call hCloseDocument
      sleep(2)
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase tAsisanVerticalWriting
'TODO: Complete the test tAsisanVerticalWriting.
'/// <h2>Asian vertical writing in Spreadsheet cells</h2>
'/// <h3>Test description</h3>
 call hNewDocument
 gApplication = "CALC"
'/// Enable the Asian language support under <i>Tools / Options / Language Settings</i>
 ToolsOptions
 call hToolsOptions ("LanguageSettings" , "Languages" )
 Kontext "TabSprachen"
  if Aktivieren.IsChecked then
    printlog "+- Asian language support was already enabled,"
   else
    Aktivieren.Check
    printlog "+- Asian language support has been enabled."
  end if
 Kontext "ExtrasOptionenDlg"
  ExtrasOptionenDlg.OK
  sleep(1)  
'/// Open a new Calc document and select a range of cells (A1:D10).
 call hNewDocument
 Kontext "DocumentCalc"
  DocumentCalc.TypeKeys "<SHIFT RIGHT>" , 3
  DocumentCalc.TypeKeys "SHIFT DOWN>" , 9  
'/// Now open the context menu or use main menu entry <i>format / cells</i>.
  FormatCells
'/// Switch to the <i>Tab Page Alignment</i>
   Kontext
    Active.SetPage TabAusrichtung
   Kontext "TabAusrichtung"
'/// Change the Textdirection box to vertical (it is the push button in the 'Text direction' section).
    Gestapelt.Click
    sleep(1)
    if VertikaleAusrichtung.IsEnabled then
'/// Now you are able to tag the <i>Use Asian vertical layout mode</i>, so do this
      VertikaleAusrichtung.Check
      printlog "Vertical writing enabled."
     else
      warnlog "Vertical writing checkbox is not enabled!?"
    end if
'/// and close the format cells dialog with OK.
    TabAusrichtung.OK    
'/// Select one cell out of the previously selected range and type in some characters. They must appear rotated 90 degrees to the right.
   Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<MOD1 HOME>"
    DocumentCalc.TypeKeys "This is a vertical direction test."
    DocumentCalc.TypeKeys "<MOD1 RETURN>"
    DocumentCalc.TypeKeys "And this is a soft breaked second sentence."
    DocumentCalc.TypeKeys "<RETURN>"      
'/// Now select the cells behind and set some formattings...
    DocumentCalc.TypeKeys "<UP><RIGHT>"
'/// Background color
   Kontext "OL_SC_TABELLE"
    Hintergrundfarbe.Click
    sleep(1)
   Kontext "TB_Farbe"
    TB_Farbe.TypeKeys "<DOWN>" , 4
    sleep(1)
    TB_Farbe.Close            
'/// Text colour
   Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<LEFT>"
   Kontext "OL_SC_TABELLE"
    Schriftfarbe.Click
    sleep(1)
   Kontext "TB_Farbe"
    TB_Farbe.TypeKeys "<DOWN>" , 4
    sleep(1)
    TB_Farbe.Close
    sleep(1)                    
'/// Borders
   warnlog "BugId: 102575"
   Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<RIGHT>" , 2
'   Kontext "OL_SC_TABELLE"
'    Umrandung.Click
    FormatCells
    sleep(1)
   Kontext   
    Active.SetPage "TB_Umrandung"
   Kontext "TB_Umrandung"
'    TB_Umrandung.TypeKeys "<DOWN>" , 3
    Vorgaben.TypeKeys "<HOME>"
    Vorgaben.TypeKeys "<RIGHT>"
    TB_Umrandung.OK
'/// Font size
   Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<RIGHT>"
    DocumentCalc.TypeKeys "This is another vertical direction test."
   Kontext "OL_SC_TABELLE"
    Schriftgroesse.Select "14"    
'/// Allignment
   Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<HOME>"
    DocumentCalc.TypeKeys "<DOWN>"
'/// <ol><li>centered</li>    
    DocumentCalc.TypeKeys "centered"    
   Kontext "OL_SC_TABELLE"
'    .Click 
'/// <li>right</li>    
    DocumentCalc.TypeKeys "right"    
   Kontext "OL_SC_TABELLE"
'    .Click
'/// <li>justified</li>    
    DocumentCalc.TypeKeys "justified"    
   Kontext "OL_SC_TABELLE"
'    .Click 
    
    
'/// Fonteffects
   Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<RIGHT>" , 2
   Kontext "OL_SC_TABELLE"
'    .Click    
    
'/// Select one cell out of the previously selected range and type in some characters. 
'/// Now select the cell and switch to the Edit mode. 
'/// Perform some formattings on different characters (Text colour, Font height, Font and Fonteffects). 
'/// Also type a short text into a different cell out of the previously formatted cell range and check the line break function from the textflow box in the format cells dialog. 
'/// The manual line break function (CTRL + RETURN) must also be checked.
'/// [If Asian Office]
'///+ Do the same as above described for Asian Characters. 
'/// Now save the file to Calc6. 
'/// <h3>Searching for:</h3>
'///+ <ul><li><i>style:glyph-orientation-vertical</i></li></ul>.
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tNativeNumberTransliteration
'TODO: Create the test tNativeNumberTransliteration 
'/// <h2>Native Number transliteration stored in Calc6</h2>
'/// <h3>Searching for:</h3>
'/// <ul><li><i>number:transliteration-format</i></li>
'///+ <li><i>number:transliteration-language</i></li>
'///+ <li><i>number:transliteration-country</i></li>
'///+ <li><i>number:transliteration-style</i></li></ul>
endcase
