'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: xmltool1.inc,v $
'*
'*  $Revision: 1.7 $
'*
'*  last change: $Author: tbo $ $Date: 2005/09/07 19:28:17 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : XML Tools
'*
'***************************************************************************************
'*
' #1 CreateWorkXMLExportDir
' #1 hEnablePrettyPrinting
'*
'\***********************************************************************************
sub CreateWorkXMLExportDir ( DirName as string )
'/*** <i>CreateWorkXMLExportDir</i> creates in the StarOffice/work-
'/*** +directory a directory. If the same name exists the content (files only)
'/*** +will be deleted.
 Dim OutputPath as string
 Dim Isliste(200) as string
 Dim i, BornToKill
 printlog "Checking work-dir & creating '" & gOfficePath & ConvertPath(DirName) & "'."
  if hDirectoryExists ( gOfficePath & ConvertPath(DirName) ) = TRUE then
    OutputPath = gOfficePath & ConvertPath(DirName)
    IsListe(0) = 0
    GetFileList ( OutputPath ,  "*", IsListe() )
    BornToKill = KillFileList ( IsListe() )
     for i = 1 to BornToKill
      warnlog IsListe(i) & " could not be deleted!"
     next i
   else
    app.mkDir( gOfficePath & ConvertPath(DirName))
  end if
end sub
'-------------------------------------------------------------------------
sub hEnablePrettyPrinting (OPTIONAL A)
'/// <i>hEnablePrettyPrinting</i> enables the pretty printing (=better
'/// +formated view) in XML file export. It takes >10 percent more time
'/// +to save files!!! OPTIONAL parameter is used to DISABLE it.
 ToolsOptions
 Kontext "ExtrasOptionenDLG"
  call hToolsOptions("loadsave","general")
 Kontext "TabSpeichern"
   if IsMissing(A) then
    if NoPrettyPrinting.IsChecked = TRUE then
     NoPrettyPrinting.Uncheck
     sleep(1)
     printlog "- XML pretty printing enabled ( xmltool1.inc )"
    end if
   else
    if NoPrettyPrinting.IsChecked = FALSE then
     NoPrettyPrinting.Check
     sleep(1)
     printlog "- XML pretty printing disabled ( xmltool1.inc )"
    end if
  end if
 Kontext "ExtrasOptionenDLG"
  ExtrasOptionenDLG.OK
end sub
'-------------------------------------------------------------------------

